require({cache:{
'url:dojoe/gauge/statusgauge/templates/StatusGauge.html':"<div id=\"${id}_statusGauge\">\r\n\t<table role=\"presentation\" align=\"center\" style='table-layout:fixed' data-dojo-attach-point=\"table\" cellpadding=\"0px\" cellspacing=\"0px\">\r\n\t\t<tr>\r\n\t\t\t<td colspan=\"2\" data-dojo-attach-point=\"topLabelTD\" style=\"padding: 0px\">\r\n\t\t\t\t<div tabindex=\"0\" class=\"dojoxEllipsis\" id=\"${id}_topLabel\" data-dojo-attach-point=\"topLabelDiv\" align=\"center\" style=\"text-overflow: ellipsis\">\r\n\t\t\t\t</div>\r\n\t\t\t</td>\t\r\n\t\t</tr>\r\n\t\t<tr>\r\n\t\t\t<td data-dojo-attach-point=\"leftLabelTD\" style=\"padding: 0px\">\r\n\t\t\t\t<div tabindex=\"0\" class=\"dojoxEllipsis\" id=\"${id}_leftLabel\" data-dojo-attach-point=\"leftLabelDiv\" style=\"text-overflow: ellipsis;text-align:right\">\t\r\n\t\t\t\t</div>\r\n\t\t\t</td>\r\n\t\t\t<td data-dojo-attach-point=\"statusGaugeTD\" style=\"padding: 0px\">\r\n\t\t\t\t<div tabindex=\"0\" id=\"${id}_statusGaugeDiv\" data-dojo-attach-point=\"statusGaugeDiv\" style=\"align:left\" >\r\n\t\t\t\t</div>\r\n\t\t\t</td>\r\n\t\t</tr>\r\n\t</table>\r\n</div>"}});
/*********************************************************** {COPYRIGHT-TOP} ***
* Licensed Materials - Property of IBM
* Tivoli Widget Library
*
* (C) Copyright IBM Corp. 2014.  All Rights Reserved.
*
* US Government Users Restricted Rights - Use, duplication, or
* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
************************************************************ {COPYRIGHT-END} **/

define("dojoe/gauge/statusgauge/StatusGauge", [
	"dojo/_base/declare",
	"dojo/_base/array",
	"dijit/_WidgetBase",
	"dijit/_TemplatedMixin",
	"dojo/text!./templates/StatusGauge.html",
	"dojo/_base/connect",
	"dojoe/BidiUtil",
	"ibm/tivoli/navmodel/Dataset",
	"dijit/Tooltip",
	"dojo/i18n!./../common/nls/Gauge",
	"dojo/colors"
],function(declare, array, _WidgetBase, _TemplatedMixin, template, connect, bidiUtil, Dataset, Tooltip, nlsBundle, colors) {
	return declare("dojoe.gauge.statusgauge.StatusGauge", [_WidgetBase, _TemplatedMixin], {
	
	templateString: template,
    width: 100,
    height: 100,
	topLabel:"",
	leftLabel:"",
	itemId:null,
	datasetInfo: null,
	_leftshift:0,
	_topshift:0,
	_s:1,
	thresholds: null,
	_labelRatio : 0.25,
	_size:0,
	_supportedStatuses:["informational","normal","minor","major","critical","fatal","undefined","unknown"],
	nls:nlsBundle,
	defaultStatus: "Unknown", //Holds a default state to be displayed when dataset is empty.
	errorStatus: "Unknown", //Holds a default state to be displayed when dataset is in error.
	_resizing: false, // while resizing,  this flag will be enabled. Prevents overwriting of tooltip from DASH portlet error state.
	
	// value: String
	//		Font Size of the labels
	fontSize:"",
		
	// value: String
	//		Font Family of the labels
	fontFamily:"",
	
	// value: String
	//		Font Color of the labels
	fontColor:"",
	
	constructor: function(args){
		this.min = 0;
		this.max = 100;
        dojo.mixin(this, args);
	},
    
	postCreate: function() {
		if(this.fontFamily !== "") {
				this.leftLabelDiv.style.fontFamily = this.fontFamily; 
				this.topLabelDiv.style.fontFamily = this.fontFamily;
			}
			
			if(this.fontSize !== "") {
				this.leftLabelDiv.style.fontSize = this.fontSize; 
				this.topLabelDiv.style.fontSize = this.fontSize;
				switch(this.fontSize) {
					case "xx-small":
					case "x-small":
					case "small":
						this.topLabelDiv.style.paddingBottom = "2px";
						break;
					case "medium":
						this.topLabelDiv.style.paddingBottom = "4px";
						break;
					case "xx-large":
					case "x-large":
					case "large":
						this.topLabelDiv.style.paddingBottom = "6px";
						break;
				}
			}
			
			if(this.fontColor != "" && this.fontColor !== "Default") {
				this.fontColor = this.fontColor.replace(/\s+/g, '');
				this.leftLabelDiv.style.color = dojo.colorFromString(this.fontColor).toHex(); 
				this.topLabelDiv.style.color = dojo.colorFromString(this.fontColor).toHex();
			}
	},
	
    startup: function(){
		this.draw();
		var leftLabelTooltip = dojo.hitch( this, this._showTooltip, "left" ); 			
		var topLabelTooltip = dojo.hitch( this, this._showTooltip, "top" ); 			
		this.connect(this.leftLabelDiv, "onclick", this, leftLabelTooltip);
		this.connect(this.topLabelDiv, "onclick", this, topLabelTooltip);
		dojo.attr(this.statusGaugeDiv, "role", "button");
    },
    
	_showTooltip : function(arg) {
		var node;
		if(arg == "left"){
			node = this.leftLabelDiv;
			Tooltip.show(this.leftLabel, node, ['above-centered','below-centered','after']);
		} else {
			node = this.topLabelDiv;
			Tooltip.show(this.topLabel, node, ['above-centered','below-centered','after']);
		}			
		setTimeout(function(){
			Tooltip.hide(node);
		}, 2000);
	},
		
    setValue: function(v){
	      /*if(v != "undefined" && v.getValue){
			this.value = v.getValue();
	        } else	{
			this.value = v;
		}*/
		this.value = v;
        this.draw();
    },
	
	getValue: function(){
        return this.value;
    },
    
    setLabelAndValue: function(topLabel, leftLabel, value){
    	if(topLabel !== undefined && topLabel !== null) this.topLabel = topLabel;
    	if(leftLabel !== undefined && leftLabel !== null) this.leftLabel = leftLabel;
		this.setValue(value);
    },
	   
    draw: function(){
		if(this.leftLabel !== undefined && this.leftLabel !== null && this.leftLabel !== "") {
			this._labelRatio = 0.25;
			this.leftLabelDiv.innerHTML = this.leftLabel;
			this.leftLabelDiv.title = this.leftLabel;
			this.leftLabelDiv.style.direction = bidiUtil.getResolvedDir(this.leftLabel, this.textDir, this.dir);
			if (this.dir == "rtl"){
				this.leftLabelDiv.style.textAlign = "left";
				this.leftLabelDiv.style.marginLeft="8px";
			} else {
				this.leftLabelDiv.style.textAlign = "right";
				this.leftLabelDiv.style.marginRight="8px";
			}
		} else {
			this._labelRatio = 0;
			this.leftLabelDiv.innerHTML = "";
			this.leftLabelDiv.title = "";
		}
		this.leftLabelTD.style.width = (this.width * this._labelRatio) + "px";
		//if((this.width * this._labelRatio-4) > -1)
		this.leftLabelDiv.style.width=(this.width * this._labelRatio) + "px"; 
		
		if(this.topLabel !== undefined && this.topLabel !== null && this.topLabel !== "") {
			this.topLabelDiv.innerHTML = this.topLabel;
			this.topLabelDiv.title = this.topLabel;
			this.topLabelDiv.style.direction = bidiUtil.getResolvedDir(this.topLabel, this.textDir, this.dir);
			if (this.dir == "rtl"){
				this.topLabelDiv.style.marginRight = this.leftLabelDiv.clientWidth + "px";
				this.topLabelDiv.style.marginLeft = "0px";
			} else {
				this.topLabelDiv.style.marginLeft = this.leftLabelDiv.clientWidth + "px";
				this.topLabelDiv.style.marginRight = "0px";
			}
		} else {
			this.topLabelDiv.innerHTML = "";
			this.topLabelDiv.title = "";
		}
		var diffH = (this.width * this._labelRatio) + 14;
		var diffV = this.topLabelTD.offsetHeight + 4;
		var min = (this.width - diffH) < (this.height - diffV) ? (this.width - diffH) : (this.height - diffV);
		if(dojo.isChrome) // only chrome behaves in a weird way. Gives a scroll bar even if enough space is present.
			min = min - 11;
		//var min = (this.width - diffH - 8) < (this.height - diffV) ? (this.width - diffH - 8) : (this.height - diffV);
		var img = this._getStatusImage();
		if(img === undefined)
			return;
		if(dojo.isIE === undefined && dojo.isSafari === undefined) {
			//50317 : StatusGauge: onlick doesn't respond on SVG image
			// Hack to get onClick event work on the the SVG image. 
			//Image is overlayed with higher zIndex div which can absorb the onclick event.
			if(this._labelRatio == 0) {
				this.statusGaugeDiv.innerHTML = '<embed src=' + img + ' type="image/svg+xml" style="width:' + min + 'px;height:' + min + 'px; display:block; margin-left:auto; margin-right:auto"/>' +'<div style="width:' + min + 'px;height:' + min + 'px; top:-'+ min+  'px;position: relative; z-index: 1; display:block; margin-left:auto; margin-right:auto"/>';
				this.topLabelDiv.style.width = this.width - 2 + "px";
			} else {
				this.statusGaugeDiv.innerHTML = '<embed src=' + img + ' type="image/svg+xml" style="width:' + min + 'px;height:' + min + 'px"/>' +'<div style="width:' + min + 'px;height:' + min + 'px; top:-'+ min+  'px;position: relative; z-index: 1"/>';
				this.topLabelDiv.style.width = min + "px";	
			}
			this.statusGaugeDiv.style.height = min + "px";
			this.statusGaugeDiv.style.overflow = "hidden";
		} else {
			if(this._labelRatio == 0) {
				this.statusGaugeDiv.innerHTML = '<img src=' + img + ' style="width:' + min + 'px;height:' + min + 'px; display:block; margin-left:auto; margin-right:auto"/>';
				this.topLabelDiv.style.width = this.width - 2 + "px";
			} else {
				this.statusGaugeDiv.innerHTML = '<img src=' + img + ' style="width:' + min + 'px;height:' + min + 'px"/>';
				this.topLabelDiv.style.width = min + "px";	
			}
		}	
    },

    resize: function(size){
		var px = size.available.w;
		var py = size.available.h;
    	if(px == this.width && py == this.height) { // same dimensions, no need to repaint.
    		return;
    	}
		this._resizing = true;
		this.width = px;
		this.height = py;
		this.draw();
    },
	
    _getStatusImage: function(){
		var s;
		var ext;
		var image;
		var imageFound = true;
		//if(this.value && this.value.getValueType() == "status") {
		if(this.value && typeof(this.value.getValue) != "undefined") {
			image = this.value.getImage();	
			var scalarImage = this.value.getScalarImage();		
			scalarImage = scalarImage.substr(scalarImage.lastIndexOf("_") + 1);
			scalarImage = scalarImage.substr(0, (scalarImage.length - 4));
			if(scalarImage == "warning" || scalarImage == "WarningMinor" || scalarImage=="warning_minor")
				scalarImage="minor";
			else if(scalarImage == "WarningMajor" || scalarImage=="warning_major") 
				scalarImage="major";
				
			if(array.indexOf(this._supportedStatuses, scalarImage) > -1) {
				s={};
				s["status"]=scalarImage;
			} else {
				if(image && image.indexOf('[widget]') > -1){
					image = image.replace('[widget]', "ibm/tivoli/tip/navwidget/themes");
					image = require.toUrl(image);
					imageFound = false;
				}	
			}
			//_supportedStatuses
		} else {
			s = this.getThresholdFromValue(this.value, this.thresholds);
		}	
		if(!this._resizing) // set the tooltip only when setValue is called. DASH may call resize after an error has occurred.
			this.statusGaugeDiv.title = dojo.string.substitute(this.nls.GAUGE_STATUS, { 0: this.getTranslatedName(s.status)});
		else
			this._resizing = false;
		
		if(!imageFound)
			return image;
		ext = ".png";
		console.log("dojo.isIE - " + dojo.isIE);
		if(dojo.isIE === undefined)
			ext = ".svg";
		// images are symmetric, need nt be inverted. 'Normal' img is not(symmetric) but displayed in same way in rtl languages
        /*if (this.dir == "rtl"){
        	return dojo.moduleUrl("dojoe.statusgauge.StatusStyle", s.status.toLowerCase() + '_rtl' + ext);
        }*/
        return dojo.moduleUrl("dojoe.gauge.statusgauge.StatusStyle", s.status.toLowerCase() + ext);
    },
    
    getThresholdFromValue: function(value, thresholds){
        // summary:
        //          Returns the threshold from the sorted array that the value 
        //          resides within.
        // value: Number
        //          Value to find the threshold for.
        // thresholds: Array
        //          Sorted array of thresholds, sorted by their "start" 
        //          attribute.
        // returns:
        //          The threshold from the array where the value resides, or 
        //          thresholds[0] if can't find it anywhere...
        
    	// 39974: Status Gauge - If the value is set to 0, gauge doesn't reflect the correct threshold and moves to 'unknown' state
        // value == 0 is treated as false by JS. isNaN(null) is false hence can't move to switch statement below!
		//if(!value)
		if(value === undefined || value === null)
			return {name: this.nls.GAUGE_STATUS_UNKNOWN, status: "Unknown", start: 0};
		
		if(isNaN(value)) {
			switch(value) {
				case "Normal":
					return {name: this.nls.GAUGE_STATUS_NORMAL, status: "Normal", start: 0};
				case "Unknown":
					return {name: this.nls.GAUGE_STATUS_UNKNOWN, status: "Unknown", start: 0};
				case "Minor":
					return {name: this.nls.GAUGE_STATUS_Minor, status: "Minor", start: 0};
				case "Major":
					return {name: this.nls.GAUGE_STATUS_Major, status: "Major", start: 0};
				case "Critical":
					return {name: this.nls.GAUGE_STATUS_Critical, status: "Critical", start: 0};
				case "Fatal":
					return {name: this.nls.GAUGE_STATUS_FATAL, status: "Fatal", start: 0};
				case "Informational":
					return {name: this.nls.GAUGE_STATUS_INFORMATIONAL, status: "Informational", start: 0};
				default:
					return {name: this.nls.GAUGE_STATUS_UNKNOWN, status: "Unknown", start: 0};
			};
		}
			
        if (thresholds.length==0) 
              return {name: this.nls.GAUGE_STATUS_UNKNOWN, status: "Unknown", start: 0};

		if(this.value !== undefined && this.value.getValue)
				value = this.value.getValue();
				
		for(var i = 0, len = thresholds.length; i < len; i++){
            if(i == len-1){
                if(value < thresholds[i].start){
                    return thresholds[0];
                } else {
                    return thresholds[i];
                }
            }
            if(value >= thresholds[i].start && value < thresholds[i+1].start){
                return thresholds[i];
            }
        }

		return thresholds[0];
    },
    
	getTranslatedName: function(status) {
		switch(status) {
				case "Normal": case "normal":
					return this.nls.GAUGE_STATUS_NORMAL;
				case "Unknown": case "unknown":
					return this.nls.GAUGE_STATUS_UNKNOWN;
				case "Minor": case "minor":
					return this.nls.GAUGE_STATUS_Minor;
				case "Major": case "major":
					return this.nls.GAUGE_STATUS_Major;
				case "Critical": case "critical":
					return this.nls.GAUGE_STATUS_Critical;
				case "Fatal": case "fatal":
					return this.nls.GAUGE_STATUS_FATAL;
				case "Informational": case "informational":
					return this.nls.GAUGE_STATUS_INFORMATIONAL;
				default:
					return this.nls.GAUGE_STATUS_UNKNOWN;
			};
	},
	
    clearLabels: function() {
		this.leftLabelDiv.innerHTML = "";
		this.topLabelDiv.innerHTML = "";
		this.leftLabel = "";
		this.topLabel = "";
	},
    
    destroy: function(){
		// summary:
		//          Called when the widget is destroyed by dojo, used to clean 
		//          up memory before disassociating the widget from the dom.
		
		this.topLabel= null;
		this.leftLabel=null;
		this.value=null;
		this.inherited(arguments);
	}
	
});
});
