// wrapped by build app
define("dojoe/gauge/valuestatus/ValueStatusStyle", ["dijit","dojo","dojox","dojo/require!dojo/fx,dojo/fx/easing,dojoe/gauge/common/_Style,dojoe/gauge/common/AbstractGauge"], function(dijit,dojo,dojox){
/*********************************************************** {COPYRIGHT-TOP} ***
* Licensed Materials - Property of IBM
* Tivoli Widget Library
*
* (C) Copyright IBM Corp. 2014.  All Rights Reserved.
*
* US Government Users Restricted Rights - Use, duplication, or
* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
************************************************************ {COPYRIGHT-END} **/
dojo.provide("dojoe.gauge.valuestatus.ValueStatusStyle");

dojo.require("dojo.fx");
dojo.require("dojo.fx.easing");
dojo.require("dojoe.gauge.common._Style");
dojo.require("dojoe.gauge.common.AbstractGauge");


dojo.declare("dojoe.gauge.valuestatus.ValueStatusStyle", [dojoe.gauge.common._Style], {
	_height:62,
	_width:62,
//	Richa:30Oct12:#55230 , the fonts were not coming as expected in some IE browsers.
//	Adding more approved fonts to the family.
//	textFont: {family: 'Arial',weight:'bold'},
	textFont: {family: 'Arial,Helvetica,Verdana,sans-serif',weight:'bold'},
	textColor: "#f5f5f5",
	_textX:0,
	_textY:0,
	_textSize:50,
	_scaler:1,
	_backImage: "",
	_currentStatus: "",
	
    constructor: function(args){
		dojo.mixin(this, args);
	},

	/**
	 * private function compute
	 */
    _computeSizing: function(state){
				
		var thres = this.getThresholdFromValue(state.endValue, state.thresholds);
		var status = thres.status;
		this._currentStatus = thres.name;
		if(isNaN(state.endValue))
			state.endValue = "-";
		var textLength = (state.endValue + "").length;
		
		if(status == "Not Applicable"){
			if(state.height>state.width*0.5688){
				this._width = state.width;
				this._height = (state.width*0.5688);
			}
			else{
				this._width = (state.height/0.5688);
				this._height = state.height;
			}
		}
		else{
			if(state.width>state.height){
				this._width = state.height;
				this._height = state.height;
			}
			else{
				this._width = state.width;
				this._height = state.width;
			}
		}		
		
		//compute the background image, number position/style
		if(status == "Clear"){
			this._backImage = "simple_clear.png";
			this._textX=0;
			this._textY=this._height*0.2;
			this._textSize = 50;
			if(textLength > 2){
				this._textSize *= (2/textLength);
				var rate = (this._textSize - 10) / 2.0 / 100.0;
				this._textY = this._height * rate;
			}
		}
		else if(status == "Normal"){
			this._backImage = "simple_normal.png";
			this._textX=0;
			this._textY=this._height*0.2;
			this._textSize = 50;
			if(textLength > 2){
				this._textSize *= (2/textLength);
				var rate = (this._textSize - 10) / 2.0 / 100.0;
				this._textY = this._height * rate;
			}
		}
		else if(status == "Critical"){
			this._backImage = "simple_critical.png";
			this._textX=0;
			this._textY=this._height*0.2;
			this._textSize = 50;
			if(textLength > 2){
				this._textSize *= (2/textLength);
				var rate = (this._textSize) / 2.0 / 100.0;
				this._textY = this._height * rate;
			}
		}
		else if(status == "Fatal"){
			this._backImage = "simple_fatal.png";
			this._textX=0;
			this._textY=this._height*0.2;
			this._textSize = 50;
			if(textLength > 2){
				this._textSize *= (2/textLength);
				var rate = (this._textSize) / 2.0 / 100.0;
				this._textY = this._height * rate;
			}
		}
		else if(status == "Major"){
			this._backImage = "simple_major.png";
			this._textX=0;
			this._textY=this._height*0.001;
			this._textSize = 40;
			if(textLength > 2){
				this._textSize *= (2/textLength);
				this._textY =  - this._height * (40 - this._textSize) / 100.0;
			}
		}
		else if(status == "Minor"){
			this._backImage = "simple_minor.png";
			this._textX=0;
			this._textY=this._height*0.3;
			this._textSize = 40;
			if(textLength > 2){
				this._textSize *= (2/textLength);
				//this._textY = this._height * (this._textSize * 35.0 / 45.0 / 100.0);
				this._textY = this._height * 40 / 100.0;
			}
		}
		else if(status == "Indeterminant"){
			this._backImage = "simple_indeterminant.png";
			this._textX=0;
			this._textY=this._height*0.15;
			this._textSize = 45;
			if(textLength > 2){
				this._textSize *= (2/textLength);
				//this._textY = this._height * (this._textSize * 15.0 / 45.0 / 100.0);
				this._textY = this._height * (this._textSize / 3.0 / 100.0);
			}
		}
		else if(status == "Not Applicable"){
			this._backImage = "simple_not_applicable.png";
			this._textX=0;
			this._textY=this._height * 0.15;
			this._textSize = 30;
			if(textLength > 2){
				this._textSize *= (2/textLength);
				this._textY = this._height * (this._textSize * 2 / 4.0 / 100.0);
			}
		}
		else if(status == "Unknown"){
			this._backImage = "simple_unknown.png";
			this._textX=0;
			this._textY=this._height*0.15;
			this._textSize = 45;
			if(textLength > 2){
				this._textSize *= (2/textLength);
				this._textY = this._height * (this._textSize / 3.0 / 100.0);
			}
		}
		else if(status == "Undefined" || status == ""){
			this._backImage = "simple_undefined.png";
			this._textX=0;
			this._textY=this._height*0.15;
			this._textSize = 45;
			if(textLength > 2){
				this._textSize *= (2/textLength);
				this._textY = this._height * (this._textSize / 3.0 / 100.0);
			}
		}
		else if(status == "Informational"){
			this._backImage = "simple_informational.png";
			this._textX=0;
			this._textY=this._height*0.2;
			this._textSize = 50;
			if(textLength > 2){
				this._textSize *= (2/textLength);
				var rate = (this._textSize - 10) / 2.0 / 100.0;
				this._textY = this._height * rate;
			}
		}
		
		//compute scaler
		if(state.width>state.height){
			this._scaler = 100.0/state.height;
		}
		else{
			this._scaler = 100.0/state.width;
		}

    },
	
    getDrawOrder: function(){
        if(this.getValueVisible()){
    		return ["drawBackground",  "drawForeground", "drawValue"];
    	}
	
        return ["drawBackground",  "drawForeground"];
	},
    
    getDrawSemantics: function(){
        var textFunc=[];
		var updateValueFunc = ["drawBackground", "drawForeground"];
		if(this.getValueVisible()){
			textFunc = "drawValue";
			updateValueFunc.push("drawValue");
    	}
        return {
            background: "drawBackground",
            foreground: "drawForeground",
			text: textFunc,
            updateValue: updateValueFunc
        };
    },
	
	_backGroup: null,
	drawBackground: function(state){
		if (this._backGroup == null){
           this._backGroup = state.group.createGroup();
        }
		this._computeSizing(state);
		
		var cx = this._width*0.5;
        var cy = this._height*0.5;
		
		var bgShape = {
			x: -cx, y: -cy,
			width: this._width, height: this._height,
			src: dojo.moduleUrl("dojoe.gauge.valuestatus.ValueStatusStyle", this._backImage)
		};
		var background = this._backGroup.children[0];
		if(!background){
			background = this._backGroup.createImage(bgShape);
		}else{
			background.setShape(bgShape);
		}
		this._backGroup.setTransform({xx: this._scaler, yy: this._scaler, dx:0, dy:0});
		return this._backGroup;
		
	},
	
    _foreGroup: null,
    drawForeground: function(state){
    },

	
	/**
     *  draw label and value
     */
    _valueGroup: null,
    drawValue: function(state){
		if (this._valueGroup == null) {
			this._valueGroup = state.group.createGroup();
		}
		
		if(isNaN(state.endValue))
			state.endValue = "-";
		 
		var valueShape ={
			x: this._textX,
			y: this._textY,
			text: state.endValue,
			align: "middle",
			textDir: this.getGfxTextDir()
		};
		/*if(this._valueGroup && this._valueGroup.children){
			for(var i=0;i<this._valueGroup.children.length;++i){
				this._valueGroup.children[i] = null;
			}		
		} */
		var value = this._valueGroup.children[0];
		if (!value){
			value = this._valueGroup.createText(valueShape);//.setFill(this.textColor);
		}else{
			value.setShape(valueShape);
		}
		value.setFill(this.textColor);
        this.textFont.size= this._textSize * this._width / 100 + "px";
       
		
		value.setFont(this.textFont);
		//value.setStroke({color:"#c0c0c0",width:1});
		value.setStroke({color:"#61671d",width:1});
        if (this.orient=='rtl') 
        	value.setTransform(dojox.gfx.matrix.flipX);

		this._valueGroup.setTransform({xx: this._scaler, yy: this._scaler, dx:0, dy:0});
		return this._valueGroup;
		
	},

	getStatus: function(){
		return this._currentStatus; // eg : simple_unknown.png
	},
	
    _destroyContent:function(g){
		if(g.children){
			for(var i=0;i<g.children.length;++i){
				var s = g.children[i];
				//dojox.gfx.shape.dispose(s);
				if(s && s.children){
					this._destroyContent(s);
				}
				s.destroy();
			}
			//g.clear();
		}
		g.clear();
	},
    reset: function(){
        // summary:
        //          Deletes any locally-stored shape objects when the gauge 
        //          needs to be reset.
		if(this._valueGroup)
			this._destroyContent(this._valueGroup);
		if(this._backGroup)
			this._destroyContent(this._backGroup);

		delete this._backGroup;
        delete this._foreGroup;
		delete this._valueGroup;

        this._backGroup=null;
        this._foreGroup=null;
		this._valueGroup=null; 
    }
});

});
