require({cache:{
'url:dojoe/gauge/volumebar/templates/VolumeBar.html':"<div id=\"${id}_volumeBar\">\r\n\t<table role=\"presentation\" style='table-layout:fixed' data-dojo-attach-point=\"table\" cellpadding=\"0px\" cellspacing=\"0px\">\r\n\t\t<tr>\r\n\t\t\t<td colspan=\"3\" data-dojo-attach-point=\"topLabelTD\" style=\"padding: 0px\">\r\n\t\t\t\t<div tabindex=\"0\" class=\"dojoxEllipsis\" id=\"${id}_topLabel\" data-dojo-attach-point=\"topLabelDiv\" align=\"left\" style=\"text-overflow: ellipsis\">\r\n\t\t\t\t</div>\r\n\t\t\t</td>\t\r\n\t\t</tr>\r\n\t\t<tr>\r\n\t\t\t<td data-dojo-attach-point=\"leftLabelTD\" style=\"padding: 0px\">\r\n\t\t\t\t<div tabindex=\"0\" class=\"dojoxEllipsis\" id=\"${id}_leftLabel\" data-dojo-attach-point=\"leftLabelDiv\" style=\"text-overflow: ellipsis;text-align:right\">\t\r\n\t\t\t\t</div>\r\n\t\t\t</td>\r\n\t\t\t<td data-dojo-attach-point=\"volumeBarTD\" style=\"padding: 0px\">\r\n\t\t\t\t<div id=\"${id}_volumeBarDiv\" data-dojo-attach-point=\"volumeBarDiv\" style=\"align:left\" >\r\n\t\t\t\t</div>\r\n\t\t\t</td>\r\n\t\t\t<td data-dojo-attach-point=\"volumeBarValueTD\" style=\"padding: 0px\">\r\n\t\t\t\t<div tabindex=\"0\" id=\"${id}_volumeBarValue\" class=\"dojoxEllipsis\" data-dojo-attach-point=\"volumeBarValue\" style=\"align:left;font-weight:bold\" >\r\n\t\t\t\t</div>\r\n\t\t\t\t<div tabindex=\"0\" id=\"${id}_volumeBarWarning\" class=\"dojoxEllipsis\" data-dojo-attach-point=\"volumeBarWarning\" style=\"align:left;font-weight:bold\" >\r\n\t\t\t\t</div>\r\n\t\t\t</td>\r\n\t\t</tr>\r\n\t</table>\r\n</div>"}});
/*********************************************************** {COPYRIGHT-TOP} ***
* Licensed Materials - Property of IBM
* Tivoli Widget Library
*
* (C) Copyright IBM Corp. 2014.  All Rights Reserved.
*
* US Government Users Restricted Rights - Use, duplication, or
* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
************************************************************ {COPYRIGHT-END} **/
define("dojoe/gauge/volumebar/VolumeBar", [
	"dojo/_base/declare",
	"dojo/_base/connect",
	"dijit/_WidgetBase",
	"dijit/_TemplatedMixin",
	"dojo/text!./templates/VolumeBar.html",
	"dojoe/gauge/volumebar/VolumeBarStyle",
	"dojoe/gauge/common/AbstractGauge",
	"dojoe/BidiUtil",
	"dijit/Tooltip",
	"dojo/i18n!./../common/nls/Gauge",
	"dojo/dom-construct",
	"dojo/colors"
], function(declare, connect, _WidgetBase, _TemplatedMixin, template, VolumeBarStyle, AbstractGauge, bidiUtil, Tooltip, nlsBundle, domConstruct, colors) {
	return declare("dojoe.gauge.volumebar.VolumeBar", [_WidgetBase, _TemplatedMixin], {
		templateString: template,
		volumeBar:null,
		
		// width: number  
		//		Holds the width of the Analog Gauge. 
		width:120,
		
		// height: number  
		//		Holds the height of the Analog Gauge. 
		height:110,
		
		// topLabel: String  
		//		Holds the String/label to be displayed on top of the Analog Gauge
		topLabel:"",
		
		// leftLabel: String  
		//		Holds the String/label to be displayed on the leading edge the Analog Gauge
		leftLabel:"",
		
		// value: Numeric  
		//		Holds the numeric value which the Analog Gauge should represent.
		value:0,
		
		// value: Boolean  
		//		Holds a boolean value to indicate if the gauge is supposed to have a top label at any point
		topLabelPresent: false,
		
		// value: Boolean  
		//		Holds a boolean value to indicate if the gauge is supposed to have a leading edge label at any point
		leftLabelPresent: false,
		
		maxValue:100,
		
		minValue:0,
		
		_labelRatio:0.20,
		_size:0,
		_leftLabelWidth:0,
		_valueWidth:0,
		nls: nlsBundle,
		_addWarning: false,
		_defMin:0,
		_defMax:100,
		
		// value: String
		//		Font Size of the labels
		fontSize:"",
		
		// value: String
		//		Font Family of the labels
		fontFamily:"",
		
		// value: String
		//		Font Color of the labels
		fontColor:"",
		
		constructor: function() {
			dojo.mixin(this, arguments);
			
		},
		
		postCreate: function() {
			if(this.topLabelPresent) {
				this.topLabelDiv.innerHTML = ".";
			}
			
			if(this.fontFamily !== "") {
				this.leftLabelDiv.style.fontFamily = this.fontFamily; 
				this.topLabelDiv.style.fontFamily = this.fontFamily;
			}
			
			if(this.fontSize !== "") {
				this.leftLabelDiv.style.fontSize = this.fontSize; 
				this.topLabelDiv.style.fontSize = this.fontSize;
				switch(this.fontSize) {
					case "xx-small":
					case "x-small":
					case "small":
						this.topLabelDiv.style.paddingBottom = "2px";
						break;
					case "medium":
						this.topLabelDiv.style.paddingBottom = "4px";
						break;
					case "xx-large":
					case "x-large":
					case "large":
						this.topLabelDiv.style.paddingBottom = "6px";
						break;
				}
			}
			
			if(this.fontColor != "" && this.fontColor !== "Default") {
				this.fontColor = this.fontColor.replace(/\s+/g, '');
				this.leftLabelDiv.style.color = dojo.colorFromString(this.fontColor).toHex(); 
				this.topLabelDiv.style.color = dojo.colorFromString(this.fontColor).toHex();
			}
			
			if(this.leftLabelPresent) {
				console.info("this.leftLabelPresent : " + this.leftLabelPresent);
				console.log(this.domNode.clientWidth);
				this._labelRatio = 0.20;
				this.leftLabelTD.style.width = (this.domNode.offsetWidth * 0.20) + "px";
				this.leftLabelDiv.style.width= (this.domNode.offsetWidth * 0.20) + "px";
				if(this.leftLabel) {
					this.leftLabelDiv.innerHTML = this.leftLabel;
					this.leftLabelDiv.title = this.leftLabel;
				}
				if(this.dir == "rtl")
					this.leftLabelDiv.style.marginLeft="8px";
				else
					this.leftLabelDiv.style.marginRight="8px";
			} else
				this._labelRatio = 0;
		
			// 77580: [Dojo 10445] TBSM 3xxxx: Volume Bar: value clipped on right edge
			var valueWidth = (this.domNode.offsetWidth * 0.10)
			if(valueWidth < 32) {
				valueWidth = 32;
			}
			this.volumeBarValueTD.style.width = valueWidth + "px";
			this.volumeBarValue.style.width = valueWidth + "px";
			if(this.minValue == this.maxValue || this.minValue > this.maxValue) {
				this.volumeBar = new dojoe.gauge.common.AbstractGauge({minValue:this._defMin, maxValue:this._defMax, thresholds:this.thresholds, majorTickSeparation:this.majorTickSeparation, minorTickSeparation:this.minorTickSeparation, _currentValue:this._currentValue, dir:this.dir}, this.volumeBarDiv); //def58897
			} else
				this.volumeBar = new dojoe.gauge.common.AbstractGauge({minValue:this.minValue, maxValue:this.maxValue, thresholds:this.thresholds, majorTickSeparation:this.majorTickSeparation, minorTickSeparation:this.minorTickSeparation, _currentValue:this._currentValue, dir:this.dir}, this.volumeBarDiv); //def58897
			this.volumeBar.styler = new VolumeBarStyle();
			this.volumeBar.styler.majorTicksColor = this.majorTicksColor;
			this.volumeBar.styler.showThresholdStrip = this.showThresholdStrip;
			this.volumeBar.styler.orient = this.volumeBar.dir; //def58897
			this.volumeBar.startup();	
			this._textHeight = this.topLabelTD.clientHeight;
			this.topLabelDiv.innerHTML = "";
			if(this.topLabel) {
				this.topLabelDiv.innerHTML = this.topLabel;
				this.topLabelDiv.title = this.topLabel;
			}
			if(!this.leftLabelPresent) {
				this.volumeBar.domNode.style.margin = "auto";
			}
			var leftLabelTooltip = dojo.hitch( this, this._showTooltip, "left" ); 			
			var topLabelTooltip = dojo.hitch( this, this._showTooltip, "top" ); 		
			this.volumeBarValue.style.whiteSpace="nowrap";
			dojo.connect(this.leftLabelDiv, "onclick", this, leftLabelTooltip);
			dojo.connect(this.topLabelDiv, "onclick", this, topLabelTooltip);
			this.volumeBar.domNode.tabIndex = "0";
			
			this.topLabelDiv.style.textOverflow="ellipsis";
			this.leftLabelDiv.style.textOverflow="ellipsis";
			dojo.attr(this.volumeBar.domNode, "role", "button");		
			this.inherited(arguments);
		},
		

		startup: function() {
			console.log("VolumeBar.js startup");
			try{
				this.inherited(arguments);	
			}catch(err){
				console.debug(err);
			}			
			console.log("volumeBar.js startup ends");
		},
		
		_showTooltip : function(arg) {
			var node;
			if(arg == "left"){
				node = this.leftLabelDiv;
				Tooltip.show(this.leftLabel, node, ['above-centered','below-centered','after']);
			} else {
				node = this.topLabelDiv;
				Tooltip.show(this.topLabel, node, ['above-centered','below-centered','after']);
			}			
			setTimeout(function(){
				Tooltip.hide(node);
			}, 2000);
		},
		
		draw: function(surface){
			this.volumeBar.adjust(surface);
		},
		
		updateTicks: function(min, max) {
			if(min == null && max == null)
				return;
				
			if((this.minValue == min && this.maxValue == max))
				return;
			
			if((min || min == 0) && (max || max == 0) && (min > max || min == max)) {
				this._addWarning = true;
				this.minValue = this._defMin;
				this.maxValue = this._defMax;
				this.volumeBar.updateTicks(this._defMin, this._defMax);
			} else {
				if (min || min == 0)
					this.minValue = min;
					
				if(max || max == 0) {
					this.maxValue = max;
				}
				this._addWarning = false;
				this.volumeBar.updateTicks(this.minValue,this.maxValue);
			}
			if(this._addWarning)
				this.displayWarning(this.nls.GAUGE_WARN_MIN_GREATER_THAN_MAX);
			else
				this.removeWarning();
		},
		
		resize: function(size, force){
			// summary:  
			//		Resizes the Analog Gauge
			// sx: number
			//		 Ratio of original width and new width available
			// sy: number 
			//		Ratio of original Height and new height available
			// px: number 
			//		New width available
			// py: number 
			//		New height available
			// Do not add metric while specifying the numbers above
			// tags: public
			
			var px = size.available.w;
			var py = size.available.h;
			
			if(this.width == px && this.height == py) { // same dimensions, no need to resize again. For abnormal scrolls in chrome 
				return;												   // this method is called to remove them, sx condition is for that
			}
			
			this.leftLabelTD.style.width = (px * this._labelRatio) + "px";	
			this.leftLabelDiv.style.width = (px * this._labelRatio) + "px";
			this.width = px;
			this.height = py;
			
			this.volumeBarValueTD.style.width = (px * 0.10) + "px";
			this.volumeBarValue.style.width = (px * 0.10) + "px";

			var gfxWidth = px - this.leftLabelTD.clientWidth - this.volumeBarValueTD.clientWidth - 1;
			if(dojo.isChrome)
				gfxWidth = gfxWidth - 9;
			var gfxHeight = py - this._textHeight - 4;
			if(this.leftLabelPresent)
				gfxWidth = gfxWidth - 10;
		
			//this.volumeBarDiv.style.width = this._size + "px";
			this.volumeBarDiv.style.position = "relative";
			
			//77580: [Dojo 10445] TBSM 3xxxx: Volume Bar: value clipped on right edge
			if((px * 0.10) < 32) {
				this.volumeBarValueTD.style.width = "32px";
				this.volumeBarValue.style.width = "32px";
				gfxWidth = gfxWidth - (32 - (px * 0.10));
			}
			
			this.volumeBar._adjust({
				width:gfxWidth, 
				height:gfxHeight
			});		
			this.topLabelTD.style.width= gfxWidth + "px"; 			
			this.topLabelDiv.style.width= gfxWidth + "px"; 
			this.topLabelDiv.style.whiteSpace="nowrap"; 
			//this.leftLabelTD.style.height = this._size + "px";
			//this.topLabelDiv.style.marginLeft = this._leftLabelWidth + 4 + "px";
			if (this.dir == "rtl"){                                                                 //def58897
				this.topLabelDiv.style.marginRight = this.leftLabelDiv.offsetWidth + "px";       
				this.topLabelDiv.style.textAlign = "right";
			} else {                                                                                //def58897
				this.topLabelDiv.style.marginLeft = this.leftLabelDiv.offsetWidth + "px";
			}                                                                                       //def58897

			//this.table.style.marginTop = (py- this.table.offsetHeight)/2 + "px";
		},
		
		setLabelAndValue: function(topLabel, leftLabel, value) {
			// summary:  
			//		Sets labels and value for the Analog Gauge
			// topLabel: String
			//		 Label which appears at the TOP of the gauge
			// leftLabel: String 
			//		Label which appears on theleading edge of the gauge
			// value: Numeric 
			//		Numeric Value to be displayed on the gauge
			// tags: public
			/*if(topLabel && typeof(topLabel.getValueType) != "undefined" && topLabel.getValueType() == "status") {
				this.topLabel = topLabel.getValue().getValue();
			} else if(topLabel && typeof(topLabel.getValue) != "undefined") {
				this.topLabel = topLabel.getValue();
			} else
				this.topLabel = topLabel;
				
			if(leftLabel && typeof(leftLabel.getValueType) != "undefined" && leftLabel.getValueType()=="status")
				this.leftLabel = leftLabel.getValue().getValue();
			else if(leftLabel && typeof(leftLabel.getValue) != "undefined") {
				this.leftLabel = leftLabel.getValue();
			}else
				this.leftLabel = leftLabel;
			
			if(value && typeof(value.getValueType) != "undefined" && value.getValueType()=="status")
				this.value = value.getValue().getValue();
			else if(value && typeof(value.getValue) != "undefined") {
				this.value = value.getValue();
			}else
				this.value = value;*/
				
			if(topLabel != "undefined" && topLabel != null) {
				this.topLabelDiv.innerHTML = topLabel;
				this.topLabelDiv.title = topLabel;
				this.topLabel = topLabel;
			}
	    	if(leftLabel != "undefined" && leftLabel != null)  {
				this.leftLabelDiv.innerHTML = leftLabel;
				this.leftLabelDiv.title = leftLabel;
				this.leftLabel = leftLabel;
			}
			
	    	if(value && typeof value.getValue == 'function')
				value = value.getValue();
				
			this.setValue(value);	
			if (this.dir == "rtl"){                                                             
				this.topLabelDiv.style.marginRight = this.leftLabelDiv.offsetWidth + "px";      
				//this.topLabelDiv.style.marginLeft = "0px";           
				this.topLabelDiv.style.textAlign = "right";          
			} else {
				this.topLabelDiv.style.marginLeft = this.leftLabelDiv.offsetWidth + "px";
			}	
			//this._leftLabelWidth = (this.width * this._labelRatio);
			//this._valueWidth = this.volumeBarValueTD.clientWidth;
			//this.topLabelDiv.style.marginLeft = this._leftLabelWidth + 4 + "px";
			//this.topLabelDiv.style.marginLeft = this.leftLabelDiv.clientWidth + "px";
			// chrome is behaving a little weird here. Even if the width is specified properly
			// as seen in debugger it just shows scroll(which aren't needed). if you click on portlet
			// it sends resize event with same width and height and scroll disappears, hence below fix.
			if(dojo.isChrome) {
				this.volumeBar.adjust({
					width:this.width - this.leftLabelTD.offsetWidth - this.volumeBarValueTD.offsetWidth - 25,
					height:this.height - this.topLabelTD.offsetHeight - 1
				});
				var size = new Object();
				size.available = {w: this.width, h:this.height};
				this.resize(size);
			}
			//this.volumeBar.domNode.title = this.value + " " + this.volumeBar.styler.getStatus();
		},
		
		setValue: function(/*number*/ value){
			if(value && typeof value.getValue == 'function')
				value = value.getValue();
				
	    	if(value != "undefined" && value != null)this.value = value;
			
			if(value == null)
				value = this.volumeBar.errorStatus;
				
			this.volumeBar.setValue(value);
			this.volumeBarValue.title = value;
					
			// 80344: TWL 1.1.0.2 : [No Data Status] Analog Gauge/Volume Bar Values are not translated
			if(isNaN(value)) {
				this.volumeBarValue.innerHTML = this.volumeBar.styler.getStatus();
				this.volumeBar.domNode.title = dojo.string.substitute(this.nls.GAUGE_STATUS_RANGE, { 0: this.volumeBar.styler.getStatus(), 1: this.minValue, 2: this.maxValue});
			} else {
				this.volumeBarValue.innerHTML = value;
				this.volumeBar.domNode.title = dojo.string.substitute(this.nls.GAUGE_TOOLTIP, { 0: value , 1: this.volumeBar.styler.getStatus(), 2: this.minValue, 3: this.maxValue });			
			}
		},
	
		destroy: function(){
			// summary:
			//          Called when the widget is destroyed by dojo, used to clean 
			//          up memory before disassociating the widget from the dom.
			this.destroyWidgets();
			if(dojo.byId(this.id+"volumeBarDiv")) dojo.forEach(dijit.findWidgets(dojo.byId(this.id+"volumeBarDiv")), function(widget){
				// Avoid double destroy of widgets like Menu that are attached to body
				// even though they are logically children of other widgets.
				if(widget && !widget._destroyed){
					if(widget.destroyRecursive){
						widget.destroyRecursive();
					}else if(widget.destroy){
						widget.destroy();
					}
				}
			});	
			this.inherited(arguments);
		},
		
		displayWarning: function(message) {
			if(!this._warningAdded){
				var img = dojo.moduleUrl("dojoe.gauge.common.images", "warning.png");
				var n = domConstruct.create("div", { id:"warningImage", innerHTML: '<img src=' + img + ' title=\"'+ message + '\" />' },  this.volumeBarWarning);
				this._warningAdded = true;
			}
		},
		
		removeWarning: function() {
			if(this.volumeBarWarning)
				this.volumeBarWarning.innerHTML = "";
			this._warningAdded = false;
		},
		
		clearLabels: function() {
			this.leftLabelDiv.innerHTML = "";
			this.topLabelDiv.innerHTML = "";
		},
	
		destroyWidgets: function() {
			try{
				if(this.gauge){
					var listWidget = dojo.byId(this.gauge);
					if(listWidget.destroyRecursive) listWidget.destroyRecursive();
					else if(listWidget.destroy) listWidget.destroy();
				}	
				
			} catch (ex) {
				console.error ("volumeBar.js: Caught exception in destroy:");
				console.error (ex);
			}
		}
});
});
