// wrapped by build app
define("dojoe/gauge/volumebar/VolumeBarStyle", ["dijit","dojo","dojox","dojo/require!dojo/fx,dojo/fx/easing,dojoe/gauge/common/_Style,dojoe/gauge/common/AbstractGauge"], function(dijit,dojo,dojox){
/*********************************************************** {COPYRIGHT-TOP} ***
* Licensed Materials - Property of IBM
* Tivoli Widget Library
*
* (C) Copyright IBM Corp. 2014.  All Rights Reserved.
*
* US Government Users Restricted Rights - Use, duplication, or
* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
************************************************************ {COPYRIGHT-END} **/
dojo.provide("dojoe.gauge.volumebar.VolumeBarStyle");

dojo.require("dojo.fx");
dojo.require("dojo.fx.easing");
dojo.require("dojoe.gauge.common._Style");
dojo.require("dojoe.gauge.common.AbstractGauge"); // for the GaugeThreshold

dojo.declare("dojoe.gauge.volumebar.VolumeBarStyle", [dojoe.gauge.common._Style], {
        /**
	     * Set the display text size, if set to zero it computes the size.
		 */
    	fs: 0,

	   /**
        * font
        * maybe later used
        */
        font: {family: "Verdana", style: "normal", variant: 'small-caps', weight: 'bold', size:'11px'},
        fontv: {family: "Arial", style: "italic", variant: 'small-caps', weight: 'bold', size:'8px'},
        axisFont: {family: "Arial", style: "normal", variant: 'small-caps', weight: 'bold', size:'10px'},
        _fh: 8,
        _fhv:8,
		_padh: 0,
		_padw: 0,
		_topmargin: 0,

	   /**
       * for  filling your own color
       * fillcolor="'lime'"
       * fillcolor="{'type': 'linear',
       *                 'x1': 0,
       *                 'x2': 400,
       *                 'y2': 0,
       *                 'y1': 0,
       *                 'colors': [{offset: 0, color: '#0000FF'},{offset: 1, color: 'lime'}] }"
       *
       **/
        fillcolor: null,
        lines: true,
        values: true,
		_dispw: 0,
       /**
        * majorTicks control the min and max range as well as the interval
        *
        */
        majorTicksColor: '#333333',
        majorTicksLength: 5,
       /**
        * minorTicks control drawing minor ticks only
        */
        minorTicksColor: "black",
        minorTicksLength: 3,
		_X:0,
		_W:0,
	
	   /**
        * dont animate when setting values
		*/
		dontAnimate: false,
		_save: false,

	   /**
        * Set outline thickness and color, set to zero to remove outline
		*/
		outlineWidth: 2,
		outlineColor: "#0c0c0c",
        outlineRadius: 4,
        outPadding: 3,
        
        /**
        * Set inline thickness and color, set to zero to remove outline
		*/
		inlineWidth: 1,
		inlineColor: "#000000",
        inlineRadius: 2,

        /**
        * Scale with the state
        */
        _scale: 2,
        
        outInPadding: 2.5, 
		
		_leftX:0,
		_width:0,
		//labelPosition:"",
		
		// showGraduations: Boolean
		//		Decides if the graduations are to be shown on Volume Bar or not.
		//		If true enables the ticks/graduations else doesn't paint them at all.
		// 49331: Add an option to show/hide graduations on Volume Bar -- needed by ITM
		//showGraduations : true, 
    	showGraduations:true,
		
		// showThresholdStrip: Boolean
		//		Decides if the threshold strip are to be shown at the bottom of Volume Bar or not.
		//		If true enables the threshold strip else not.
		//showThresholdStrip : false, 
		showThresholdStrip:"on",
		_currentState : "unknown",
		
		colorMap: (function(){
        	var color = {};
        	color[dojoe.gauge.common.GaugeThreshold.CLEAR_STATUS] = "#33cc14";
			color[dojoe.gauge.common.GaugeThreshold.NORMAL_STATUS] = "green"; // #33cc14";
			color[dojoe.gauge.common.GaugeThreshold.CRITICAL_STATUS] = "red"; // #e51717";
			color[dojoe.gauge.common.GaugeThreshold.FATAL_STATUS] = "#222222";
			color[dojoe.gauge.common.GaugeThreshold.MAJOR_STATUS] = "#FFB31A";
			color[dojoe.gauge.common.GaugeThreshold.MINOR_STATUS] = "#ffff1a";
			color[dojoe.gauge.common.GaugeThreshold.INDETERMINANT_STATUS] = "#2EA8E5";
			color[dojoe.gauge.common.GaugeThreshold.NOT_APPLICABLE_STATUS] = "#6963A6";
			color[dojoe.gauge.common.GaugeThreshold.UNKNOWN_STATUS] = "#A6A6A6";
			color[dojoe.gauge.common.GaugeThreshold.UNDEFINED_STATUS] = "#9294f3";
			color[dojoe.gauge.common.GaugeThreshold.INFORMATIONAL_STATUS] = "#2ea8e5";
			return color;
        })(),
		
    	
    constructor: function(args){
	   dojo.mixin(this, args);
	},

		measuringNode: null,

	 /**
      * private function compute
      */
      _computeSizing: function(state){
	//	 console.log("VolumeStyle _ computeSizing--" +  state.height + "----" + state.width);
         this._fh=this.fs;
		 if (this.fs==0) {

			if (state.width>state.height) 
	    	   this._fh=((state.height/6.0)|0);
			else
	    	   this._fh=((state.width/6.0)|0);
		 }

         this.font.size= this._fh+"px";
		 var count = 2;
		 if(("9"+state.maxValue).length > 4)
			count = 6;
		 this._padw= ("9"+state.maxValue).length / 2  * count; //this._getTextBox("9"+state.maxValue).w;
		 this._padh= this._fh;	//this._getTextBox("99").h;
   		 if (state.width>state.height) {
		    this._padh += (2+this.majorTicksLength);
   		 }
		 else {
  		   this._padw += (2+this.majorTicksLength);
		 }
		 //this._topmargin=this._padh;
		 this._topmargin=0;
		 
		 //check if the majorTickSeparation cannot contain the characters
		 if(state.width > state.height){
		 	var pw = state.width - this._padw;
		 	var sum = Math.abs(state.maxValue - state.minValue);
		 	var inc =  pw / ( sum / state.majorTickSeparation);
		 	if (inc <  (("9"+state.maxValue).length / 2 * this._fh)){
		 		this._fh = inc / ("9"+state.maxValue).length * 2;
		 		this.font.size = this._fh+"px";
		 	}
		 }else{
		 	var ph = state.height-this._padh-this._padh;
			var sum = Math.abs(state.maxValue - state.minValue);
			var inc =  ph/(sum/state.majorTickSeparation);
			if (inc < this._fh){
		 		this._fh = inc;
		 		this.font.size = this._fh+"px";
		 	}
		 }
		 
		 if(state.width < (("9"+state.maxValue+": "+state.units).length / 2 * this._fh)){
		 	this._fh = state.width / ("9"+state.maxValue+": "+state.units).length * 2;
		 	this.font.size = this._fh+"px";
		 }



		 if (state.units!=null) {
		    this._dispw= ("W"+state.units+": "+state.maxValue).length / 2 * this._fh;//this._getTextBox("W"+state.units+state.maxValue).w;
		  }
		  console.log("this.fs",this.fs,"this._fh",this._fh,"this._padw",this._padw,"this._padh",this._padh,
		  			"this._topmargin",this._topmargin,"this._dispw",this._dispw);
	  },


    getDrawOrder: function(){
        return ["drawBackground", "drawTicks","drawNeedle"];
	},
	
    
    getDrawSemantics: function(){
        return {
            background: "drawBackground",
            needle: "drawNeedle",
            updateValue: ["drawNeedle"],
			updateTicks: ["drawBackground", "drawTicks", "drawNeedle"],
            attentionUp: ["drawBackground", "drawTicks", "drawNeedle"],
            attentionDown: ["drawBackground", "drawTicks", "drawNeedle"]
        };
    },
    

    _getStatusNeedleImage: function(state){
        var s = this.getThresholdFromValue(state.endValue, state.thresholds);
		if(s.status == "")
			s.status = "unknown";
		this._currentState = this.getTranslatedName(s.status);
        var v = this._isHorizontal(state) ? '' : 'v';
        return dojo.moduleUrl("dojoe.gauge.volumebar.VolumeBarStyle", v + "bar_" + s.status.toLowerCase().replace(' ', '_') + ".png");
    },
	
    getStatus: function(){
		return this._currentState;
	},
	
    _getScale: function(state){
        if(this._isHorizontal(state)){
            return 100.0 / state.height;
        }else{
            return 100.0 / state.width;
        }
    },

	_drawTicksH: function(state){
		// OID, to prevent overlap of value check if the ticks value is in 3 digit or more. In that case reduce the number of major ticks to 3.
		
		 var secondLastTickVal = (state.maxValue - state.minValue)/state.majorTickSeparation;
		 secondLastTickVal = state.maxValue - secondLastTickVal;
		 if((""+secondLastTickVal).length > 2){
			console.log("Ticks length gettings more than 2, limiting number of ticks to 3");
			state.majorTickSeparation = (state.maxValue - state.minValue)/4;
		}
		var ph=state.height-this._padh-this._padh;
        var pw=state.width-this._padw - this.outPadding * 2 - this.outInPadding * 2;
		var cx = state.width/2.0 - this.outPadding - this.outInPadding;
        var cy = state.height/2.0;

		var sum = Math.abs(state.maxValue - state.minValue);
        var i,x=1;

		var inc =  pw/(sum/state.majorTickSeparation);

		var len= this.majorTicksLength;

		if (this._tickGroup==null){
           this._tickGroup= state.group.createGroup();
        }
        this._tickGroup.clear();

		var shape;
		var offs = this.orient=='rtl'? 1 : -1; 

		for(i=state.minValue; i<=state.maxValue; i+=state.majorTickSeparation){

			   if (this.lines){
                 shape = this._tickGroup.createLine({x1: x, y1: 0, x2: x, y2: len})
                  .setStroke({color: this.majorTicksColor, width: 1})
                  .setTransform({dx:-cx,dy:cy-this._padh});
               }
			  //53318: Volume Bar does not show decimals for small ranges
			  //var st= ""+(i|0);
			  
			  // 71431: Volume Bar tick mark label floating point error 
			  // 0.4 + 0.2 returns 0.60000001 which is one of the JS limitations as internally these are 
			  // represented as binary equivalents which do not have an exact representation for many decimal values.
			  // As per OID review limiting the decimal places to 2.
			  var tmp = dojo.number.round(i, 2);
			  var st= ""+(tmp);
			  var align='middle';
			  if (i==state.minValue) 
			     align = this.orient=='rtl'? 'end' : 'start';

			  if (this.values){
                var t = this._tickGroup.createText({x: offs*cx-offs*x, y: cy, text: st, align: align, textDir: this.getGfxTextDir()});
                 t.setFill(this.majorTicksColor).setFont(this.axisFont);
                 if (this.orient=='rtl') 
                 	t.setTransform(dojox.gfx.matrix.flipX);        
              }

			  x+=inc;
		  }
		return this._applyGroupTransform(this._tickGroup, state);
	},

	_drawTicksV: function(state){
		 var secondLastTickVal = (state.maxValue - state.minValue)/state.majorTickSeparation;
		 secondLastTickVal = state.maxValue - secondLastTickVal;
		 if((""+secondLastTickVal).length > 2){
			console.log("Ticks length gettings more than 2, limiting number of ticks to 3");
			state.majorTickSeparation = (state.maxValue - state.minValue)/4;
		}
        var ph=state.height-this._padh - this.outInPadding * 2 - this.outPadding * 2;
        var pw=state.width-this._padw - this.outInPadding * 2 - this.outPadding * 2;
		var cx = state.width/2.0;
        var cy = state.height/2.0 - this.outInPadding - this.outPadding;
        
		var sum = Math.abs(state.maxValue - state.minValue);
        var y=ph;

		var i,inc =  ph/(sum/state.majorTickSeparation);

		var len= this.majorTicksLength;

		if (this._tickGroup==null){
           this._tickGroup= state.group.createGroup();
        }
        this._tickGroup.clear();

		var shape;
        var offs1 = this.orient=='rtl'? -1 : 1;
        var offs2 = this.orient=='rtl'? -1 : 0;

		for(i=state.minValue; i<=state.maxValue; i+=state.majorTickSeparation){
  			   if (this.lines){
                 shape = this._tickGroup.createLine({x1: 0, y1: y, x2: len, y2: y})
                  .setStroke({color: this.majorTicksColor, width: 1})
                  .setTransform({dx:cx-this._padw,dy:-cy});
               }
              var st= ""+(i|0);

			  var align=this.orient=='rtl'? 'end' : 'start';
			  if (this.values){
                var t = this._tickGroup.createText({x: offs1*(cx-this._padw+len+1)+ offs2, y:(-cy+y+4), text: st, align: align, textDir: this.getGfxTextDir()});
                 t.setFill(this.majorTicksColor).setFont(this.axisFont);
                 if (this.orient=='rtl') 
                  	t.setTransform(dojox.gfx.matrix.flipX);        
              }

			  y-=inc;
		  }
       return this._applyGroupTransform(this._tickGroup, state);
	},
    
    _createOrClearGroup: function(group, state){
        if(this[group] == null){
            this[group] = state.group.createGroup();
        }else{
            this[group].clear();
        }
        return this[group];
    },

    _applyGroupTransform: function(group, state){
        var scale = this._getScale(state);
        group.setTransform({xx: scale, yy: scale, dx:0, dy:0});
        return group;
    },

	_backGroup: null,
    drawBackground: function(state){
        this._computeSizing(state);
        return this._drawBackground(state);
	},
    
    _drawBackground: function(state){
        this._createOrClearGroup('_backGroup', state);
        if(state.endValue === undefined)
			state.endValue = 0;
			
		if (state.thresholds.length == 0)
			this.showThresholdStrip = "off";
			
        var rect = this._getBackgroundRect(state);
        
		this._width = rect.width;
        var bar = this._backGroup.createImage({
            x: rect.x, 
            y: rect.y,
            width : rect.width, 
            height: rect.height, 
            src: this._getBackgroundImage(state)
        });
        
        this._backGroup.createRect({
            x: rect.x, 
            y: rect.y,
            width : rect.width, 
            height: rect.height,
            r: this.outlineRadius})
            .setStroke({color: this.outlineColor, width: this.outlineWidth});
		/*var value = this._backGroup.createText({x: (rect.width + rect.x + 3), text: state.endValue, align: "start"});
        value.setFill(this.majorTicksColor).setFont("arial");
        value.setFont({size:"15px"});*/

		// create Threshold colors at the botton of the Volume Bar
		if(this.showThresholdStrip == "on") {
			var totWidth = this._width - (this.outlineWidth *2);
			var colors = this._getColors(state, rect);
			console.debug("colorWWW ", colors);
			var xVal = rect.x  + 3;
			var yVal = rect.y + (rect.height * 0.8);
			for(var color in colors) {
				if(color != "") {
				this._backGroup.createRect({
				x: xVal, 
				y: yVal+1,
				width : totWidth * colors[color].width, 
				height: (rect.height * 0.2) - this.inlineWidth
				})
				.setStroke({color: this.outlineColor, width: this.inlineWidth, cap:"square"})
				.setFill(colors[color].color).setShape({r:0});
				}
				xVal = xVal + totWidth * colors[color].width;
			}
		}	
        return this._applyGroupTransform(this._backGroup, state);
    },
    
    _getColors: function(state,rect){
    	var nValue = state.endValue - state.minValue;
    	if(nValue > (state.maxValue - state.minValue)){
    		nValue = state.maxValue - state.minValue;
    	}
    	var reColors = [];
    	var sunOffset = 0;
		var totalWidth = 0;
    	 if (state.thresholds.length > 0){
    		 for(var i = 0; i<state.thresholds.length - 1; i++){
    			 if(state.thresholds[i].start < state.maxValue){
					 if(state.thresholds[i+1].start < state.minValue)
						continue;
					 else if(state.thresholds[i+1].start < state.maxValue) {
						if(state.thresholds[i].start < state.minValue)
							sunOffset = (state.thresholds[i+1].start - state.minValue)/(state.maxValue - state.minValue);
						else
							sunOffset = (state.thresholds[i+1].start - state.thresholds[i].start)/(state.maxValue - state.minValue);
					 } else
						sunOffset = (state.maxValue - state.thresholds[i].start)/(state.maxValue - state.minValue);
    				 reColors.push({color:this.colorMap[state.thresholds[i].status],width:sunOffset});
					 totalWidth = totalWidth + sunOffset;
    			 }
    		 }
			 var len = state.thresholds.length - 1;
			 if(state.thresholds[len].start < state.maxValue)
				reColors.push({color:this.colorMap[state.thresholds[len].status],width:1-totalWidth});
    	 }
    	 console.debug("reColors : ", reColors);
    	 if(reColors.length == 0){
			reColors.push({"color":"green","offset":0});
		 }
		 
    	return reColors;
    },
	
	_getBackgroundImage: function(state){
        if(this._isHorizontal(state)){
            return dojo.moduleUrl("dojoe.gauge.volumebar.VolumeBarStyle", "background.png");
        }else{
            return dojo.moduleUrl("dojoe.gauge.volumebar.VolumeBarStyle", "vbackground.png")
        }
    },
    
    _getBackgroundRect: function _getBackRect(state){
        if(this._isHorizontal(state)){
            var ph=state.height-this._padh-this._topmargin;
            var pw=state.width-this._padw; 
            var rect = {
                x: -state.width/2.0 + this.outPadding, 
                y: -state.height/2.0 + this._topmargin + this.outPadding,
                width : pw - this.outPadding * 2, 
                height: ph - this.outPadding * 2
            };
            return rect;
        }else{
            var ph = state.height-this._padh;
            var pw = state.width-this._padw;
            var rect = {
                x: -state.width/2.0 + this.outPadding, 
                y: -state.height/2.0 + this.outPadding,
                width : pw - this.outPadding * 2, 
                height: ph - this.outPadding * 2
            };
            return rect;
        }
    },
    
	_tickGroup: null,
	drawTicks: function(state){
	  // 49331: Add an option to show/hide graduations on Volume Bar -- needed by ITM
	  // ITM wants to put multiple volume bars together like a bar chart
	  // they want an option to not show the scale on a volume bar because 
	  // they only want the scale on one of the bars (the bottom one).
	  if(!this.showGraduations) {
		return;
	  }
	  if (this._isHorizontal(state)){
	     return this._drawTicksH(state);
      }else{
        return this._drawTicksV(state);
      }
	},

    _isHorizontal: function(state){
       // return state.width >= state.height;
	   // disable vertical VB.
	   return true;
    },

    _needleGroup: null,
    drawNeedle: function(state){
        return this._drawNeedle(state);
	},
    
    _drawNeedle: function(state){
		if (this._needleGroup == null) {
			this._needleGroup = state.group.createGroup();
		}
        //this._createOrClearGroup('_needleGroup', state);
        
		if (state.thresholds.length == 0){
			this.showThresholdStrip = "off";
		}
		
        var rect = this._getNeedleRect(state);
		
		var bgShape = {
			x: rect.x, y: rect.y,
			width: rect.width, 
            height: (rect.height) * (this.showThresholdStrip == "on"? 0.8:1.0),  
            src: this._getStatusNeedleImage(state)
		};
		var background = this._needleGroup.children[0];
		if(!background){
			background = this._needleGroup.createImage(bgShape);
		}else{
			background.setShape(bgShape);
		}
		/*
        var bar = this._needleGroup.createImage({
            x: rect.x, 
            y: rect.y,
            width: rect.width, 
            height: (rect.height) * (this.showThresholdStrip == "on"? 0.8:1.0),  
            src: this._getStatusNeedleImage(state)
        });*/
        var rectShape = {
			x: rect.x, y: rect.y,
			width: rect.width, 
            height: (rect.height) * (this.showThresholdStrip == "on"? 0.8:1.0),  
            r: this.inlineRadius
		};
		var rectDom = this._needleGroup.children[1];
		if(!rectDom){
			rectDom = this._needleGroup.createRect(rectShape);
		}else{
			rectDom.setShape(rectShape);
			rectDom.setStroke({color: this.inlineColor, width: this.inlineWidth});
		}
		/*
		var shape = this._needleGroup.createRect({
            x: rect.x, 
            y: rect.y,
            width : rect.width, 
            height: (rect.height) * (this.showThresholdStrip == "on"? 0.8:1.0),  
            r: this.inlineRadius})
            .setStroke({color: this.inlineColor, width: this.inlineWidth});*/
            
        return this._applyGroupTransform(this._needleGroup, state);
    },
    
    _getNeedleRect: function(state){
		// 79907: TWL 1.1.0.2 : [No Data Status] Volume Bar tooltip always shows Status: Unknown even when other status selected
		// if I change the state obj here, it effects while finding the threshold.
		var endValue = state.endValue;
		if((endValue === undefined) || (endValue < state.minValue) || isNaN(endValue))
			endValue = state.minValue;
			
    	if(this._isHorizontal(state)){
            var ph=state.height-this._padh-this._topmargin;
            var pw=state.width-this._padw;
            var w = (pw - this.outInPadding * 2 - this.outPadding * 2) * (endValue - state.minValue) / (state.maxValue - state.minValue);
            if((endValue - state.minValue) > state.maxValue - state.minValue){
            	w = pw - this.outInPadding * 2 - this.outPadding * 2;
            }
            var rect = {
                x: -state.width/2.0 + this.outInPadding + this.outPadding, 
                y: -state.height/2.0+this._topmargin + this.outInPadding + this.outPadding,
                width: w, 
                height: ph - this.outInPadding * 2 - this.outPadding * 2
            };

            return rect;
        }else{
            var ph=state.height-this._padh - this._topmargin;
            var pw=state.width-this._padw;
            var h = (ph - this.outInPadding * 2 - this.outPadding * 2) * (endValue - state.minValue) / (state.maxValue - state.minValue);
            if((endValue - state.minValue) > (state.maxValue - state.minValue)){
            	h = ph - this.outInPadding * 2 - this.outPadding * 2;
            }
            var rect = {
                x: -state.width/2.0 + this.outInPadding + this.outPadding, 
                y: state.height/2.0 - this.outInPadding - this.outPadding - this._padh - this._topmargin - h,
                width : pw - this.outInPadding * 2 - this.outPadding * 2, 
                height: h
            };
            return rect;
        }
    },
	
	_destroyContent:function(g){
		if(g.children){
			for(var i=0;i<g.children.length;++i){
				var s = g.children[i];
				//dojox.gfx.shape.dispose(s);
				if(s && s.children){
					this._destroyContent(s);
				}
				s.destroy();
			}
			//g.clear();
		}
		g.clear();
	},
	
    reset: function(){
        // summary:
        //          Deletes any locally-stored shape objects when the gauge 
        //          needs to be reset.
		if(this._needleGroup)
			this._destroyContent(this._needleGroup);
		if(this._backGroup)
			this._destroyContent(this._backGroup);
		if(this._tickGroup)
			this._destroyContent(this._tickGroup);
			
        delete this._backGroup;
        delete this._needleGroup;
        delete this._tickGroup;

        this._needleGroup=null;
        this._backGroup=null;
        this._tickGroup=null;
    }
});


});
