/*********************************************************** {COPYRIGHT-TOP} ***
* Licensed Materials - Property of IBM
* Tivoli Widget Library
*
* (C) Copyright IBM Corp. 2014.  All Rights Reserved.
*
* US Government Users Restricted Rights - Use, duplication, or
* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
************************************************************ {COPYRIGHT-END} **/
define("dojoe/list/_MultiSelectTabBarButton", [
	"dojo/_base/declare",
	"dojo/_base/lang",
	"dojox/mobile/TabBarButton"
], function(declare, lang, TabBarButton){

	// module:
	//		dojoe/list/_MultiSelectTabBarButton

	// summary:
	//		A button widget that is placed in the TabBar widget.

	return declare("dojoe.list._MultiSelectTabBarButton", TabBarButton,{
		
		//45819: TWL 3.2.0.0 : List, de-selecting filter icon on filterbar does not clear the filter
		//Bobby: 18Mar2014, Major overhaul as base class (TabBarButton) implementation changed significantly in dojo 1.9.x
		currently_Selected: false,
		
		onClick : function (evt) {
			setTimeout(lang.hitch(this, "toggleSelection", evt), 500);
			//this.toggleSelection(evt); //_setSelectedAttr from base class getting triggered 3 times on every click!			
		},
		
		toggleSelection : function (evt) {
			//console.debug("_MultiSelectTabBarButton.js: time to toggle, current state:"+this.currently_Selected);
			this.currently_Selected = !(this.currently_Selected);
			this._setSelectedAttr(this.currently_Selected);
			this.onToggle(evt);
		},
		
		onToggle: function (evt) {
			// summary:
			//		User defined function to handle clicks
			// tags:
			//		callback		
		}
	});
});
