// wrapped by build app
define("dojoe/propertylist/PropertyList", ["dijit","dojo","dojox","dojo/require!dijit/_Widget,dijit/_Templated"], function(dijit,dojo,dojox){
/*********************************************************** {COPYRIGHT-TOP} ***
* Licensed Materials - Property of IBM
* Tivoli Widget Library
*
* (C) Copyright IBM Corp. 2014.  All Rights Reserved.
*
* US Government Users Restricted Rights - Use, duplication, or
* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
************************************************************ {COPYRIGHT-END} **/
dojo.provide('dojoe.propertylist.PropertyList');

dojo.require('dijit._Widget');
dojo.require('dijit._Templated');

dojo.declare('dojoe.propertylist.PropertyList', [dijit._Widget, dijit._Templated],{
    // current page
    page : 1,
 
    // total number of pages
    pages : 1,
 
    // DataList title
    title : null,
 
    // title of the next page link
    nextPageText : 'next',
 
    // title of the prev page link
    prevPageText : 'previous',
 
    // url to which an ajax request will be sent
    // for obtaining data from the server
    dataUrl : '',

    // visible row fields
    cells : '',

    // where to look for template
    templateString:"<div class=\"propertylist\">\r\n <div class=\"title\" dojoAttachPoint='_titleNode'>\r\n   ${title}\r\n </div>\r\n <table dojoAttachPoint=\"_rowsNode\" class=\"rows\">\r\n  <!-- This code is commented because\r\n        items will be created at runtime.\r\n  <div class=\"row\">\r\n    ...\r\n  </div>\r\n  -->\r\n </table>\r\n <div class=\"pager\" dojoAttachPoint=\"_pagerNode\">\r\n  <div class=\"pager-links\">\r\n   <div class=\"pager-links-prev\">\r\n     <a href=\"#\" dojoAttachEvent=\"onclick:prevPage\">${prevPageText}</a>\r\n   </div>\r\n   <div class=\"pager-links-next\">\r\n     <a href=\"#\" dojoAttachEvent=\"onclick:nextPage\">${nextPageText}</a>\r\n   </div>\r\n   <div class=\"pager-links-info\" dojoAttachPoint=\"_pagerLinksInfoNode\">\r\n    <!-- This section will be populated right after the list data\r\n         is fetched from the server. -->\r\n   </div>\r\n  </div>\r\n </div>\r\n</div>\r\n",
	
	items: {},

    // postCreate is a predefined event
    // handler that is executed when widget
    // is created and initialized
    postCreate : function () {
      this.fetch();
    },

    prevPage : function () {
      if (this.page > 1) {
        this.page--;
        this.fetch();
      }
    },
 
    nextPage : function () {
      if (this.page < this.pages) {
        this.page++;
        this.fetch();
      }
    },
  
    fetch : function () {
		console.info("PropertyList: fetch() - BEGIN");
		console.dir(this.items);
		if(this.items && this.items.length>0){
			console.info("Found items, length:"+this.items.length);
			this.pages = this.items.length;
			this.render(this.items[this.page-1]);
		}else if ("" != this.dataUrl) {
			// Send the request to the server and
			// rebuild the list of items
			//var _this = this;
			dojo.xhrGet({
			  url: this.dataUrl.replace(/\{page\}/, this.page),
			  handleAs: 'json',
			  load: function(response, ioArgs) {
				this.pages = response.pages;
				this.render(response.items[this.page-1]);
			  }
			});
		}else if(this.items) {
			this.pages = 1;
			this.render(this.items);						
		}else console.warn("PropertyList: fetch(): Neither items nor dataUrl set!");
		console.info("PropertyList: fetch() - END");
    },

    render : function (item) {
	  console.info("PropertyList: render() - BEGIN");
		console.log("item ->");
		console.dir(item);	
      var rows = this._rowsNode;

      // clear current rows      
	  //if(rows.innerHTML) rows.innerHTML = '';
	  dojo.empty(rows);
	  
      // fields that should be rendered
      //var cells = this.cells.split(',');
      // for each entry in items render fields
      // defined in the "cells" array
      //for (var i = 0; i < items.length; i++) {
 
		for (x in item){
			console.log(x+':'+item[x]);
			var row=rows.insertRow(-1);
			//var row = rows.appendChild(document.createElement('tr'));
			dojo.addClass(row, 'row');	
			var cell=row.insertCell(0);			
			//var cell = row.appendChild(document.createElement('td'));
			dojo.addClass(cell, 'row-cell');
			//dojo.addClass(cell, 'row-cell-' + x);
			if(x instanceof Object)
				cell.appendChild(document.createTextNode(x));
			else	
				cell.appendChild(document.createTextNode(x));
			var cell=row.insertCell(1);			
			dojo.addClass(cell, 'row-cell');
			cell.appendChild(document.createTextNode(':'));
			
			var cell=row.insertCell(2);			
			dojo.addClass(cell, 'row-cell');
			//console.dir(item[x]);
			if(item[x] instanceof Object){
				console.info('item[x] is not text!');
				//dojo.place(cell.appendChild(document.createElement('div')), item[x]);				
				cell.appendChild(item[x].domNode);
			}else	
				cell.appendChild(document.createTextNode(item[x]));
				
		}
		
		
        /*for (var j = 0; j < cells.length; j++) {
          var cell = row.appendChild(document.createElement('div'));
          dojo.addClass(cell, 'row-cell');
          dojo.addClass(cell, 'row-cell-' + cells[j]);
          cell.appendChild(document.createTextNode(item[cells[j]]));
        }*/
        this.onRenderRow(row, item);

      this._pagerLinksInfoNode.innerHTML = this.page + ' / ' + this.pages;
	  if(this.pages == 1) dojo.style(this._pagerNode, 'display', 'none');
	  if(!this.title) dojo.style(this._titleNode, 'display', 'none');
	  console.info("PropertyList: render() - END");		
    },
	

    // empty method that can be overwritten to customize
    // the row rendering
    onRenderRow : function (row, fields) {
    }

  }
);

});
