require({cache:{
'url:dojoe/ssd/quickedit/templates/GaugeOptions.html':"<div style=\"height:100%;width:100%;\"> \r\n\t<div data-dojo-attach-point=\"gaugeOptionsNode\"></div>\t\r\n</div>\t"}});
/*********************************************************** {COPYRIGHT-TOP} ***
* Licensed Materials - Property of IBM
* Tivoli Widget Library
*
* (C) Copyright IBM Corp. 2014.  All Rights Reserved.
*
* US Government Users Restricted Rights - Use, duplication, or
* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
************************************************************ {COPYRIGHT-END} **/
define("dojoe/ssd/quickedit/GaugeOptions", [
	"dojo/_base/declare",
	"dojo/_base/lang",
	"dojo/_base/array",
	"dijit/_WidgetBase",
	"dijit/_TemplatedMixin",
	"dojo/text!./templates/GaugeOptions.html",
	"dojo/i18n!./nls/GaugeOptions",
	"dojoe/ssd/quickedit/DatasetDetails",
	"dojoe/tablelayout/TableLayout",
	"dijit/form/TextBox",
	"dijit/form/NumberSpinner",
	"dijit/form/NumberTextBox",
	"dijit/form/ComboBox",
	"dijit/form/CheckBox",
	"dojo/store/Memory",
	"dijit/form/FilteringSelect",
	"dojoe/Util",
	"dijit/ColorPalette",
	"dijit/form/DropDownButton",
	"dijit/MenuItem",
	"dijit/DropDownMenu",
	"dijit/popup",
	"dojo/colors"
], function (declare, lang, array, _WidgetBase, _TemplatedMixin, template, nlsBundle, datasetDetails, TableLayout, TextBox, NumberSpinner, NumberTextBox, ComboBox, CheckBox, Memory, FilteringSelect, ColorPalette, DropDownButton, MenuItem, DropDownMenu, Popup, colors) {
	 return declare("dojoe.ssd.quickedit.GaugeOptions", [_WidgetBase, _TemplatedMixin], {
		templateString: template,
		nls: nlsBundle,
		optionsList: null,		
		_datasetColumns: null,
		_gaugeName: "AnalogGauge",
		_topLabelCustom:"true",
		_leftLabelCustom:"true",
		_disableThreshold:"false",
		_oslcResourceURI:"false",
		thMinValue: 0,
		thMaxValue: 100,
		optionsGrid_data: null,
		colorDropDown:null,
		
		constructor: function (args) {
			console.debug("In GaugeOptions Constructor");
			this._gaugeName = args.name;
			this._isGroupWidget = args.isGroupWidget;
		},
			
		postCreate: function() {
			console.debug("In GaugeOptions postCreate : " + quickEdit);
		},
		
		createOptionsGrid: function() {
			quickEdit.getDatasetColumns(this, "_getDatasetAttributes");
		},
		
		_getDatasetAttributes: function(columns) {
			this._datasetColumns = new Array();
			this._datasetColumns.push({id:"None", name:this.nls.NONE});			
			var datasetColumnsTemp = new Array();					
		
			for (var i=0;i<columns.length;i++){
				//exclude hidden columns from dataset
				if(!columns[i].isHidden()){
					datasetColumnsTemp.push({
						id: columns[i].getId(), 
						name: columns[i].getLabel(), 
						valueType: columns[i].getValueType()
					});			
				}	
				if(columns[i].getId() == "OslcResourceURI")
					this._oslcResourceURI = true;
			}			

			//sort the dataset columns
			datasetColumnsTemp.sort(function(a, b){
				if (a.name < b.name) //sort string ascending
					return -1;
				if (a.name > b.name)
					return 1;
				return 0; //default return value (no sorting)
			});			
			
			this._datasetColumns = this._datasetColumns.concat(datasetColumnsTemp);				

			console.info("Dataset Attributes...");
			console.dir(this._datasetColumns);			
			
			this.createGaugeOptions();			
		},
		
		_updateThreshold: function(widget) {
			var val;
			var initialThresholdState = this._disableThreshold; // for optimization, don't need to change options if state doesn't change
			var options = widget.item;
			if(options) {
				if(options.valueType && options.valueType.toLowerCase() == "status") {
					this._disableThreshold = true;
				} else {
					this._disableThreshold = false;
				}
			}
			//Select has been changed to Filtering Select in DefaultMapper hence changes
			/*for(var i in options) {
				if(options[i].value == widget.get('value') && options[i].valueType && options[i].valueType.toLowerCase() == "status") {
					this._disableThreshold = true;
					break;
				} else {
					this._disableThreshold = false;
				}
			}*/
			// 78514: TWL 1.1.0.2 : Staus Gauge, Threshold value Fields in QE are not removed on selecting ' Status ' when locale changed [fr, ja,he, no etc.,]
			var statuses=["Critical","Normal", "Fatal", "Minor", "Major", "Informational"];
			if(this._disableThreshold != initialThresholdState) { // do this only if there is a change in state
				for(var i=0; i<this.optionsList._rowsNode.children.length; i++) {
					if(array.indexOf(statuses, this.optionsGrid_data.itemsUI[i].item_id)>-1) {
						if(this._disableThreshold)
							this.optionsList._rowsNode.children[i].style.display = "none";
						else
							this.optionsList._rowsNode.children[i].style.display = "";
					}
				}
			}
		},
		
		createGaugeOptions: function () {	
			
			console.log ("GaugeOptions._createOptionsGrid... BEGIN");			
			if(this._gaugeName == "StatusGauge") {
				for(var i in quickEdit.dd.mappingGrid_data.items) {
					if(quickEdit.dd.mappingGrid_data.items[i].id == "Value") {
						quickEdit.dd.mappingGrid_data.itemsUI[i].item_value.onChange = dojo.hitch(this, this._updateThreshold, quickEdit.dd.mappingGrid_data.itemsUI[i].item_value);
					}
				}
			}
			// Create the options grid
			if(!this.optionsGrid_data)
				this.optionsGrid_data = { "identifier": "id", "idAttribute":"id", "items": [], "itemsUI": []};
			
			this.optionsGrid_data.items = new Array();
			this.optionsGrid_data.items.push({id:"TopLabel", name:this.nls.TOPLABEL, description: this.nls.DESC_TOPLABEL, valueType: "label"});
			this.optionsGrid_data.items.push({id:"LeftLabel", name:this.nls.LEFTLABEL, description: this.nls.DESC_LEFTLABEL, valueType: "label"});
			
			var fontSizes = [{name:"xx-small", id:"xx-small", label:"<div style='font-size:xx-small'>xx-small</div>"},
							 {name:"x-small", id:"x-small", label:"<div style='font-size:x-small'>x-small</div>"},
							 {name:"small", id:"small", label:"<div style='font-size:small'>small</div>"},
							 {name:"medium", id:"medium", label:"<div style='font-size:medium'>medium</div>"},
							 {name:"large", id:"large", label:"<div style='font-size:large'>large</div>"},
							 {name:"x-large", id:"x-large", label:"<div style='font-size:x-large'>x-large</div>"},
							 {name:"xx-large", id:"xx-large", label:"<div style='font-size:xx-large'>xx-large</div>"}
							];
			this.optionsGrid_data.items.push({id:"FontSize", name: this.nls.FONTSIZE, description:this.nls.DESC_FONTSIZE, valueType: "combo", data: fontSizes});
			
			var allFonts = [{name:"Arial", id:"Arial", label:"<div style='font-family:Arial'>Arial</div>"},
							{name:"Times New Roman", id:"TimesNewRoman", label:"<div style='font-family:Times New Roman'>Times New Roman</div>"},
							{name:"Comic Sans MS", id:"ComicSansMS", label:"<div style='font-family:Comic Sans MS'>Comic Sans MS</div>"},
							{name:"Courier New", id:"CourierNew", label:"<div style='font-family:Courier New'>Courier New</div>"}
						    ];
			this.optionsGrid_data.items.push({id:"FontFamily", name: this.nls.FONTFAMILY, description:this.nls.DESC_FONTFAMILY, valueType: "combo", data: allFonts});
			
			this.optionsGrid_data.items.push({id:"ColorPicker", name: this.nls.COLORPICKER, description:this.nls.DESC_COLORPICKER, valueType: "ColorPicker"});
			
			//Ramachandran - Re-arranging as per defect 74437: Incorporate OID review comments for Gauges Quick Edit 
			if(this._gaugeName == "VolumeBar" || this._gaugeName == "AnalogGauge") {
				
				this.optionsGrid_data.items.push({id:"MinValue", name: this.nls.MINVALUE, description:this.nls.DESC_MINVALUE, def: "0", valueType:"label"});
				this.optionsGrid_data.items.push({id:"MaxValue", name: this.nls.MAXVALUE, description:this.nls.DESC_MAXVALUE, def: "100", valueType:"label"});
			}
			
			//Ramachandran - 28-Jun-13 - Task:78497: OID review for Gauges QuickEdit - Threshold textbox change to NumberSpinner
			this.optionsGrid_data.items.push({id:"Informational", 
				name: "<image alt='"+this.nls.INFORMATIONAL+"' src="+require.toUrl("dojoe/ssd/quickedit/images/Informational.png")+" /> "+this.nls.INFORMATIONAL, 
				description:this.nls.DESC_INFORMATIONAL, valueType:"numberSpinner"});			
			this.optionsGrid_data.items.push({id:"Normal", 
				name: "<image alt='"+this.nls.NORMAL+"' src="+require.toUrl("dojoe/ssd/quickedit/images/Normal.png")+" /> "+this.nls.NORMAL, 
				description:this.nls.DESC_NORMAL, valueType:"numberSpinner"});
			this.optionsGrid_data.items.push({id:"Minor", 
				name: "<image alt='"+this.nls.MINOR+"' src="+require.toUrl("dojoe/ssd/quickedit/images/MinorWarning.png")+" /> "+this.nls.MINOR, 
				description:this.nls.DESC_MINOR, valueType:"numberSpinner"});
			this.optionsGrid_data.items.push({id:"Major", 
				name: "<image alt='"+this.nls.MAJOR+"' src="+require.toUrl("dojoe/ssd/quickedit/images/MajorWarning.png")+" /> "+this.nls.MAJOR, 
				description:this.nls.DESC_MAJOR, valueType:"numberSpinner"});
			this.optionsGrid_data.items.push({id:"Critical", 
				name: "<image alt='"+this.nls.CRITICAL+"' src="+require.toUrl("dojoe/ssd/quickedit/images/Critical.png")+" /> "+this.nls.CRITICAL, 
				description:this.nls.DESC_CRITICAL, valueType:"numberSpinner"});
			this.optionsGrid_data.items.push({id:"Fatal", 
				name: "<image alt='"+this.nls.FATAL+"' src="+require.toUrl("dojoe/ssd/quickedit/images/Fatal.png")+" /> "+this.nls.FATAL, 
				description:this.nls.DESC_FATAL, valueType:"numberSpinner"});
				
			if(this._gaugeName == "VolumeBar" || this._gaugeName == "AnalogGauge") {
				this.optionsGrid_data.items.push({id:"ShowThresholdStrip", name: this.nls.SHOWTHRESHOLDSTRIP, description:this.nls.DESC_SHOWTHRESHOLDSTRIP, valueType:"checkBox"});
				this.optionsGrid_data.items.push({id:"MajorTicksSeparation", name: this.nls.MAJORTICKSSEPARATION, description:this.nls.DESC_MAJORTICKSSEPARATION, def: "20", valueType:"numberSpinner"});
			}
				
			if(this._gaugeName == "AnalogGauge") {
				this.optionsGrid_data.items.push({id:"MinorTicksSeparation", name: this.nls.MINORTICKSSEPARATION, description:this.nls.DESC_MINORTICKSSEPARATION, def:"5", valueType:"numberSpinner"});
				this.optionsGrid_data.items.push({id:"Unit", name:this.nls.UNIT, description: this.nls.DESC_UNIT});
			}
			
			var alignData = [{name:"Left", id:"left"},
							 {name:"Center", id:"center"},
							 {name:"Right", id:"right"}
							];
			if(this._isGroupWidget == "true") {
				this.optionsGrid_data.items.push({id:"align", name: "Alignment", description:"Select the alignment for the widget", valueType: "combo", data: alignData});
			}
			var defaltStatusData = [{name:this.nls.UNKNOWN, id:"Unknown"},
									{name:this.nls.NORMAL, id:"Normal"},
									{name:this.nls.INFORMATIONAL, id:"Informational"},
									{name:this.nls.MINOR, id:"Minor"},
									{name:this.nls.MAJOR, id:"Major"},
									{name:this.nls.CRITICAL, id:"Critical"},
									{name:this.nls.FATAL, id:"Fatal"}
								];
			this.optionsGrid_data.items.push({id:"DefaultStatus", name:this.nls.DEFAULT_STATUS, description: this.nls.DEFAULT_STATUS_DESC, valueType: "combo", data: defaltStatusData});
			this.optionsGrid_data.itemsUI = new Array();
			var attribName;
			for(var i=0;i<this.optionsGrid_data.items.length;i++){
				for(var j=0;j<dashletConfig.optionNameArr.length;j++){
					attribName = dashletConfig.optionNameArr[j].replace("qe_optn_","");
					if(this.optionsGrid_data.items[i].id == attribName){		
						this.optionsGrid_data.itemsUI[i] = new Object();
						this.optionsGrid_data.itemsUI[i].item_id = attribName;
						this.optionsGrid_data.itemsUI[i].item_name = this.optionsGrid_data.items[i].name;
						this.optionsGrid_data.itemsUI[i].item_desc = this.optionsGrid_data.items[i].description;						
						if(this.optionsGrid_data.items[i].valueType == 'label') {
							var tempArray = [];
							var columnsArray = this._datasetColumns;
							if(this.optionsGrid_data.itemsUI[i].item_id == 'MinValue' || this.optionsGrid_data.itemsUI[i].item_id == 'MaxValue') {
								for(var k=0; k<this._datasetColumns.length; k++) {
									var type = quickEdit.dd._mapDataType(this._datasetColumns[k].valueType);
									if(type == "status" || type == "number") {
										tempArray.push(columnsArray[k]);
									}
								}
								columnsArray = tempArray;
							}
							this.optionsGrid_data.itemsUI[i].item_value = new ComboBox({store: new Memory({ idProperty: "id", data: columnsArray})});
							if(dashletConfig.optionValueArr[j]) {
								this.optionsGrid_data.itemsUI[i].item_value.set('value', unescapeHTML(dashletConfig.optionValueArr[j]));
								for(var k=0;k<this._datasetColumns.length;k++) {
									if(dashletConfig.optionValueArr[j] == this._datasetColumns[k].id)
										this.optionsGrid_data.itemsUI[i].item_value.set('value', this._datasetColumns[k].name);
								}
							}		
							if(this.optionsGrid_data.itemsUI[i].item_id == 'MinValue') {							
								this.optionsGrid_data.itemsUI[i].item_value.onChange = dojo.hitch(this, this._thresholdMinValueChanged, this.optionsGrid_data.itemsUI[i].item_value);
								this.thMinValue = this.optionsGrid_data.itemsUI[i].item_value.getValue();
							}
							if(this.optionsGrid_data.itemsUI[i].item_id == 'MaxValue') {
								this.optionsGrid_data.itemsUI[i].item_value.onChange = dojo.hitch(this, this._thresholdMaxValueChanged, this.optionsGrid_data.itemsUI[i].item_value);
								this.thMaxValue = this.optionsGrid_data.itemsUI[i].item_value.getValue();
							}
						} else if(this.optionsGrid_data.items[i].valueType == 'combo') {
							if(this.optionsGrid_data.itemsUI[i].item_id == 'FontSize') {
								this.optionsGrid_data.itemsUI[i].item_value = new FilteringSelect({store: new Memory({ idProperty: "id", data: fontSizes}), searchAttr: "name", labelAttr: "label", labelType: "html"});
								this.optionsGrid_data.itemsUI[i].item_value.set('value', dashletConfig.optionValueArr[j]);
							} else if(this.optionsGrid_data.itemsUI[i].item_id == 'FontFamily') {
								this.optionsGrid_data.itemsUI[i].item_value = new ComboBox({store: new Memory({ idProperty: "id", data: allFonts}), searchAttr: "name", labelAttr: "label", labelType: "html"});
								this.optionsGrid_data.itemsUI[i].item_value.set('value', dashletConfig.optionValueArr[j]);
							} else if(this.optionsGrid_data.itemsUI[i].item_id == 'DefaultStatus') { 
								this.optionsGrid_data.itemsUI[i].item_value = new FilteringSelect({store: new Memory({ idProperty: "id", data: defaltStatusData})});
								this.optionsGrid_data.itemsUI[i].item_value.set('value', dashletConfig.optionValueArr[j]);
							} else if(this.optionsGrid_data.itemsUI[i].item_id == 'align') { 
								this.optionsGrid_data.itemsUI[i].item_value = new FilteringSelect({store: new Memory({ idProperty: "id", data: alignData})});
								this.optionsGrid_data.itemsUI[i].item_value.set('value', dashletConfig.optionValueArr[j]);
							}
						} else if(this.optionsGrid_data.items[i].valueType == 'checkBox') {
							this.optionsGrid_data.itemsUI[i].item_value = new CheckBox();
							if(dashletConfig.optionValueArr[j])
								this.optionsGrid_data.itemsUI[i].item_value.set('value', dashletConfig.optionValueArr[j] == "on"?true:false);
						} else if(this.optionsGrid_data.items[i].valueType == 'numberSpinner') {

							//Ramachandran - 28-Jun-13 - Task:78497: OID review for Gauges QuickEdit - Threshold textbox change to NumberSpinner
							if(this._gaugeName == "VolumeBar" || this._gaugeName == "AnalogGauge") {
							
								if(	this.optionsGrid_data.itemsUI[i].item_id == "Informational" ||
										this.optionsGrid_data.itemsUI[i].item_id == "Normal" || 
										this.optionsGrid_data.itemsUI[i].item_id == "Minor" ||
										this.optionsGrid_data.itemsUI[i].item_id == "Major" ||
										this.optionsGrid_data.itemsUI[i].item_id == "Critical" ||
										this.optionsGrid_data.itemsUI[i].item_id == "Fatal"
										) {
									this.optionsGrid_data.itemsUI[i].item_value = new NumberSpinner({smallDelta: 1, constraints: { min: this.thMinValue, max: this.thMaxValue, places:'0,10' }});
								} else {
									this.optionsGrid_data.itemsUI[i].item_value = new NumberSpinner();
								}
								
							} else {
								this.optionsGrid_data.itemsUI[i].item_value = new NumberSpinner({smallDelta: 1, constraints: { places:'0,10' }});
							}
							
							if(dashletConfig.optionValueArr[j]){
								this.optionsGrid_data.itemsUI[i].item_value = new NumberSpinner();
								this.optionsGrid_data.itemsUI[i].item_value.set('value', dashletConfig.optionValueArr[j]);
							}else{
								this.optionsGrid_data.itemsUI[i].item_value = new NumberTextBox();
							}							
						} else if(this.optionsGrid_data.items[i].valueType == 'ColorPicker') {
							var cp = new dijit.ColorPalette({palette: "7x10",
															 value: dashletConfig.optionValueArr[j], 
															 onChange: dojo.hitch(this, function(){
																	if(!cp)
																		return;
																	var color = cp.get('value');
																	var colorCell = cp._selectedCell;
																	if(colorCell && cp._cells[colorCell]) {
																		var colorName = cp._cells[colorCell].node.title;
																		var pickerButton = this.colorDropDown;
																		if(pickerButton) {
																			pickerButton.set("label", "<span style='color:" + color + "; position:relative;'>" + colorName + "</span>");
																			pickerButton.set("value", colorName);
																		}
																	}
																}, cp)
															 });
							var menu = new dijit.DropDownMenu({ style: "display: none;"});
							var defMenu = new dijit.MenuItem({
								label: this.nls.DEF_COLOR,
								onClick: dojo.hitch(this, function(){
									var pickerButton = this.colorDropDown;
									if(pickerButton) {
										pickerButton.set("label", this.nls.DEF_COLOR);
										pickerButton.set("value", "Default");
									}
								})
							});
							menu.addChild(defMenu);							
							var colorPalleteMenu = new dijit.MenuItem({
								label: this.nls.SELECT_COLOR,
								onClick: dojo.hitch(this, function(){dijit.popup.open({
													popup: cp,
													around: this.colorDropDown.domNode,
													onExecute: function(){
														dijit.popup.close(cp);
													},
												});})
							});
									
							menu.addChild(colorPalleteMenu);										
							this.optionsGrid_data.itemsUI[i].item_value = new dijit.form.DropDownButton({
										label:this.nls.SELECT_COLOR,
										name: "picker",
										dropDown: menu,
									});
							this.colorDropDown = this.optionsGrid_data.itemsUI[i].item_value;
							if(dashletConfig.optionValueArr[j]) {
								this.optionsGrid_data.itemsUI[i].item_value.set('value', dashletConfig.optionValueArr[j]);
								if(dashletConfig.optionValueArr[j] != "Default") {
									var color = dashletConfig.optionValueArr[j].replace(/\s+/g, '');
									this.optionsGrid_data.itemsUI[i].item_value.set("label", "<span style='color:" + dojo.colorFromString(color) + "; position:relative;'>" + dashletConfig.optionValueArr[j] + "</span>");
								} else {
									this.optionsGrid_data.itemsUI[i].item_value.set("label", dashletConfig.optionValueArr[j]);
								}
							}
						} else {
							this.optionsGrid_data.itemsUI[i].item_value = new TextBox();
							if(dashletConfig.optionValueArr[j])
								this.optionsGrid_data.itemsUI[i].item_value.set('value', unescapeHTML(dashletConfig.optionValueArr[j]));
						}
					}
					if(attribName == 'UIPreview'){
						if(quickEdit.dd.richHoverCheckBox && quickEdit.isResourceRegistrySet){
							console.info("value ofuiPreview in QE -- " + dashletConfig.optionValueArr[j]);
							quickEdit.dd.richHoverCheckBox.set("value",dashletConfig.optionValueArr[j]);
							if(dashletConfig.optionValueArr[j] == 'false')
								quickEdit.dd.richHoverCheckBox.set("checked",false);
							else quickEdit.dd.richHoverCheckBox.set("checked",true);	
						}					
					}
					//Richa- 36760: [CUST/BP] [Accuoss]Allow me to enable my own hover over a widget (non-OSLC)
					else if(attribName == "CustomHoverURL"){
						quickEdit.dd.customRichHoverURL.set("value",dashletConfig.optionValueArr[j]);
					}else if(attribName == "CustomHoverTitle"){
						quickEdit.dd.customRichHoverShortTitle.set("value",dashletConfig.optionValueArr[j]);
					}else if(attribName == "CustomHoverHeight"){
						if (dashletConfig.optionValueArr[j] == "NaN"){
							quickEdit.dd.customRichHoverHeight.set("value",10);
						}else
							quickEdit.dd.customRichHoverHeight.set("value",dashletConfig.optionValueArr[j]);
					}else if(attribName == "CustomHoverWidth"){
						if (dashletConfig.optionValueArr[j] == "NaN"){
							quickEdit.dd.customRichHoverWidth.set("value",20);
						}else
							quickEdit.dd.customRichHoverWidth.set("value",dashletConfig.optionValueArr[j]);
					}else if(attribName == "CustomHoverUnit"){
						quickEdit.dd.customRichHoverUnit.set("value",dashletConfig.optionValueArr[j]);
						
					}
				}
				
				//if option not found in preferences, create default control
				if(!this.optionsGrid_data.itemsUI[i]){
					console.log("No settings in preferences for ..."+ this.optionsGrid_data.items[i].id);
					this.optionsGrid_data.itemsUI[i] = new Object();
					this.optionsGrid_data.itemsUI[i].item_id = this.optionsGrid_data.items[i].id;
					this.optionsGrid_data.itemsUI[i].item_name = this.optionsGrid_data.items[i].name;
					this.optionsGrid_data.itemsUI[i].item_desc = this.optionsGrid_data.items[i].description;
					if(this.optionsGrid_data.items[i].valueType == "numberSpinner") {
						//Ramachandran- 28-Jun-13 - Task:78497: OID review for Gauges QuickEdit - Threshold textbox change to NumberSpinner
						if(this._gaugeName == "VolumeBar" || this._gaugeName == "AnalogGauge") {
						
							if(	this.optionsGrid_data.itemsUI[i].item_id == "Informational" ||
									this.optionsGrid_data.itemsUI[i].item_id == "Normal" || 
									this.optionsGrid_data.itemsUI[i].item_id == "Minor" ||
									this.optionsGrid_data.itemsUI[i].item_id == "Major" ||
									this.optionsGrid_data.itemsUI[i].item_id == "Critical" ||
									this.optionsGrid_data.itemsUI[i].item_id == "Fatal"
									) {
								this.optionsGrid_data.itemsUI[i].item_value = new NumberSpinner({smallDelta: 1, constraints: { min: this.thMinValue, max: this.thMaxValue, places:'0,10' }});
							} else {
								this.optionsGrid_data.itemsUI[i].item_value = new NumberSpinner();
							}
							
						} else {
							this.optionsGrid_data.itemsUI[i].item_value = new NumberSpinner({smallDelta: 1, constraints: { places:'0,10' }});
						}							
					} else if(this.optionsGrid_data.items[i].valueType == "numberInput")
						this.optionsGrid_data.itemsUI[i].item_value = new TextBox();				
					else if(this.optionsGrid_data.items[i].valueType == "label"){
						//59203: TBSM 36924: QuickEdit: inconsistent display of default value in drop down list
						//Bobby, 05Dec2012, adding None as default
						var columnsArray = [{"id":"None", "name": this.nls.NONE}];
						var tempArray = [];
						dojo.mixin(columnsArray,this._datasetColumns);
						if(this.optionsGrid_data.itemsUI[i].item_id == 'MinValue' || this.optionsGrid_data.itemsUI[i].item_id == 'MaxValue') {
							for(var j=0; j<columnsArray.length; j++) {
								var type = quickEdit.dd._mapDataType(columnsArray[j].valueType);
								if(type == "status" || type == "number") {
									tempArray.push(columnsArray[j]);
								}
							}
							columnsArray = tempArray;
						}
						this.optionsGrid_data.itemsUI[i].item_value = new ComboBox({
							value: this.nls.NONE, store: new Memory({ idProperty: "id", data: columnsArray})});
							if(this.optionsGrid_data.itemsUI[i].item_id == 'MinValue') {							
								this.optionsGrid_data.itemsUI[i].item_value.onChange = dojo.hitch(this, this._thresholdMinValueChanged, this.optionsGrid_data.itemsUI[i].item_value);
								this.thMinValue = this.optionsGrid_data.itemsUI[i].item_value.getValue();
								console.debug("combo -- ", this.optionsGrid_data.itemsUI[i].item_value);
								console.debug("combo's current value - ", this.thMinValue);
							}
							if(this.optionsGrid_data.itemsUI[i].item_id == 'MaxValue') {
								this.optionsGrid_data.itemsUI[i].item_value.onChange = dojo.hitch(this, this._thresholdMaxValueChanged, this.optionsGrid_data.itemsUI[i].item_value);
								this.thMaxValue = this.optionsGrid_data.itemsUI[i].item_value.getValue();
							}
					}else if(this.optionsGrid_data.items[i].valueType == "combo"){
						if(this.optionsGrid_data.itemsUI[i].item_id == "DefaultStatus") {
							this.optionsGrid_data.itemsUI[i].item_value = new FilteringSelect({value:"Unknown", store: new Memory({ idProperty: "id", data: this.optionsGrid_data.items[i].data })});
						} else if(this.optionsGrid_data.itemsUI[i].item_id == "FontSize") {
							this.optionsGrid_data.itemsUI[i].item_value = new FilteringSelect({value:"x-small", store: new Memory({ idProperty: "id", data: this.optionsGrid_data.items[i].data}), labelAttr: "label", labelType: "html"});
						} else if(this.optionsGrid_data.itemsUI[i].item_id == "FontFamily") {
							this.optionsGrid_data.itemsUI[i].item_value = new ComboBox({value:"Arial", store: new Memory({ idProperty: "id", data: this.optionsGrid_data.items[i].data }), labelAttr: "label", labelType: "html"});
						} else if(this.optionsGrid_data.itemsUI[i].item_id == "align") {
							this.optionsGrid_data.itemsUI[i].item_value = new ComboBox({value:"Center", store: new Memory({ idProperty: "id", data: this.optionsGrid_data.items[i].data })});
						}
					}else if(this.optionsGrid_data.items[i].valueType == "checkBox") {
						this.optionsGrid_data.itemsUI[i].item_value = new CheckBox();
					} else if(this.optionsGrid_data.items[i].valueType == "ColorPicker") {
							var cp = new dijit.ColorPalette({palette: "7x10",
															 onChange: dojo.hitch(this, function(){
																	var color = cp.get('value');
																	var colorCell = cp._selectedCell;
																	if(colorCell && cp._cells[colorCell]) {
																		var colorName = cp._cells[colorCell].node.title;
																		var pickerButton = this.colorDropDown;
																		if(pickerButton) {
																			pickerButton.set("label", "<span style='color:" + color + "; position:relative;'>" + colorName + "</span>");
																			pickerButton.set("value", colorName);
																		}
																	}
																}, cp)
															});
																	
							var menu = new dijit.DropDownMenu({ style: "display: none;"});
							var defMenu = new dijit.MenuItem({
								label: this.nls.DEF_COLOR,
								onClick: dojo.hitch(this, function(){
									var pickerButton = this.colorDropDown;
									if(pickerButton) {
										pickerButton.set("label", "Default");
										pickerButton.set("value", "Default");
									}
								})
							});
							menu.addChild(defMenu);

							var colorPalleteMenu = new dijit.MenuItem({
								label: "Choose Color",
								onClick: dojo.hitch(this, function(){
													dijit.popup.open({
													popup: cp,
													around: this.colorDropDown.domNode,
													onExecute: function(){
														console.log("onExecute");
														dijit.popup.close(cp);
													},
												});})
							});
							menu.addChild(colorPalleteMenu);
							this.optionsGrid_data.itemsUI[i].item_value = new dijit.form.DropDownButton({
										label: "Select Color",
										name: "picker",
										dropDown: menu,
									});
							this.colorDropDown = this.optionsGrid_data.itemsUI[i].item_value;
					} else
						this.optionsGrid_data.itemsUI[i].item_value = new TextBox();
					
					if(this.optionsGrid_data.items[i].def)
						this.optionsGrid_data.itemsUI[i].item_value.set('value', this.optionsGrid_data.items[i].def);
				}				
			}	

			console.log("this.optionsGrid_data -->");
			console.dir(this.optionsGrid_data);			
			console.log("this.optionsGrid_data.items.length - " + this.optionsGrid_data.itemsUI.length);	
					
			this.optionsList = new TableLayout({
				items: this.optionsGrid_data.itemsUI,
				rowTemplatePath: dojo.moduleUrl("dojoe.ssd.quickedit","templates/RowLayout.html")
			},this.gaugeOptionsNode);				
			
			this.optionsList.startup();
			// anurag : 58906: TBSM 36846 : Thresholds shown for status gauge when a status property is used for the value and you edit gauge more than once
			// when QE is opened for already configured dataset, we need to explicitly check if the value is
			// configured to Status obj and accordingly hide/show thresholding.
			if(this._gaugeName == "StatusGauge") {
				for(var i in quickEdit.dd.mappingGrid_data.items) {
					if(quickEdit.dd.mappingGrid_data.items[i].id == "Value") {
						this._updateThreshold(quickEdit.dd.mappingGrid_data.itemsUI[i].item_value);
					}
				}
			}
			
			//67644
			if (quickEdit.enablePageLaunch == true) {
				for(var j=0;j<dashletConfig.optionNameArr.length;j++) {
					var name = dashletConfig.optionNameArr[j].replace("qe_optn_","");
					if(name == 'LaunchPage') {
						if(quickEdit.dd.launchPageSelect && dashletConfig.optionValueArr[j])							
							quickEdit.dd.launchPageSelect.set("value",dashletConfig.optionValueArr[j]);
						break;
					}
				}
			}
			console.log ("GaugeOptions.createOptionsGrid... END");				
		},
		
		_getConstraints: function() {
			var constraints;
			if(!isNaN(parseFloat(this.thMaxValue)) && !isNaN(parseFloat(this.thMinValue)))
				constraints = {min: parseFloat(this.thMinValue), max: parseFloat(this.thMaxValue)};
			else if(!isNaN(parseFloat(this.thMaxValue)))
				constraints = {max: parseFloat(this.thMaxValue), min:""};
			else if(!isNaN(this.thMinValue))
				constraints = {min: parseFloat(this.thMinValue), max:""};
			else
				constraints = {min: "", max:""};
			
			return constraints
		},
		
		//Ramachandran- 28-Jun-13 - Task:78499: OID review for Gauges QuickEdit - Validation to threshold values
		_thresholdMinValueChanged: function(widget) {
			console.info('_thresholdMinValeChanged');			
			if(widget.value) {
				console.debug('widget', widget.value);
				this.thMinValue = widget.value;
				
				for(i=0;i<this.optionsGrid_data.itemsUI.length;i++) {
					if(	this.optionsGrid_data.itemsUI[i].item_id == "Informational" ||
						this.optionsGrid_data.itemsUI[i].item_id == "Normal" || 
						this.optionsGrid_data.itemsUI[i].item_id == "Minor" ||
						this.optionsGrid_data.itemsUI[i].item_id == "Major" ||
						this.optionsGrid_data.itemsUI[i].item_id == "Critical" ||
						this.optionsGrid_data.itemsUI[i].item_id == "Fatal"
						) {
							this.optionsGrid_data.itemsUI[i].item_value.set('constraints', this._getConstraints());
						}
				}
			}
		},
		
		//Ramachandran- 28-Jun-13 - Task:78499: OID review for Gauges QuickEdit - Validation to threshold values
		_thresholdMaxValueChanged: function(widget) {
			console.info('_thresholdMaxValeChanged');
			console.debug('widget', widget.value);
			if(widget.value) {
				console.debug('widget', widget.value);
				this.thMaxValue = widget.value;
				
				for(i=0;i<this.optionsGrid_data.itemsUI.length;i++) {
					if(	this.optionsGrid_data.itemsUI[i].item_id == "Informational" ||
						this.optionsGrid_data.itemsUI[i].item_id == "Normal" || 
						this.optionsGrid_data.itemsUI[i].item_id == "Minor" ||
						this.optionsGrid_data.itemsUI[i].item_id == "Major" ||
						this.optionsGrid_data.itemsUI[i].item_id == "Critical" ||
						this.optionsGrid_data.itemsUI[i].item_id == "Fatal"
						) {
							this.optionsGrid_data.itemsUI[i].item_value.set('constraints', this._getConstraints());
						}
				}
			}
		},
		
		getQuickEditOptionsString: function () {	
			console.info("In getQuickEditOptionsString");
			// Check if Labels are Custom
			for(i=0;i<this.optionsGrid_data.itemsUI.length;i++) {
				if(this.optionsGrid_data.itemsUI[i].item_id == "TopLabel" || this.optionsGrid_data.itemsUI[i].item_id == "LeftLabel" || this.optionsGrid_data.itemsUI[i].item_id == "MinValue" || this.optionsGrid_data.itemsUI[i].item_id == "MaxValue") {
					var valueSet = "";
					//59203: TBSM 36924: QuickEdit: inconsistent display of default value in drop down list
					//Bobby, 05Dec2012, adding None as default
					if(this.optionsGrid_data.itemsUI[i].item_value.get('value') != this.nls.NONE){
						valueSet = this.optionsGrid_data.itemsUI[i].item_value.get('value');
					}	
					if(valueSet) {
						for(var j=0;j<this._datasetColumns.length;j++) {
							console.debug("Matching with : "+this._datasetColumns[j].id);
							if(this._datasetColumns[j].name == valueSet) {
								this.optionsGrid_data.itemsUI[i].item_value.set('value', this._datasetColumns[j].id);
								if(this.optionsGrid_data.itemsUI[i].item_id == "TopLabel")
									this._topLabelCustom = "false";
								else if(this.optionsGrid_data.itemsUI[i].item_id == "LeftLabel")
									this._leftLabelCustom = "false";
								break;
							}
						}						
					}
				}
			}
			
			var quickEditOptions="";							
			
			for(var i=0;i<this.optionsGrid_data.itemsUI.length;i++){
				var valueSet = "";				
				//59203: TBSM 36924: QuickEdit: inconsistent display of default value in drop down list
				//Bobby, 05Dec2012, adding None as default
				if(this.optionsGrid_data.itemsUI[i].item_value.get('value') != this.nls.NONE){
					valueSet = this.optionsGrid_data.itemsUI[i].item_value.get('value');
				}				
				//anurag: 03Sep2012, sending NaN creates issues
				if(valueSet == this.nls.NONE || valueSet.toString() == "NaN"){ 	
					quickEditOptions = quickEditOptions + 
										"&qe_optn_"+this.optionsGrid_data.itemsUI[i].item_id+
										"=";
				}else {
					valueSet = escape(escapeHTML(valueSet));
					console.info(this.optionsGrid_data.itemsUI[i].item_id+" : "+ valueSet );
					quickEditOptions = quickEditOptions + 
											"&qe_optn_"+this.optionsGrid_data.itemsUI[i].item_id+
											"="+valueSet;
				}
			}
			
			// Add the label flags to quickEditOptions
			quickEditOptions = quickEditOptions +
								"&qe_optn_TopLabelCustom="+this._topLabelCustom;
								
			quickEditOptions = quickEditOptions +
								"&qe_optn_LeftLabelCustom="+this._leftLabelCustom;
			
			if(quickEdit.dd.richHoverCheckBox){
				 if(quickEdit.dd.richHoverCheckBox.get('checked')){
					quickEditOptions = quickEditOptions + "&qe_optn_UIPreview=true"
				}else quickEditOptions = quickEditOptions + "&qe_optn_UIPreview="+ quickEdit.dd.richHoverCheckBox.get('checked');	 
			}
			//67644
			if(quickEdit.enablePageLaunch == true && quickEdit.dd.launchPageSelect){
				quickEditOptions = quickEditOptions + "&qe_optn_LaunchPage="+quickEdit.dd.launchPageSelect.get('value');			
			}
			
			//Richa- 36760: [CUST/BP] [Accuoss]Allow me to enable my own hover over a widget (non-OSLC)
			//if(quickEdit.dd.customRichHoverURL.value != "" ){
				quickEditOptions = quickEditOptions + "&qe_optn_CustomHoverURL="+quickEdit.dd.customRichHoverURL.value;
				quickEditOptions = quickEditOptions + "&qe_optn_CustomHoverTitle="+quickEdit.dd.customRichHoverShortTitle.value;
				quickEditOptions = quickEditOptions + "&qe_optn_CustomHoverHeight="+quickEdit.dd.customRichHoverHeight.get('value');
				quickEditOptions = quickEditOptions + "&qe_optn_CustomHoverWidth="+quickEdit.dd.customRichHoverWidth.get('value');
				quickEditOptions = quickEditOptions + "&qe_optn_CustomHoverUnit="+quickEdit.dd.customRichHoverUnit.get('value');
			//}
			console.info("	quickEditOptions is "+quickEditOptions);				
			return quickEditOptions;
		},
		
		setQuickEditOptionsString : function(optionsArray) {
			console.debug("In setQuickEditOptionsString");
			console.debug("optionsArray", optionsArray);
			console.debug("this.optionsGrid_data ....", this.optionsGrid_data);
			var _optionsValueArray = new Array();
			for(var j=1;j<optionsArray.length;j++) {
				var tempArray = optionsArray[j].split("=");
				_optionsValueArray.push({name : tempArray[0].slice(8), value : tempArray[1]});
			}
			console.debug("_optionsValueArray..",_optionsValueArray);
			for(i=0;i<this.optionsGrid_data.itemsUI.length;i++) {
				for(var k=0;k<_optionsValueArray.length;k++) {
					if(this.optionsGrid_data.itemsUI[i].item_id == _optionsValueArray[k].name) {
						if(this.optionsGrid_data.itemsUI[i].item_id == "ColorPicker") {
							if(_optionsValueArray[k].value!= "Default") {
									var color = _optionsValueArray[k].value;
									color = unescape(color);
									color = color.replace(/\s+/g, '');
									this.optionsGrid_data.itemsUI[i].item_value.set("label", "<span style='color:" + dojo.colorFromString(color) + "; position:relative;'>" + unescape(_optionsValueArray[k].value) + "</span>");
									this.optionsGrid_data.itemsUI[i].item_value.set("value", unescape(_optionsValueArray[k].value));
								} else {
									this.optionsGrid_data.itemsUI[i].item_value.set("label",  _optionsValueArray[k].value);
									this.optionsGrid_data.itemsUI[i].item_value.set("value", _optionsValueArray[k].value);
								}
						} else {
							this.optionsGrid_data.itemsUI[i].item_value.set('value', unescape(_optionsValueArray[k].value));
						}
					
					}
				}
			}
		},
		  
		validate: function() {
			var maxValue, minValue, majorTicks, minorTicks, defaultStatus;
			var allThresholds = [];
			for(i=0;i<this.optionsGrid_data.itemsUI.length;i++) {
				if(this.optionsGrid_data.items[i].valueType == "number" && this.optionsGrid_data.itemsUI[i].item_value.getValue() === undefined) {
					var msgDialog = new dojoe.messagedialog.MessageDialog({namespace: portletId+'_tsErrMsg', message: quickEdit.quickEditCCS.nls.MSGDIALOG_OPTIONAL_DATASET_INVALID_PARAMS});
					msgDialog.show();
					return false;
				}
				if(this.optionsGrid_data.itemsUI[i].item_id == "MajorTicksSeparation") {
					majorTicks = parseFloat(this.optionsGrid_data.itemsUI[i].item_value.getValue());
				} else if(this.optionsGrid_data.itemsUI[i].item_id == "MinorTicksSeparation") {
					minorTicks = parseFloat(this.optionsGrid_data.itemsUI[i].item_value.getValue());
				} else if(this.optionsGrid_data.itemsUI[i].item_id == "MaxValue") {
					maxValue = this.optionsGrid_data.itemsUI[i].item_value.getValue();
				} else if(this.optionsGrid_data.itemsUI[i].item_id == "MinValue") {
					minValue = this.optionsGrid_data.itemsUI[i].item_value.getValue();
				} else if(	this.optionsGrid_data.itemsUI[i].item_id == "Informational" ||
							this.optionsGrid_data.itemsUI[i].item_id == "Normal" || 
							this.optionsGrid_data.itemsUI[i].item_id == "Minor" ||
							this.optionsGrid_data.itemsUI[i].item_id == "Major" ||
							this.optionsGrid_data.itemsUI[i].item_id == "Critical" ||
							this.optionsGrid_data.itemsUI[i].item_id == "Fatal"
							) {
					allThresholds.push(this.optionsGrid_data.itemsUI[i].item_value.getValue());
				} else if(this.optionsGrid_data.itemsUI[i].item_id == "DefaultStatus") {
					defaultStatus = this.optionsGrid_data.itemsUI[i].item_value.getValue();
				}
			}
			//maxValue, minValue, majorTicks, minorTicks;
			if(defaultStatus == "") {
				var msgDialog = new dojoe.messagedialog.MessageDialog({namespace: portletId+'_tsErrMsg', message: this.nls.MSGDIALOG_GAUGES_INVALID_NO_DATA_STATUS});
				msgDialog.show();
				return false;
			}
				
			if(!maxValue)
				maxValue = 100;
			if(!minValue)
				minValue = 0;
				
			for(var index in allThresholds) {
				var value = allThresholds[index];
				if(value === undefined) {
						var msgDialog = new dojoe.messagedialog.MessageDialog({namespace: portletId+'_tsErrMsg', message: this.nls.MSGDIALOG_GAUGES_INVALID_EXPONENT});
						msgDialog.show();
						return false;
				}
			}
			
			if(!isNaN(maxValue) && !isNaN(minValue) && parseFloat(maxValue) <= parseFloat(minValue)) {
				var msgDialog = new dojoe.messagedialog.MessageDialog({namespace: portletId+'_tsErrMsg', message: this.nls.MSGDIALOG_GAUGES_INVALID_RANGE});
				msgDialog.show();
				return false;
			}
			if(!isNaN(maxValue) && !isNaN(minValue) && ((majorTicks && (parseFloat(maxValue)-parseFloat(minValue))/majorTicks > 100) || (minorTicks && (parseFloat(maxValue)-parseFloat(minValue))/minorTicks > 100))) {
				var msgDialog = new dojoe.messagedialog.MessageDialog({namespace: portletId+'_tsErrMsg', message: this.nls.MSGDIALOG_GAUGES_TICKS_INVALID_PARAMS});
				msgDialog.show();
				return false;
			}
			if((this._gaugeName == "VolumeBar" || this._gaugeName == "AnalogGauge") && !isNaN(maxValue) && !isNaN(minValue)) {
				for(var index in allThresholds) {
					if(allThresholds[index] > parseFloat(maxValue) || allThresholds[index] < parseFloat(minValue)) {
						var msgDialog = new dojoe.messagedialog.MessageDialog({namespace: portletId+'_tsErrMsg', message: this.nls.MSGDIALOG_GAUGES_GREATER_THAN_MAX});
						msgDialog.show();
						return false;
					}
				}
			}
			var maxValueOptionFound = false;
			var minValueOptionFound = false;
			for(var k=0; k<this._datasetColumns.length; k++) {
				var type = quickEdit.dd._mapDataType(this._datasetColumns[k].valueType);
				if(type == "status" || type == "number") {
					if(this._datasetColumns[k].name == minValue)
						minValueOptionFound = true;
					else if(this._datasetColumns[k].name == maxValue)
						maxValueOptionFound = true;
				}
			}
			if(isNaN(maxValue)) {
				if(!maxValueOptionFound) {
					var msgDialog = new dojoe.messagedialog.MessageDialog({namespace: portletId+'_tsErrMsg', message: this.nls.MSGDIALOG_INVALID_MIN_MAX});
					msgDialog.show();
					return false;
				}
			}
			
			if(isNaN(minValue)) {
				if(!minValueOptionFound) {
					var msgDialog = new dojoe.messagedialog.MessageDialog({namespace: portletId+'_tsErrMsg', message: this.nls.MSGDIALOG_INVALID_MIN_MAX});
					msgDialog.show();
					return false;
				}
			}
			
			return true;
		},
		
		destroy: function () {
			if(this.optionsGridNode){
				if(this.optionsGridNode.destroyRecursive) 
					this.optionsGridNode.destroyRecursive();
				else if (this.optionsGridNode.destroy) 
					this.optionsGridNode.destroy();
			}
			this.inherited(arguments);		
		}		
	});
});
