require({cache:{
'url:dojoe/ssd/quickedit/templates/SmartTextMapper.html':"<div style=\"height:100%;width:100%;\"> \r\n\t<b class=\"label\" data-dojo-attach-point=\"mappingGridLabel\">${nls.SMARTTEXT_REQUIRED_ATTRIBUTES_LABEL}</b><br/>\t\r\n\t<!-- <div id=\"${id}_mappingGridContainer\" data-dojo-attach-point=\"mappingGridNode\" style=\"height:100%;width:100%;\"> -->\r\n\t\t<table style=\"height:100%;width:100%;\">\r\n\t\t\t<tr style=\"background: inherit;font-weight:bold;\">\r\n\t\t\t\t<td>\r\n\t\t\t\t\t<div id=\"valueEditor\" data-dojo-attach-point='smart_text_editor_container'> </div>\r\n\t\t\t\t</td> \r\n\t\t\t\t<td style=\"vertical-align: top;\" class=\"smartText\">\t\t\t\t\t\r\n\t\t\t\t\t<div data-dojo-attach-point=\"listBuilderContainer\" class=\"listBuilder\"></div>\r\n\t\t\t\t</td>\r\n\t\t\t</tr>\r\n\t </table>\t\r\n\t<!-- </div> -->\r\n</div>"}});
/*********************************************************** {COPYRIGHT-TOP} ***
* Licensed Materials - Property of IBM
* Tivoli Widget Library
*
* (C) Copyright IBM Corp. 2014.  All Rights Reserved.
*
* US Government Users Restricted Rights - Use, duplication, or
* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
************************************************************ {COPYRIGHT-END} **/
define("dojoe/ssd/quickedit/SmartTextMapper", [
	"dojo/_base/declare",
	"dojo/_base/lang",
	"dijit/_WidgetBase",
	"dijit/_TemplatedMixin",
	"dijit/_WidgetsInTemplateMixin",
	"dojo/text!./templates/SmartTextMapper.html",
	"dojoe/tablelayout/TableLayout",
	'dijit/form/TextBox',
	"dijit/form/FilteringSelect",
	"dojo/store/Memory",
	"dojo/i18n!./nls/SmartTextOptions",
	"dijit/Editor",
	"dijit/_editor/plugins/LinkDialog",
	"dijit/_editor/plugins/ViewSource",
	"dijit/_editor/plugins/FontChoice",
	"dijit/_editor/plugins/TextColor",
	"dijit/_editor/plugins/EnterKeyHandling",
	"dijit/_editor/plugins/TabIndent",
	"dojox/editor/plugins/TablePlugins",
	"dojox/editor/plugins/ResizeTableColumn",
	"dojoe/text/ssd/ToggleDirection",
	"ibm/tivoli/tip/dijit/DndListbox",
	"dijit/Menu",
	"dijit/MenuItem",
	"dojo/dom"
], function (declare,lang,_WidgetBase, _TemplatedMixin, _WidgetsInTemplateMixin, template, TableLayout,TextBox,FilteringSelect,Memory, nlsBundle, Editor, LinkDialog, ViewSource, FontChoice, TextColor, EnterKeyHandling, TabIndent, TablePlugins, ResizeTableColumn, ToggleDirection, DndListbox, Menu, MenuItem, dom) {
	 return declare("dojoe.ssd.quickedit.SmartTextMapper", [_WidgetBase, _TemplatedMixin, _WidgetsInTemplateMixin], {
		templateString: template,
		mappingGrid_data: null,
		columns: null,
		nls:nlsBundle,
		contextMenu: null,
		contextMenuItem: null,
		selectedListItem: null,

		constructor: function (mappingGrid_data, columns) {
			//lang.mixin (this, props);
			this.mappingGrid_data = mappingGrid_data;
			this.columns = columns;
		},
		
		postCreate: function() {
			console.log ("SmartTextMapper.postCreate... BEGIN");
			console.info('attrValueArr:'+attrValueArr);
			
			this.smart_text_editor = new Editor({
						value: (attrValueArr[0]) ? unescapeHTML(unescape(attrValueArr[0])) : '',
						//height: '100%',	
						textDir: this.textDir,
						extraPlugins: [
							'toggleDir',
							'createLink', 'unlink', 'insertImage', //LinkDialog
							'viewsource', //ViewSource
							'fontName', 'fontSize', 'formatBlock', //FontChoice
							'foreColor', 'hiliteColor', //TextColor
							{name: 'insertTable'},
							{name: 'modifyTable'},
							{name: 'insertTableRowBefore'},
							{name: 'insertTableRowAfter'},
							{name: 'insertTableColumnBefore'},
							{name: 'insertTableColumnAfter'},
							{name: 'deleteTableRow'},
							{name: 'deleteTableColumn'},
							{name: 'colorTableCell'},
							{name: 'tableContextMenu'}
						]
					}, this.smart_text_editor_container);
			
			var editorPersistedValue = this.smart_text_editor.get('value');
			var directionAutoSpan=/<span twl="true" dir="auto">/g;
			var directionltrSpan='<span dir="ltr" twl="true">';
			editorPersistedValue = editorPersistedValue.replace(directionAutoSpan,directionltrSpan);
			this.smart_text_editor.setValue(editorPersistedValue);
			this.smart_text_editor.startup();
			
			this.listDnDWidget = new DndListbox({id: this.id+"nameList", showAllButtons : true, filtered : true, 
														sorted : false, accept : "name", type:"name" ,
														leftLabel : this.nls.LEFTLABEL});
			this.listBuilderContainer.appendChild(this.listDnDWidget.domNode);
			this.listDnDWidget.startup();
			
			this.smart_text_editor.focus();
			
			dojo.connect(this.listDnDWidget, 'onClick', lang.hitch(this, "insertColId"));	
			//38268 - Using scrollBox as domnode results in callback even for the keystrokes in the filter box which is not right
			dojo.connect(this.listDnDWidget._scrollBox, 'onkeyup', lang.hitch(this, "insertColId"));						
			//dojo.connect(this.listDnDWidget.domnode, 'onkeyup', lang.hitch(this, "insertColId"));			
			dojo.connect(this.listDnDWidget.domNode, 'oncontextmenu', lang.hitch(this, "onContextMenu"));			
			
			this.contextMenu = new Menu({id: this.id+'contextmenu', targetNodeIds: [this.listDnDWidget.domNode]});
			this.contextMenuItem = new MenuItem({id: this.id+'contextmenuItem', label: 'Add with format'});
			this.contextMenu.addChild(this.contextMenuItem);
			
			dojo.connect(this.contextMenuItem.domNode, 'onclick', lang.hitch(this, 'insertColIdWithFormat'));
			dojo.connect(this.contextMenuItem.domNode, 'onkeyup', lang.hitch(this, 'insertColIdWithFormat'));
			
			console.log ("SmartTextMapper.postCreate... END");
		},
				
		onContextMenu: function(event) {
			console.info('showContextMenu*****');
			console.debug('event', event);
			
			if(event.target.title)
				this.selectedListItem = event.target.title;
			else
				this.selectedListItem = event.target.parentNode.title;		

			console.debug('this.selectedListItem', this.selectedListItem);
		},
		
		insertColId: function(event) {
			console.info('insertColId');
			console.debug(event);			
			
			if(event.keyCode) {
				console.info('key pressed....');
				if(event.keyCode == dojo.keys.SPACE || event.keyCode == dojo.keys.ENTER) {
					if(event.target.attributes.dojoattachpoint === undefined || !(event.target.attributes.dojoattachpoint.value == '_filterInput')) {
						var selectedColId = event.target.title;
						console.info('selectedColId:'+selectedColId);
						if(selectedColId) {
							selectedColId = selectedColId.substring(selectedColId.lastIndexOf('(')+1, selectedColId.lastIndexOf(')'));
							/*38268 - If you do not set focus, the inserthtml wont work.This is needed by dijit/editor to insert via exec command.
							Once the focus is moved to editor, you have to come back again to the list to continue selection rest columns so I 
							am setting focus back to the list.However it is working for FF but not for IE/Chrome, so in case on IE the user would 
							have to tab again and select the new column.SetValue works fine for all browser without setting focus to editor but 
							I cannot use it as it will only overwrite so it can be easily used to append but not insert.Will check later on common 
							fix if possible.*/
							this.smart_text_editor.focus();	
							this.smart_text_editor.execCommand('inserthtml', '<span dir="ltr" twl="true">${'+selectedColId+'}</span>');	
							this.listDnDWidget.focusedItem.focus();	
						}
					}
				}
			}

			if(event.type == 'click') {
				console.info('mouse clicked');
				if(event.target.attributes.dojoattachpoint === undefined || !(event.target.attributes.dojoattachpoint.value == '_filterInput')) {
					var selectedColId = event.target.value;
					console.info('selectedColId:'+selectedColId);
					if(selectedColId) {
						selectedColId = selectedColId.substring(selectedColId.lastIndexOf('(')+1, selectedColId.lastIndexOf(')'));
						this.smart_text_editor.focus();
						this.smart_text_editor.execCommand('inserthtml', '<span dir="ltr" twl="true">${'+selectedColId+'}</span>');
					}
				}
			}
		},
		
		insertColIdWithFormat: function(event) {
			console.info('insertColIdWithFormat');
			console.debug('event', event);
			console.debug('event', event.type);
			
			var selectedColId = this.selectedListItem;			
			console.debug('selectedColId', selectedColId);
			
			this.smart_text_editor.focus();
			
			if(selectedColId) {
				var colId = selectedColId.substring(selectedColId.lastIndexOf('(')+1, selectedColId.lastIndexOf(')'));
				var colIdType = selectedColId.substring(selectedColId.lastIndexOf(':')+1, selectedColId.length);
				console.info('colIdType'+colIdType);
				
				var formatType = '';
				var formatPattern = '';
				if(colIdType.match(/^(byte|short|int|long|float|double|ubyte|ushort|uint|ulong|percentage|decimal)$/)) {
					formatType = '\"dojoNumber\"';
				} else if(colIdType.match(/^(date|time|datetime|isodate|isotime|isodatetime)$/)) {
					formatType = '\"dojoDate\"';
				} else if(colIdType == 'status') {
					formatType = '\"dashStatus\"';
				} 
				
				if(formatType) {
					this.smart_text_editor.execCommand('inserthtml', '<span dir="ltr" twl="true">${'+colId+'%{"formatTag":'+formatType+'}}</span>');
				} else {
					this.smart_text_editor.execCommand('inserthtml', '<span dir="ltr" twl="true">${'+colId+'}</span>');
				}
			}
		},

		createMappingGrid: function () {
			console.log ("SmartTextMapper.createMappingGrid... BEGIN");
			
			var datasetAttribs = new Array();
			var datasetAttribsTemp = new Array();

			for (i=0;i<this.columns.length;i++){
				//exclude hidden columns from dataset				
				if(!this.columns[i].isHidden())
					datasetAttribsTemp.push({
						'value': this.columns[i].getId(), 
						'label': this.columns[i].getLabel(), 
						'valueType': this.columns[i].getValueType()
					});
			}
			//sort the dataset columns
			datasetAttribsTemp.sort(function(a, b){
				if (a.label < b.label) //sort string ascending
					return -1;
				if (a.label > b.label)
					return 1;
				return 0; //default return value (no sorting)
			});

			datasetAttribs = datasetAttribs.concat(datasetAttribsTemp);

			console.info("datasetAttribs..");
			console.dir(datasetAttribs);
			console.info('dashletConfig:');
			console.dir(dashletConfig);
			
			var listWidgetData = new Array();
			
			for(i=0;i<datasetAttribs.length;i++) {
				var dataType = datasetAttribs[i].valueType;
				console.debug('dataType', dataType);
				if(dataType.indexOf('[]') == -1 && dataType != 'map' && dataType != 'enum') {
					listWidgetData.push(datasetAttribs[i].label+'('+datasetAttribs[i].value+'):'+datasetAttribs[i].valueType);
				}				
			}			
			this.listDnDWidget.addData(listWidgetData);				
			
			console.info("mappingGrid_data..");
			console.dir(this.mappingGrid_data);
			
			console.log ("SmartTextMapper.createMappingGrid... END");
		},

		//This is expected out of any Custom Mapping widget
		//QuickEditController.js looks for this method to get current UI state when 'OK' is pressed
		//This value is stored in prefrences and View JSP retrieves from there
		getQuickEditMappingString: function () {
			var quickEditMapping="";
			console.info('smartText from editor:'+this.smart_text_editor.get('value'));
			var editorValue = this.smart_text_editor.get('value');
			
			var txtDir = this.smart_text_editor._currentDir? this.smart_text_editor._currentDir : "ltr";
			var pureText = editorValue.replace(/<[^<]*>/g,"").replace(/\s/g,"");
			var directionltrSpan=/<span dir="ltr" twl="true">/g;
			var directionAutoSpan='<span twl="true" dir="auto">';
			
			if (pureText != ""){
				editorValue = "<div class=\"TextSkin\" style=\"width:100%;\" dir=\""
				+ txtDir + "\">" + editorValue + "</div>";
				editorValue = editorValue.replace(directionltrSpan,directionAutoSpan);
			} 
			
			editorValue = escape(editorValue);
			console.info('smartText from editor:'+editorValue);
			
			quickEditMapping = "&qe_attr_smartTextEditorValue="+encodeURIComponent(editorValue);			
			
			return quickEditMapping;
		},

		destroy: function () {
			if(this.listBuilderContainer){
				if(this.listBuilderContainer.destroyRecursive) this.listBuilderContainer.destroyRecursive();
				else if (this.listBuilderContainer.destroy) this.listBuilderContainer.destroy();
			}
			this.inherited(arguments);
		}
	});
});
