/*
 * Licensed Materials - Property of IBM
 *
 * OCO Source Materials
 *
 * Restricted Materials of IBM
 *
 * Copyright IBM Corp. 2014 All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or 
 * disclosure restricted by GSA ADP Schedule Contract with 
 * IBM Corp. 
 */
define("dojoe/tablex/plugins/_MapToModules", ["dojo/_base/declare",
		"dojo/_base/array",
        "dojo/_base/lang",
    	"dojo/dom-class",
    	"dojo/dom-geometry",
    	"dojo/_base/query",
    	"dojo/window",
    	"dojo/dom-style",
		"gridx/modules/Body",
		"gridx/modules/Header",
//		"gridx/modules/VirtualVScroller", // 69711: Failed to Load Data! error in Table. Removing default load of VirtualVScroller Module.
		"gridx/modules/TouchVScroller", // 54839
		"gridx/modules/Focus",
		"gridx/modules/ColumnResizer",
		"gridx/modules/SingleSort",
		"gridx/modules/select/Row",
		"gridx/modules/select/Cell",
		"gridx/modules/select/Column",
		"gridx/modules/extendedSelect/Cell",
		"gridx/modules/extendedSelect/Row",
		"gridx/modules/extendedSelect/Column",
		"gridx/modules/RowHeader",
		"gridx/modules/IndirectSelect",
		"gridx/modules/SummaryBar",
		"gridx/modules/Pagination",
		"gridx/modules/pagination/PaginationBar",
		"gridx/modules/pagination/PaginationBarDD",
		"gridx/modules/NestedSort",
		"gridx/modules/dnd/_Dnd",
		//"gridx/modules/move/Cell",
		//"gridx/modules/dnd/Cell",
		"gridx/modules/move/Column",
		"gridx/modules/move/Row",
		"gridx/modules/dnd/Row",
		"gridx/modules/dnd/Column",
		"gridx/modules/Filter",
		"gridx/modules/filter/FilterBar",
		"gridx/modules/Menu",
		//45839: TWL 3.2.0.0 : Table View, Export/Print options in Actions drop down do not launch
		//"gridx/support/exporter/exporter",
		//"gridx/support/exporter/toTable",
		//"gridx/support/printer",
		//"gridx/support/exporter/toCSV",
		"gridx/modules/HLayout",
		"gridx/modules/VLayout",
		"gridx/modules/ColumnWidth",
		"gridx/modules/HiddenColumns"
	//	"dojoe/tablex/plugins/IndirectSelection"	
	], function (declare, array, lang, domClass, domGeometry, query, window, 
	domStyle, body, header, /* virtualVScroller,*/ touchVScroller, focus, columnResizer, singleSort, selectRow, selectCell, selectColumn, extSelCell, extSelRow, extSelColumn,
	rowHeader, indirectSelect, SummaryBar, pagination, paginationBar, paginationBarDD, nestedSort,_Dnd, /*MoveCell, DndCell,*/  
	 moveColumn, moveRow, dndRow, dndColumn, filter, filterBar, menu, 
	 //exporter, exportTable, printer, exportCSV, 
	 HLayout, VLayout, ColumnWidth , HiddenColumns /* ,IndirectSelection*/) {
	
		var forEach = array.forEach;
		var indirect = false;
		
		var mapToModules = declare("dojoe.tablex.plugins._MapToModules",[], {
			_modules: [],
			_coreModules: [
							header,
							body,
							/*LS - 11/15/2012
							 * 57652: Tablex Compatible view: Delete all rows not working on FF
							 * 57651: Tablex compatible view: Add row does not work for Virtual scroll table 
							 * VirtualVScroller doScroll interferes with delete rows and add rows on the gridx causing rendering issues
							 * Setting lazy true and some timeout will fix the issue and also helps to reduce no of calls in case of huge datasets
							 * since frequent data cals are avoided in case of serverside data fetches*/
							  // Latha: 69711: Failed to Load Data! error in Table. Removing default load of VirtualVScroller Module. It should be loaded when pagination is disabled.
					//		{moduleClass: virtualVScroller, lazy: true, lazyTimeout: 200},
							focus,
							columnResizer,
							singleSort,
							//Latha: 05 Oct 2012 : Desired Selection Behavior broken in TWL 1.0.2 : removing ExtSelectCell as this module disturbs row selection.
					//		extSelCell,
							//Latha: 07 Nov 2012: Selection mode is single by default according OID, so removing ExtendSelectRow from core modules
					//		extSelRow,
					//		extSelColumn,
					//		rowHeader,
							//LS - 10/6/12 : modules to enable setting column width in the layout
							// Please do not set last column width in the layout so that it defaults to "auto" occupying the remaining space in the grid
							HLayout,
							VLayout,
							ColumnWidth,
							SummaryBar, // 55027 - Defaults for Table Widget
							filter, // 55027 - Defaults for Table Widget
							filterBar, // 55027 - Defaults for Table Widget
							HiddenColumns
						 ],
			// 55027 - Defaults for Table Widget
			_mobileCoreModules: [ 
									header, 
									body, 
									//61872
									//{moduleClass: virtualVScroller, lazy: true, lazyTimeout: 200},
									touchVScroller, // 54839
									focus,
									singleSort,
									//61872
									//extSelRow, 
									HLayout, 
									VLayout,
									ColumnWidth,									
									filter									
								],
			_plugins: null,
			
			//54839
			_mobileMode: false,
			
			//54839
			_setMobileMode: function (isMobile) {
				this._mobileMode = isMobile;
			},

			_convertToModules: function (/*gridparams.plugins object*/plugins) {
				this._modules = [];
				//54839
				if(this._mobileMode)
					this._modules = this._modules.concat(this._mobileCoreModules);
				else
					this._modules = this._modules.concat(this._coreModules);
				
				for(var key in plugins) {
					if (plugins.hasOwnProperty(key)) {						
						switch(key){
							case "indirectSelection" :
								if( plugins[key]!= false){
									indirect = true;
									this._mapIndSelectAttrs(plugins[key]);
								}else {
								//Latha : 59486: TWL 1.1 : Table Dashlet, not able to select a row when Row Selection Type is changed from Indirect to Direct
								//Making indirect false when indirect selection is disabled.
									indirect = false;
								}
								break;
							case "pagination" :
								if( plugins[key]!= false){
									this._mapPaginationAttrs(plugins[key]);
								}
								break;
							case "dnd" :
								if( plugins[key]!= false){
									this._mapDnDAttrs(plugins[key]);
								}
								break;
							case "sortFields" :
								//@189518 handled by nestedSorting plugin, TWL could probably combine
								break;
							case "nestedSorting" :
								if( plugins[key]!= false){
									this._mapNestedSortingAttrs(plugins[key], plugins["sortFields"]);	//@189518
								} else {
									this._mapSingleSortAttrs(plugins["sortFields"]);					//@189518					
								}
								break;
							case "filter" :
								if( plugins[key]!= false){
									this._mapFilterAttrs(plugins[key]);
								}
								break;
							case "menus" :
								if( plugins[key]!= false){
									this._mapMenuAttrs(plugins[key]);
								}
								break;
							//45839: TWL 3.2.0.0 : Table View, Export/Print options in Actions drop down do not launch
							case "printer" :
								if( plugins[key]!= false){
									// this._mapPrinterAttrs(plugins[key]);
									console.info("printer module changed to support method" );
								}
								break;
							case "exporter" :
								if( plugins[key]!= false){
									// this._mapExporterAttrs(plugins[key]);
									console.info("exporter module changed to support method" );
								}
								break;
							case "selector" :
								if( plugins[key]!= false){
									this._mapSelectorAttrs(plugins[key]);
								}
								break;
							default: console.error('Plugin not supported: '+ key );
						}						
					}
				}
				return this._modules;				
			},
			
			_getCoreModules: function (){
				//Latha: 07 Nov 2012: Removing this as if selection is none select row module should not be passed by default.
				//this._coreModules.push({moduleClass: selectRow, triggerOnCell: true, multiple: false});	// 55027 - Defaults for Table Widget			
				return this._coreModules;
			},
			
			// 55027 - Defaults for Table Widget
			_getMobileCoreModules: function (){
				//61872
				//this._mobileCoreModules.push({moduleClass: selectRow, triggerOnCell: true, multiple: false});
				return this._mobileCoreModules;
			},
			
			_mapIndSelectAttrs: function (pluginObj){
				//61872
				if(this._mobileMode) {
					var mdIndex = array.indexOf(this._mobileCoreModules, extSelRow);
					if(mdIndex != -1)
						this._mobileCoreModules.splice(mdIndex, 1);					
				}
				else {
					var mdIndex = array.indexOf(this._coreModules, extSelRow);
					if(mdIndex != -1)
						this._coreModules.splice(mdIndex, 1);
				}
				var rowSelectMod = {moduleClass: extSelRow, triggerOnCell: false};				
				var rowHeaderMod = {moduleClass: rowHeader};
				var indSelMod = {moduleClass: indirectSelect};
				//var indSelPlugin = {moduleClass: IndirectSelection};
				if(lang.isObject(pluginObj)){
					if(pluginObj.headerSelector == true){
						indSelMod.all = true;
					}
					if(pluginObj.multiple == false){
						rowSelectMod = {moduleClass: selectRow, triggerOnCell: false};
						rowSelectMod.multiple = false;
					}
				}
				this._modules.push(rowSelectMod,rowHeaderMod,indSelMod);	
			},
			// Latha : 23 Nov 2012 : 56453: TWL 1.1 : Table dashlet row is selected on click in any cell when Row Selection type is ' Indirect, Select via selector column only '
			// Making triggerOnCell false if IndirectSelection is enabled. 
			_mapSelectorAttrs: function(pluginObj) {
				//61872
				if(this._mobileMode) {
					var mdIndexSelRow = array.indexOf(this._mobileCoreModules, extSelRow);
					if(mdIndexSelRow != -1)
						this._mobileCoreModules.splice(mdIndexSelRow, 1);
				} else {
					var mdIndexSelRow = array.indexOf(this._coreModules, extSelRow);
					if(mdIndexSelRow != -1)
						this._coreModules.splice(mdIndexSelRow, 1);
				}
				if(indirect) {
					var selectRowMod = {moduleClass: extSelRow, triggerOnCell: false};
				} else {
					var selectRowMod = {moduleClass: extSelRow, triggerOnCell: true};
					var selectCellMod = {moduleClass: extSelCell};
					var selectColumnMod = {moduleClass: extSelColumn};
				}				
				
				if(lang.isObject(pluginObj)){
					if(pluginObj.row == "single"){
						if(indirect) {
							selectRowMod = {moduleClass: selectRow, triggerOnCell: false};
						} else {
							selectRowMod = {moduleClass: selectRow, triggerOnCell: true};
						}
						selectRowMod.multiple = false;
					}
					if(pluginObj.cell == "single"){
						if(!indirect) {
							selectCellMod = {moduleClass: selectCell, triggerOnCell: true};
						}
					}
					if(pluginObj.col == "single"){
						if(!indirect) {
							selectColumnMod = {moduleClass: selectColumn, triggerOnCell: true};
						}
					}					
				}
				if( pluginObj.col !== undefined && pluginObj.col != "disabled" ){
					this._modules.push(selectColumnMod);
					
				}
				if(pluginObj.cell !== undefined && pluginObj.cell != "disabled" ){
					this._modules.push(selectCellMod);
				}
				if(pluginObj.row !== undefined && pluginObj.row != "disabled" ){
					this._modules.push(selectRowMod);					
				}				
			},
			
			//52510 : Disabling Row DnD until sort=order parameter in query is handled correctly.
			_mapDnDAttrs: function (){
				this._modules.push(
						{moduleClass: _Dnd}, 
						{moduleClass: extSelColumn},
					//	{moduleClass: MoveCell}, 
						{moduleClass: moveColumn},
					//	{moduleClass: moveRow}, 
					//	{moduleClass: DndCell},
					//	{moduleClass: dndRow},
						{moduleClass: dndColumn}
				);
			},
			
			_mapPaginationAttrs: function (pluginObj){
				var baseMod = {moduleClass: pagination};
				var paginationMod = {moduleClass: paginationBar};
				// 55029 - Default for Table Dashlet
				var summaryBarMod = {moduleClass: SummaryBar};
				var summaryBarIndex = array.indexOf(this._modules, SummaryBar);
				if( lang.isObject(pluginObj) && !pluginObj.onlyDesc ){
					for(var key in pluginObj) {
						if (pluginObj.hasOwnProperty(key)) {
							switch(key){
								case "defaultPageSize" :
									baseMod.initialPageSize = pluginObj[key];
									break;
								case "pageSizes" :
									paginationMod.sizes = pluginObj[key];
									break;
								case "description" :
									paginationMod.description = pluginObj[key];
									break;
								case "sizeSwitch" :
									paginationMod.sizeSwitch = pluginObj[key];
									break;
								case "pageStepper" :
									paginationMod.stepper = pluginObj[key];
									break;
								case "gotoButton" :
									paginationMod.gotoButton = pluginObj[key];
									break;
								case "maxPageStep" :
									paginationMod.visibleSteppers = pluginObj[key];
									break;
								case "position" :
									paginationMod.position = pluginObj[key];
									break;
								case "descTemplate" :
									paginationMod.descriptionTemplate = pluginObj[key];
									break;
								default: console.warn('Parameter not supported: '+ key 
										+ ' please use gridx modules instead of plugin to take advantage of extra configurations! ');
							}
						}
					}
					// 55029 - Default for Table Dashlet
					if(summaryBarIndex != -1) {
						this._modules.splice(summaryBarIndex, 1);
					}
					this._modules.push(baseMod,paginationMod);
				}
				
				if(lang.isObject(pluginObj) && pluginObj.onlyDesc == true){
					// 55029 - Default for Table Dashlet
					if(summaryBarIndex != -1)
						this._modules.push(summaryBarMod);
				}				
			},
			
			//@189518 START
			_mapSingleSortAttrs: function(pluginObj) {
				var sort = {moduleClass: singleSort};
				sort.initialOrder = pluginObj;
				this._modules.push(sort);					
			},
			
			_mapNestedSortingAttrs: function (pluginObj, initialOrder){
				var nest = {moduleClass: nestedSort};
				nest.initialOrder = initialOrder;
				this._modules.push(
						//{moduleClass: body},
						//{moduleClass: header},
						nest
				);	
			},
			//@189518 END	
			
			_mapMenuAttrs: function(pluginObj) {
				this._modules.push({moduleClass: menu});
			},
			
			_mapFilterAttrs: function(pluginObj) {
				var baseMod = {moduleClass: filter};
				var filterBarMod = {moduleClass: filterBar};
				if(lang.isObject(pluginObj)){
					for(var key in pluginObj) {
						if (pluginObj.hasOwnProperty(key)) {
							switch(key){
								case "isServerSide" :
									baseMod.serverMode = pluginObj[key];
									break;	
								case "closeFilterbarButton" :
									filterBarMod.closeFilterBarButton = pluginObj[key];
									break;	
								case "ruleCountToConfirmClearFilter" :
									filterBarMod.ruleCountToConfirmClearFilter = pluginObj[key];
									break;		
								case "setupFilterQuery" :
									baseMod.setupFilterQuery = pluginObj[key];
									break;
								default: console.warn('Parameter not supported: '+ key 
										+ ' please use gridx modules instead of plugin to take advantage of extra configurations! ');
							}
						}
					}
				}
				this._modules.push(baseMod, filterBarMod);
			},
			
			_mapPrinterAttrs: function(pluginObj) {				
				this._modules.push({moduleClass:exporter}, {moduleClass:exportTable}, {moduleClass: printer});
			},
			
			_mapExporterAttrs: function(pluginObj){
				this._modules.push({moduleClass:exporter}, {moduleClass:exportCSV}, {moduleClass:exportTable});
			}			
		});
		
		mapToModules.convertToModules = function(plugins){
			return mapToModules.prototype._convertToModules(plugins);
		};
		mapToModules._getCoreModules = function(){
			return mapToModules.prototype._getCoreModules();
		};
		
		// 55027 - Defaults for Table Widget
		mapToModules._getMobileCoreModules = function(){
			return mapToModules.prototype._getMobileCoreModules();
		};
		
		mapToModules.setMobileMode = function(isMobile) {
			return mapToModules.prototype._setMobileMode(isMobile);
		};
		
		return mapToModules;
	}
);