require({cache:{
'url:dojoe/treetablex/templates/TreeTable.html':"\r\n<div class=\"tivTreeTable\" tabIndex=0>\r\n\t<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\"  \r\n\t\tstyle=\"width:100%;height:100%;vertical-align:top;\"  role=\"presentation\">\t\t\r\n\t\t<tr>\r\n\t\t\t<td style=\"width:100%;vertical-align:top;\" valign=\"top\" role=\"toolbar\" aria-label=\"toolBar\">\r\n\t\t\t\t<div dojoAttachPoint=\"wipeNode\">\r\n\t\t\t\t\t<div dojoAttachPoint=\"toolbarNode\"></div>\r\n\t\t\t\t</div>\r\n\t\t\t</td>\r\n\t\t</tr>\r\n\t\t<tr>\r\n\t\t\t<td style=\"width:100%;vertical-align:top;\"  valign=\"top\">\r\n\t\t\t\t<div dojoAttachPoint=\"treeGridNode\"></div>\t\r\n\t\t\t</td>\r\n\t\t</tr>\t\t\r\n\t</table>\r\n</div>\t\r\n"}});
/*********************************************************** {COPYRIGHT-TOP} ***
* Licensed Materials - Property of IBM
* Tivoli Widget Library
*
* (C) Copyright IBM Corp. 2014.  All Rights Reserved.
*
* US Government Users Restricted Rights - Use, duplication, or
* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
************************************************************ {COPYRIGHT-END} **/
define("dojoe/treetablex/TreeTable", [
	"dojo/_base/declare",
	"dijit/_WidgetBase",
	"dijit/_TemplatedMixin",
	"gridx/Grid",
	"gridx/core/model/cache/Async",
	"gridx/core/model/extensions/Query",
	"gridx/modules/Persist",
	"gridx/modules/Tree",
	"gridx/modules/VirtualVScroller",
	"gridx/modules/TouchVScroller", // 54839
	"gridx/modules/Pagination",
	"gridx/modules/ColumnResizer",
	"gridx/modules/ColumnWidth",
	"gridx/modules/SingleSort",
	"gridx/modules/select/Row",
	"gridx/modules/select/Column",
	"gridx/modules/extendedSelect/Row",
	"gridx/modules/extendedSelect/Column",
	"gridx/modules/IndirectSelect",
	"gridx/modules/RowHeader",
	"gridx/modules/Filter",
	"gridx/modules/filter/FilterBar",
	"dojo/dom-geometry",
	"dojoe/treetablex/_Toolbar",
	"dojoe/slidingpane/SlidingPane",
	"dojoe/treetablex/modules/StatefulRefresh",
	"dojo/_base/array",
	"dojo/_base/lang",
	"dojo/window",
	"dojo/dom-style",
	"dojo/i18n!dojoe/treetablex/nls/TreeTable",
	"dojo/text!./templates/TreeTable.html",
	"dijit/layout/ContentPane"
], function (declare, _WidgetBase, _TemplatedMixin, Gridx, Cache, Query, Persist, Tree, VirtualVScroller, touchVScroller, Pagination, ColumnResizer, ColumnWidth, SingleSort, SelectRow, SelectColumn, ExtSelectRow, 
	ExtSelectColumn, IndirectSelect, RowHeader, Filter, FilterBar, domGeom , _Toolbar, SlidingPane, StatefulRefresh, array, Lang, Window, domStyle, NLS, template, ContentPane) {

	//summary: 
	//		Tree table is a hybrid widget of a tree and table 
	//description: 
	//		TreeTable widget implementation is based gridx
	//		Provides additional features upon gridx like toolbar with state control buttons (refresh) and custom actions dropdown etc

	TreeTable = declare('dojoe.treetablex.TreeTable', [_WidgetBase, _TemplatedMixin], {
	
		//summary: Set this to true if the widget contains other widgets
		//tags: private
		//widgetsInTemplate : true,
		
		//summary: Path to the template
		//tags: private
		templateString: template,
		
		// _grid: Object
		//		Reference to the gridx used
		_grid: null,
		
		// gridParams_: object
		//		holds all the parameters passed to the gridx by the user.
		gridParams_: null,
		
		// filterOptions:  Object
		//		Holds all the filter information passed by the user.
		filterOptions : {},
		
		// mods: object
		//		holds the modules passed to the gridx.
		/* LS - 11/15/2012 - 54832: Treetable Gridx: Delete rows not working
		 * Virtual scroller tries to do scroll during the delete rows and add rows causing rendering issues
		 * setting lazy true and a timeout fixes this issue and also helps in case of huge datasets*/
		_modules: [ Tree, {moduleClass: VirtualVScroller, lazy: true, lazyTimeout: 200}, SelectColumn, SingleSort, ColumnResizer, ColumnWidth, FilterBar],
		
		// mods: object
		//		holds the filter modules passed to the gridx.
		_filterModules: null,
		
		// mods: object
		//		holds the indirect selection modules and its dependencies passed to the gridx.
		_indirectSelectModules: null,
		
		// toolbarVisible: boolean
		//		control the _toolbar show/hide
		toolbarVisible:true,
		
		// enableCollapsibleToolbar: boolean
		//		To add collapsible toolbar  to the table
		enableCollapsibleToolbar : false,
		
		// toolbarExpand: boolean
		//		To indicate(preset) the state of the toolbar on load
		toolbarExpand : false,
		
		//enableResize: boolean
		//		To disable table resize on window resize event.Default true, set false to disable table resize on window resize event	
		enableResize:true,		
		
		// width: number in px or % or em
		//		holds the width of the grid
		width:'',
		
		// height: number in px or % or em
		//		holds the height of the grid
		height:'',
		
		// _defaultHeight: number in %
		//		holds the default height of the grid
		_defaultHeight: '100%',
		
		// _defaultWidth: number in % 
		//		holds the default width of the grid
		_defaultWidth: '100%',
		
		//summary: Reference to the toolbar
		//tags: private
		_toolbar:null,
		
		// toolbarOptions: object
		//	holds the list of values for enabling/disabling toolbar options
		toolbarOptions:{},
	
		// state: object
		//		Tree Grid state object
		state: null,
		
		// enableColumnReorder: boolean
		//		To enable column reorder, by default its true
		enableColumnReorder:true,
		
		// indirectSelection: boolean
		//		Set tree table with basic Selection, if set to true enables Indirect selection Single and multiple grid selection modes
		indirectSelection: false,
		
		//menu: object
		// 		To handle custom menus
		menu: null,
		
		//summary: keeps track of the menu event object which provides the context value when right clicked
		onContextMenuEvtObj: null,
		
		// _originalStructure: original Structure set to the table
		// tags: private
		_origLayout : null,
		
		// _currentLayout: layout object after filtering columns with hidden parameters
		// tags: private
		_currentLayout : null,
		
		//_selectionMode: string
		// 		To handle selection mode. by default it is single 
		_selectionMode : "single",
		
		// _resources:  Object
		//		Reference to the resources
		// tags: private
		_resources : null,		
		
		// 53655 : Support for mobile mode
		// mobileMode : Boolean - if enabled, display reduced capability
		mobileMode : false,
		
		// _reorderedColumns:  Object
		//		To store the _reorderedColumns from ConfigColumnsDialog
		// tags: private
		_reorderedColumns : null,
		
		// _previousSize: Object
		// Reference value for resize
		// tags: private
		_previousSize : null,		
		
		// 66712: [Dojo 9236] Last column in table cutoff width set to 60px; when horizontal scrolling active
		// stretchLastColumn: Boolean - if enabled, last column width is set to auto
		stretchLastColumn : true,	
		
		//Bobby: 03Apr2013, adding this for TreeTable also. Table supports already.
		// persistOptions: Boolean - if enabled persists config options settings and column properties
		persistOptions : false,		
		
		constructor: function(args){
			// summary: Constructor
			this.gridParams_ = {};
			this.actionList = {};
			//this._modules = [ Tree, VirtualVScroller, SelectRow, SelectColumn, SingleSort, ColumnResizer, Persist];
			this._filterModules = {moduleClass: Filter};		
			this._resources = NLS;
		},
		
		postCreate: function(){
			//summary: 
			//		creates and initialize the tree table 
			
			this._mapGridParams();
			
			// 53655 : Support for mobile mode
			if (this.mobileMode) {
				//61872
				this._modules = [ Tree, touchVScroller, SelectColumn, SingleSort, FilterBar];	// 54839			
				this._modifyOptionsForMobile();							
			} else {
				this._indirectSelectModules = [IndirectSelect, RowHeader];
			}
			
			// 66712: [Dojo 9236] Last column in table cutoff width set to 60px; when horizontal scrolling active
			if (this.stretchLastColumn != false) {
				this.stretchLastColumn = true;
			}				
			
			this._defineModules();
			// set statefulRefresh in gridparams if the expansion state needs to be persisted during dynamic updates..
			if(this.gridParams_.statefulRefresh){
				this._modules.push(Persist);
				this._modules.push(StatefulRefresh);
			
			}
			if( !this.gridParams_.autoWidth){
				domStyle.set(this.domNode, "width", this.width);
			}
			if( !this.gridParams_.autoHeight){
				domStyle.set(this.domNode, "height", this.height);
			}
			this._makeGrid();
			// set statefulRefresh in gridparams if the expansion state needs to be persisted during dynamic updates..
			// statefulRefresh is a new module on Gridx which when loaded enables persisting the expansion state
			
			if(this.gridParams_.statefulRefresh){
				this.connect(this, "onRefresh",dojo.hitch(this._grid.statefulRefresh,"_applyTreeState")) ;
				/*LS: 26 Fed 2013 : #58773: Expanded nodes for lazily loaded events does not remain expanded on refresh
				 * extra connect to _doVirtualScroll of VirtualVScroller of gridx in order to re-apply the state on virtual scroll
				 * TODO: we might have to consider the same for Pagination also  */
				this.connect(this._grid.vScroller, "_doVirtualScroll",dojo.hitch(this._grid.statefulRefresh,"_applyTreeState")) ;
			}
			if(this.menu !== null){
				this.connect(this._grid, "onRowContextMenu", dojo.hitch(this, "showRowContextMenu"));
			}	
			if(this.toolbarVisible ){
				this._toolbar = new _Toolbar({treeTable:this}, this.toolbarNode);
				
				if (this.enableCollapsibleToolbar) {
					this.slidingPane = new SlidingPane({closeNodeClass: "slidingPaneClose", open: this.toolbarExpand}, this.wipeNode);
					this.connect(this.slidingPane, "onClick", dojo.hitch(this, "slidingPaneClicked"));	//Connecting event onClick to sliding pane.
				}
				
			} else {
				//Latha : 54640: Unable to open filter popup for TreeTable and Tree Table gridx, As advanced filter is not yet enabled on TreeTablex hiding the filterbar by default
				if(this.filterOptions.hideFilterBar == undefined) {  
					this.filterOptions.hideFilterBar = true;
				}
				if(this.filterOptions.hideFilterBar == true && this._grid.filterBar !== undefined){
					this._grid.filterBar.hide();
				} 
			}
			this.resize();
			if(this.enableResize === true) {
				this.connect(window, "onresize", dojo.hitch(this, "resize"));			
			}
			
			if(this._toolbar && this._toolbar.actionListWidget){	
				this.connect(this._toolbar.actionListWidget, 'openDropDown', dojo.hitch(this,"onActionListOpen")); 			
				this.connect(this._toolbar.actionListWidget, 'closeDropDown', dojo.hitch(this,"onActionListClose")); 
			}
			
			if(this.gridParams_.preFilter){
				dojo.connect(this, 'onTreeTableLoad', dojo.hitch(this,"_preFilter"));
			}
			setTimeout(dojo.hitch(this, "onTreeTableLoad", this), 1000);
		},
		onTreeTableLoad: function(treetable){
			// summary: 
			//		Called after the tree Table loads
			// tags:
			//      callback
			console.info("TreeTable load complete....."+treetable.id);
		},
		showRowContextMenu: function(e){
			//summary: 
			//		Associates row context menu with tree table and also returns the contextEvent Object
			//tags: public
			e.preventDefault();
			if(this.menu){
				this.menu._openMyself({
					target: e.target,
					coords: "pageX" in e ? {
						x: e.pageX,
						y: e.pageY
					} : null
				});
			}
			this.onContextMenuEvtObj = e;
			return e;
		},	
		
		_defineModules: function() {
			this._modules = this._modules.concat(this._filterModules);
			//58032: Dash: TCTUI1003E: Error communicating with server during Filter step of Widget Builder Customization in Dash
			//Bobby:16Nov2012: preventing error this.toolbarOptions is undefined
			if(!this.toolbarOptions) this.toolbarOptions = {};
			
			//Bobby:19Oct2012, adding basic support for no selection
			if(this._selectionMode == 'none') {
				this.indirectSelection = false;
				this.toolbarOptions.selectAllIcon = false;
				this.toolbarOptions.selectAllMenu = false;
			}
			
			if(this._selectionMode == 'single') {
				if(this.indirectSelection) //Bobby:19Oct2012, don't select when clicked on a cell - no triggerOnCell
					this._modules = this._modules.concat({moduleClass: SelectRow, multiple : false, treeMode: false, triggerOnCell : false});
				else this._modules = this._modules.concat({moduleClass: SelectRow, multiple : false, treeMode: false, triggerOnCell : true});	
				this.toolbarOptions.selectAllIcon = false;
				this.toolbarOptions.selectAllMenu = false;
			}else if(this._selectionMode == 'multiple') {
				if(this.indirectSelection) // LS:16Jan2013, 64366: IndirectSelect module with TreeTableView will make root nodes appear selected when they aren't
					this._modules = this._modules.concat({moduleClass: ExtSelectRow, treeMode: true, triggerOnCell : false}); // 67971 : TreeTable select all does not select children
				else this._modules = this._modules.concat({moduleClass: ExtSelectRow, treeMode: true, triggerOnCell : true}); // Setting treeMode to true when multiple selection is enabled
				this._modules = this._modules.concat([ExtSelectColumn]);	
				this.toolbarOptions.selectAllMenu = true;		
			}

			if(this.persistOptions){
				//load persist module...conditionally
				this._modules.push(Persist);
			}		
			
			if(this.gridParams_.modules) {
				this._modules = this._modules.concat(this.gridParams_.modules);			
			}
			if(this.indirectSelection) {
				this._modules = this._modules.concat(this._indirectSelectModules);			
			}			
		},
		
		//Bobby: 03Apr2013, adding this for TreeTable also. Table supports already.
		_persistColumns : function () {
			// summary:   
			//	If persistOptions is enabled this is invoked to persist the column information in a cookie..	
			// tags: private
			// set filtered structure in case hidden parameters are present
			//LS - 10/6/12 - 54009: Need persistence support in gridx tables
			if( this.persistOptions && this._grid.persist ){
				// if hidden columns are configured using config columns dialog use the data from cookie
				/* 42703: TableView: Configure Options settings are not saved after refresh
				 * use table id instead of grid id to persist the grid options*/
				var content = this._grid.persist.get(this.id);
				if(content && content["configColumns"]){
					var visibleColsConfig = content["configColumns"];
					var col, cols =[], grid = this._grid;
					var structure = this._origLayout;
					if(Lang.isArray(visibleColsConfig.visibleCols)){
						Array.forEach(visibleColsConfig.visibleCols, function(col){
							Array.some(structure, function(c){
								if(c.field == col.field){
									cols.push(c);
									return true;
								}										
							});
						});
						this._grid.setColumns(cols);
					}
					/* 42703: TableView: Configure Options settings are not saved after refresh
					 * set changed width due to column addition/deletion*/
					for(var i=0; i < (content["column"]).length; i++){
						var newWidth = (content["column"])[i].width;
						this._grid.column(i).setWidth(newWidth);
					}
					this._grid.body.refresh();
				}else{
					//LS - 10/11/2012 - 54009 - Persisted width and sort props are overwritten
					// in case persistOptions is not used and user is using gridx Persist directly... need to set back the persisted col info 
					// as the original structure while constructing the grid
					if(this._grid.persist){
						this._origLayout =  this._grid._columns;
					}
					this._filterHiddenColumns(this._origLayout);
				}
				
			}else{
				if(this._grid.persist){
					this._origLayout =  this._grid._columns;
				}
				this._filterHiddenColumns(this._origLayout);
			}
		},			
		
		_mapGridParams: function() {
			//if no width is given default is set
			if(this.width ===''&& !this.gridParams_.autoWidth){
				this.width = this._defaultWidth;
			}
			//if no height is given default is set
			if(this.height ==='' && !this.gridParams_.autoHeight){
				this.height = this._defaultHeight;
			}
			if(this.gridParams_.indirectSelection){
				this.indirectSelection=this.gridParams_.indirectSelection;
			}
			if(this.gridParams_.selectionMode){
				this._selectionMode=this.gridParams_.selectionMode;
			}
			//55028 - Default for TreeTable Widget
			if(this.gridParams_.enableCollapsibleToolbar) {
				this.enableCollapsibleToolbar = this.gridParams_.enableCollapsibleToolbar;
			}
			//Server side filter implementation for TreeTable(Gridx). 
			if(this.gridParams_.filter) {
				if(this.gridParams_.filter.isServerSide) {
					this._filterModules.serverMode = this.gridParams_.filter.isServerSide;
				}
				if(this.gridParams_.filter.setupFilterQuery) {
					this._filterModules.setupFilterQuery = this.gridParams_.filter.setupFilterQuery;
				} 
			}			
		},
		
		// 53655 : Support for mobile mode
		_modifyOptionsForMobile : function () {
			console.log("In _modifyOptionsForMobile");
			
			this.enableCollapsibleToolbar = false;
			
			this.toolbarOptions.quickFilterVisible = true;
			this.toolbarOptions.showQuickFilterButton = false;			
			this.toolbarOptions.actionMenu = false;
			this.toolbarOptions.configureTreeTableIcon = false;
			this.toolbarOptions.selectAllIcon = false;
			this.toolbarOptions.clearSortIcon = false;
			
			this.gridParams_.indirectSelection = false;
			this.gridParams_.selectionMode = "single";			
		},
		
		slidingPaneClicked : function () {
			// summary:
			//		callback when collapsible tool bar sliding pane is clicked
			// tags: callback
			this.resize();
		},
		
		_makeGrid: function(){
			
			// summary: 
			//		creates and initializes gridx
			// tags: private
			
			//Bobby:10Oct2012, Create grid only if there is a store, else grid fails
			if(this.gridParams_.store){	
				var store =  this.gridParams_.store;
				
				//62246: Impact 37474: Table Widget customized column sizes cannot be saved
				//Bobby: 03Apr2013, a proper id is critical to store and retrieve settings
				if(!this.gridParams_.id){
					this.gridParams_.id = this.id + "_grid";
				}
				
				if(!this.gridParams_.cacheClass){
					this.gridParams_.cacheClass = Cache;
				}
				this.gridParams_.modules = this._modules;
				if(!this.gridParams_.modelExtensions){
					this.gridParams_.modelExtensions = [Query];
				}
				
				//Latha : 57964: Sorting the tree view and table view based on a column while loading the view
				if(this.gridParams_.sortFields) {
					this.gridParams_.sortInitialOrder = this.gridParams_.sortFields;
				}
				
				//Bobby: 10Oct2012, rowsPerPage isn't supported by gridx, instead need pagination module and paginationInitialPageSize param
				/*if(this.gridParams_.rowsPerPage){
					console.debug("TreeTable.js: _makeGrid(): gridParams_.rowsPerPage - "+this.gridParams_.rowsPerPage);
					this.gridParams_.paginationInitialPageSize = this.gridParams_.rowsPerPage;
				}*/
				
				//54501 pageSize param is the equivalent for rowsPerPage
				if(this.gridParams_.rowsPerPage){
					console.debug("TreeTable.js: _makeGrid(): gridParams_.rowsPerPage - "+this.gridParams_.rowsPerPage);
					/*LS - 21Mar2013 : # 68455: Scrolling performace of Event Viewer (TreeTable) is slow when there are a a large number of events (10'000)*/
					if(typeof(this.gridParams_.rowsPerPage) == "string"){
						this.gridParams_.rowsPerPage = parseInt(this.gridParams_.rowsPerPage);
					}
					this.gridParams_.pageSize = this.gridParams_.rowsPerPage;
				}
		
				//64903: Table - last column width doesn't comply to UI Guidelines
				//Bobby: 18Jan2013, setting last column width to auto, if not % width.
				//66712: [Dojo 9236] Last column in table cutoff width set to 60px; when horizontal scrolling active
				//Bobby: 06Mar2013, set last column width to auto only if stretchLastColumn enabled.				
				if(this.gridParams_.structure && this.stretchLastColumn) { 
					if (this.gridParams_.structure[this.gridParams_.structure.length - 1].width) {
						if (this.gridParams_.structure[this.gridParams_.structure.length - 1].width.indexOf("%") == -1) {
							this.gridParams_.structure[this.gridParams_.structure.length - 1].width = "auto";
						}
					}
					else {
						this.gridParams_.structure[this.gridParams_.structure.length - 1].width = "auto";
					}
				}				
		
				this._grid=new Gridx(this.gridParams_,this.treeGridNode);
		
				// 58879
				dojo.attr(this._grid.domNode, 'aria-label', this.gridParams_.label);
				
				if (!("hasChildren" in store)) {	
					store.hasChildren = function(id, item){
						return item && store.getValues(item, 'children').length;
					};
				}
				if (!("getChildren" in store)) {	
					store.getChildren = function(item){
						return store.getValues(item, 'children');
					};
				}
				
				/* if(!this.gridParams_.noDataMessage){
					this._grid.noDataMessage=this._resources.NO_DATA;
				}
				else{
					this._grid.noDataMessage=this.gridParams_.noDataMessage;
				} */
			
				this._grid.startup();
				//Bobby: 03Apr2013, adding this for TreeTable also. Table supports already.
				// use onModulesLoaded callback to ensure the Persist module is loaded before operating on the columns
				this.connect(this._grid,"onModulesLoaded", Lang.hitch(this,"_persistColumns"));

				
				//set original column structure to keep a reference of overall structure including hidden columns
				if(this.gridParams_.structure && !this._origLayout){
					this._origLayout = this.gridParams_.structure;
							
				}
				// set filtered structure in case hidden parameters are present
				//LS - 10/11/2012 - 55843 - Persisted width and sort props are overwritten
				// in case persistOptions is not used and user is using gridx Persist directly... need to set back the persisted col info 
				// as the original structure while constructing the grid
				if(this._grid.persist){
					this._origLayout =  this._grid._columns;
				}
				this._filterHiddenColumns(this._origLayout);
			}//Bobby: 13Oct2012, If there is no store, show an empty layout with no data message instead of creating a grid!
			else{
				this._grid = new ContentPane({
				  content:"<div style='height:99%;valign:middle;text-align:center;border:1px solid LightGrey'><p>"+this._resources.NO_DATA+"</p></div>"
				}, this.treeGridNode);
				this.filterOptions.showQuickFilter = false;
			}	
			
		},
		_filterHiddenColumns: function (structure){
			// summary: Returns the layout after filtering hidden column definition
			// tags: private
			// returns: layout object
			var filteredColumns = [];
			if(Lang.isArray(structure)){
				for(var i in structure) {
					var column = structure[i];
					
					if(!(column.hidden && column.hidden == true) ){
						filteredColumns.push(column);
					}else if(i==0 || column.expandLevel == 1){
						//root node do not hide it...
						filteredColumns.push(column);
					}
				}
			}
			if(filteredColumns.length >0 )this._currentLayout = filteredColumns;
			this._grid.setColumns(this._currentLayout);
			
		},
		
		resize: function (event) {
			// summary:  
			//		Resizes the tree table. Also takes care of window resize events
			// tags:  public
			// event: object
			//		window resize event
			
			if (!this._grid || !this.domNode || !this.domNode.parentNode || this.domNode.parentNode.nodeType != 1) {  //Javascript error in resize() sometimes on IE8
				return;
			}
			
			var size = Window.getBox();
			//return if the size of the table is same as previous size
			if(this._previousSize && this._previousSize.h == size.h && this._previousSize.w == size.w  && event){
				return;				
			}else{
				this._previousSize =  size;
			}
			//if event object is passed there is no need to set the height and width on the domNode
			if(!event){
				if (!this._grid.autoWidth) {
				domStyle.set(this.domNode, "width", this.width);
				} else {
					domStyle.set(this.domNode, "width", domGeom.getMarginBox(this._grid.domNode).w + 'px');
				}
				if (!this._grid.autoHeight) {
				domStyle.set(this.domNode, "height", this.height);
				} else {
					domStyle.set(this.domNode, "height", domGeom.getMarginBox(this._grid.domNode).h + 'px');
				}
				var heightPx = this.height;
				
				if (!(this.domNode.parentNode.style && this.domNode.parentNode.style.height)) {
					var sizeType = this.height.substring(this.height.length - 1, this.height.length);
					//if the height is given in % then translate it to pixel
					if (sizeType == "%") {
						//convert to px
						//Bobby:21Nov2012, using correct syntax of string.slice & parseInt
						//heightPx = size.h * ((parseInt(this.height.slice(0,-1))) / 100);
						heightPx = size.h * ((parseInt(this.height.slice(-1),10)) / 100);
						heightPx = heightPx + "px";
					}
				}
			
				domStyle.set(this.domNode, "height", heightPx);
			}
			setTimeout(dojo.hitch(this, function(){this._delayResize(event);}), 100);
		},
		
		_delayResize: function (resizeEvent) {
			// summary:  
			//		invoked with delay for grid resize.
			// tags: private
			
			if(this.domNode){
					
				/*using marginBox to include margins/borders of the domNode*/
				var tableSize =  domGeom.getMarginBox(this.domNode);
				if(tableSize){		
					if (this._toolbar) {
						/*calculating toolbarsize including margins and borders as they contibute to some height*/
						var toolbarSize = domGeom.getMarginBox(this._toolbar.domNode);
						if (this.enableCollapsibleToolbar  && !this.slidingPane.open) {
							//reducing the height of the table by the size of the close node of sliding pane when toolbar is not visible
							tableSize.h = tableSize.h - this.slidingPane.domNode.offsetHeight;
						}else{
							tableSize.h = tableSize.h - toolbarSize.h ;
						}
					}
					if((tableSize.h <= 0 || tableSize.w <= 0 )){
						return;
					}
					/* #62305:Table widget shows a horizontal scroll bar when it doesn't need one
					 * Adding support for resizing the grid based on width and height of the event */
					if(resizeEvent){
						if(resizeEvent.w && resizeEvent.h){
							 tableSize.h = resizeEvent.h;
							 tableSize.w = resizeEvent.w;
						}
						this._grid.resize({
							h : tableSize.h,
							w : tableSize.w
						});
					}else{
						//This check has been added for rendering issue of table inside wizard.In IE7 resize is happening only on passing both height and width. 
								// 53485: KDM 10/12/12:  Vertical scrollbar error in IE8 when no content (Dojo defect, but try/catch put in place for 1.0.2)
						if(dojo.isIE == 7) {
							try {
								this._grid.resize({
									h : tableSize.h,
									w : tableSize.w
								});
							}catch(ex){
								// Catch Dojo bug with VScroller in IE7 until Dojo can be fixed									
							}
						} else { 
							/* 61858: LS: 1/11/2013 Table view is not getting rendered properly when you resize and restore browser*/
							
							this._grid.resize({
								h : tableSize.h,
								w : tableSize.w
							});
						}
					}
				}
			}
		},
		
		onActionListOpen : function(){
			// summary:
			//		Callback when toolbar Action list is opened
			// tags: public
		
			//console.info("actionListOpen.....");
			
		},
		
		onActionListClose : function(){
			// summary:
			//		Callback when toolbar Action list is closed
			// tags: public
			
			//console.info("actionListClosed.....");
			
		},
		
		_preFilter : function(){
			// summary: 
			//		Private function to set "gridparams.preFilter" value when tree table loads
			// tags: private
			
			if (this.gridParams_.preFilter) {
					if(this.gridParams_.preFilter[0].column==='any'){
						if(this.gridParams_.preFilter[0].value){
							this.setFilter(this.gridParams_.preFilter[0].value);
						}
					}
			}
		},
		
		setFilter : function (filterText){
			//summary:
			//		set filter value programmatically
			// tags: public
			if(this._toolbar){
				if(this._toolbar.quickFilter){
					this._toolbar.quickFilter._setFilter(filterText);
				}
			}
		},
		
		getFilter : function(){
			// summary:
			//		get filter value
			// tags: public
			
			if(this._toolbar){
				if(this._toolbar.quickFilter){
					return this._toolbar.quickFilter._getFilter();
				}
			}
		},
		
		addToActionList: function(item) {
			// summary: 
			//		To add a new item to the toolbar action menu
			// tags: public
			
			if(this._toolbar) {
				if(this._toolbar.actionMenu) {
					this._toolbar.actionListWidget.dropDown.addChild(item,0);
				}
			}
		},
		
		addToToolbar : function (item, position, row, noResize) {
			// summary:  
			//		Add an item to the toolbar
			// tags: public
			// item:  object   
			//		The item that needs to be added
			// position:  number 
			//		The position of the item
			// row:  number 
			//		The row number to which the item needs to be added
			// noResize: boolean 
			//		To control whether a table resize should be done or not
		
			if (this._toolbar) {
				if (item) {
					this._toolbar._addCustomControl(item, position, row);
				}
				if (noResize == false){
				} else {
				this.resize();	
				}
			}
		}, 
		
		addItemsToToolbar : function (items, position, row, noResize) {
			// summary:  
			//		Add a list of items to the toolbar
			// tags: public
			// items:  array   
			//		The items that needs to be added
			// position:  number 
			//		The position of the starting item 
			// row:  number 
			//		The row number to which the item needs to be added
			// noResize: boolean 
			//		To control whether a table resize should be done or not
		
			if (this._toolbar) {
				for (var i = 0; i < items.length; i++) {		
					if (items[i]) {
						this._toolbar._addCustomControl(items[i], position + i, row);
					}
				}
				if (noResize == false){
				} else {
				this.resize();	
				}			
			}
		}, 		
		
		addContextMenuToTreeTable: function(position, customMenu){
			// summary: 
			//		Allows adding a context menu to the TreeTable
			//tags: public
			
			if(position == "rowMenu") {
				customMenu.bindDomNode(this._grid.domNode);
				this._grid.onRowContextMenu = function(e){				
					if(!this.menu){
						this.menu = customMenu;
					}
				};
			}
		},
		
		removeItemFromToolbar: function(itemId){
			// summary: 
			//		to remove an item from the toolbar
			// tags: public
			// itemId: String
			if(this._toolbar) {
				this._toolbar._removeItem(itemId);
			}			
		},
	
		removeFromActionList: function (menuItemId){
			// summary: 
			//		Removes a menu Item from ActionList
			// tags: public
			// menuItemId : String
			//		Id of the menuItem to be removed.
			if(this._toolbar) {
				this._toolbar._removeFromActionList(menuItemId);
			}
		},
		
		getRowCount : function(){
			// summary: 
			//		rowCount of the table
			// tags: public
			// return: number
			//		the rowCount	
			return this._grid.rowCount();
		},
		
		getSelectedRowCount : function(){
			// summary: 
			//		Gets a selected rowCount of the table
			// tags: public
			// return: number
			//		the selected rowCount
			return this._grid.select.row.getSelected().length;
		},
		
		getSelectedRows : function(){
			// summary:  
			//		Returns the selected rows from the grid.
			// tags: public
			// returns: array
			//		selected rows.
			return this._grid.select.row.getSelected();
		},	
		
		isRowSelected: function(rowId){
			// summary: 
			//		Returns true if given row is selected
			// tags: public
			
			return this._grid.select.row.isSelected(rowId);
		},
		
		disableMenuItem : function(menuid){
			// summary: 
			//		Disable a menu item of the context menu attached to the treetable.
			// tags: public
			
			var menuitem= dijit.byId(menuid);
			if(menuitem) {
				menuitem.setDisabled(true);
			}
		},
		
		enableMenuItem : function(menuid){
			// summary:
			//		Enable a menu item of the context menu attached to the treetable.
			// tags: public
			var menuitem= dijit.byId(menuid);
			if(menuitem) {
				menuitem.setDisabled(false);
			}
		},
		
		removeSelectedRows : function(){
			// summary: 
			//		deletes selected rows from the treetable
			// tags: public
			
			var grid = this._grid;
			var selectedArray = grid.select.row.getSelected();
			array.forEach(selectedArray, function(row){
				if(grid.row(row, true)) {
					var item = grid.row(row, true).item();
					grid.store.deleteItem(item);
				}
			});
		},
		
		deleteRow: function(item){
			// summary: 
			//		deletes the given item from the store
			// tags: public
			// item: object
			//		Row element of the table
			this._grid.store.deleteItem(item);
		},
	
		removeItemFromToolbar: function(itemId){
			// summary: 
			//		to remove an item from the toolbar
			// tags: public
			// itemId: String
			if(this._toolbar) {
				this._toolbar._removeItem(itemId);
			}			
		},
		
		addRow: function(item,parent) {
			// summary: 
			//		Adds a new row to the treetable 
			// tags: public
			// description: 
			//		If no parent id is given, then the new row will be added as the last row.
			//      If parent id is given, then the row will be added as the last child of the parent.
			// item: object
			//		The item to be added
			// parent: string
			//		The parent id to which the new row should be added as a child
			
			//If the row is selected to be as a parent then the new row will be added as a child to that row.
			if(this._toolbar){
				if(this._toolbar.quickFilter && this._toolbar.quickFilter.filterText !== null){
					this._toolbar.quickFilter._clearFilter();
				}
				this._toolbar._clearSort();
			}
			if(!parent){
				if(this._grid){
					var selectedItem = this._grid.store.newItem(item);
				}
			}else{
				var s = this._grid.store;
				s.fetchItemByIdentity({identity: parent, onItem: function(item){
					parent = item;
				}});
				if(parent){
					s.newItem(item, {parent: parent, attribute: "children"});
				}
				this._grid.body.refresh();
			}
		},
		
		removeMenuItem : function (menuid){
			// summary: 
			//		Removes menu item from the context menu
			// tags: public
			var menuitem= dijit.byId(menuid);
			if(menuitem) {
				menuitem.destroyRecursive();
			}
		},
		
		//43175: TBSM: TWL: NodeClickedOn event not being emitted after widget context updated
		//Bobby: 22Jan2014, adding the option to clear selection via Refresh Icon
		clearSelection : function () {
			// summary:  
			//		Clears all selected rows
			// tags: public
			
			if(this._grid.select && this._grid.select.row && this._grid.select.row.clear){
				this._grid.select.row.clear();	
			}
		}, 
			
		refresh: function(updateBody) {
			// summary: 
			//		Refreshes the grid with updated values. If updateBody is true it refreshes the grid body also. 
			// tags: public
			var deferred = null;
			if (this._grid) {
				if (this._grid.model.store.CURIRefresh) {
					// Refresh is being driven by change to CURI dataset
					// on the server
					this._grid.store.CURIRefresh();
					// Since CURI dataset could have significant changes
					// can't count on selected item(s) to still be there
					// and can't count on tree expanded branch states, so
					// have to clear all of them (unless we can find out
					// from gridx team how to gracefully handle cases where
					// old child items no longer exist or have different IDs now.
	                this._grid.select.row.clear();
	                this._grid.model.clearCache();
	                //Latha : 39568: TWL 1.1.0.3: [Auto-Update] Tree Table throws console errors on refresh (' TypeError: this._grid.tree._clear is not a function ')
	                this._grid.view._clear(); // this clear method has been moved from tree module to view module  in Gridx 1.2.  
	                deferred =  this._grid.body.refresh();  // Got to redraw all rows
				}
				else {
					if (updateBody) {
						this._grid.model.clearCache();
					}
					deferred = this._grid.body.refresh();
				}
				var t = this;
				if(deferred) {
					deferred.then(function(value){
						t.onRefresh();
					});
				}
			}

			return deferred ;
		},
		
		onRefresh: function() {
			// summary:  
			//		Callback on tree table refresh. Connect to this to perform some actions after gridx refresh is complete
			// tags: public	
		},
		
		destroy: function(){
			// summary:  
			//		Destroys the tree table.
			// tags: public	
			
			// memory leak issue: custom destroy method to take care of removing all widgets					
			try{
				if(this.menu){
					this.menu.destroyRecursive();
				}
				delete this.resources_;			
				//this is for destroying child templated widgets 
				//this should happen by itself but need to figure out why dijit._Templated is not taking care of it...
				var widgets = dijit.findWidgets(this.domNode);
				dojo.forEach(widgets, function(w) {
					if(w){
						if(w.destroyRecursive){
							w.destroyRecursive();
						} else if(w.destroy){
							w.destroy();
						}
					}
				});
				// this is for widgets added as child to this widget and their children..
				//not present in template
				var widgetArr = this.getChildren();
				dojo.forEach(widgetArr, function (child) {
					if(child){
						if(child.destroyRecursive){
							child.destroyRecursive();
						} else if(child.destroy){
							child.destroy();
						}
					}
				});
				this.inherited(arguments);
			}catch(ex){
				console.warn("Widget destroy failed: "+this.id+", ex="+ex.name+":"+ex.message);
			}
		}	
		
	});
	
	return TreeTable;
});
