// wrapped by build app
define("ibm/tivoli/tip/navwidget/dijit/NavWidgetInlineMessagePluggableView", ["dijit","dojo","dojox","dojo/i18n!ibm/tivoli/tip/navwidget/nls/messages","dojo/require!ibm/tivoli/navmodel/Trace,ibm/tivoli/navmodel/Exception,ibm/tivoli/tip/navwidget/dijit/NavWidgetPluggableView,dojoe/messagearea/MessageArea"], function(dijit,dojo,dojox){
/*********************************************************** {COPYRIGHT-TOP} ***
* Licensed Materials - Property of IBM
* Tivoli Widget Library
*
* (C) Copyright IBM Corp. 2014.  All Rights Reserved.
*
* US Government Users Restricted Rights - Use, duplication, or
* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
************************************************************ {COPYRIGHT-END} **/
dojo.provide("ibm.tivoli.tip.navwidget.dijit.NavWidgetInlineMessagePluggableView");

// includes
dojo.require("ibm.tivoli.navmodel.Trace");
dojo.require("ibm.tivoli.navmodel.Exception");
dojo.require("ibm.tivoli.tip.navwidget.dijit.NavWidgetPluggableView");
dojo.require("dojoe.messagearea.MessageArea");

dojo.requireLocalization("ibm.tivoli.tip.navwidget", "messages");

ibm.tivoli.tip.navwidget.dijit.NavWidgetInlineMessagePluggableView._trace = new ibm.tivoli.navmodel.Trace("ibm.tivoli.tip.navwidget.dijit.NavWidgetInlineMessagePluggableView");

dojo.declare("ibm.tivoli.tip.navwidget.dijit.NavWidgetInlineMessagePluggableView", [ ibm.tivoli.tip.navwidget.dijit.NavWidgetPluggableView ], {
	// summary:
	//		Base class for a view with inline message support that plugs into a NavWidget
	// description:
	//		Coming soon

	//**************************************************************************************/

	// _trace: [private] Trace
	//		Utility for trace and logging
	_trace : ibm.tivoli.tip.navwidget.dijit.NavWidgetInlineMessagePluggableView._trace,
	_messageArray : [],
	_messageContainer : null,

	displayMessage : function(/*Object*/msgId, /*Object*/msgSeverity, /*Object*/msgText) {
		// summary:
		//		Coming soon
		// description:
		//		Coming soon

		// Send to the parent view, if one exists
		
		if (this.parentPluggableView) {
			this.parentPluggableView.displayMessage(msgId, msgSeverity, msgText);
		}
		// Otherwise, send to the managing pluggable view, if one exists
		else if (this.managingPluggableView) {
			this.managingPluggableView.displayMessage(msgId, msgSeverity, msgText);
		} else {
			//No where else to turn, so we need to deal with it
			this.displayInlineMessage(msgId, msgSeverity, msgText);
		}
	},

	displayInlineMessage : function(/*Object*/msgId, /*Object*/msgSeverity, /*Object*/msgText) {
		
		console.debug("NavWidgetInlineMessagePluggableView:displayInlineMessage():BEGIN");
		
		if (!msgSeverity) {
			msgSeverity = "info";
		}
		console.debug(this.domNode.parentNode);
		if (!this._messageContainer) {
			this._messageContainer = dojo.create("div", {
				'class' : "inlineMessage",//Richa, #36863
				style : {
					width : "100%"
				}
			}, this.domNode.parentNode, "first");
		}

		//var msgArea = new dojoe.messagearea.MessageArea({type: type, message: message, region: "top"});
		var msgArea = new dojoe.messagearea.MessageArea({
			id : this.id + msgId,
			type : msgSeverity,
			message : msgText
		});

		msgArea.show();

		this._messageArray.push(msgArea);
		
		console.log(this._messageContainer);
		//if(this._messageContainer) this._messageContainer.addChild(msgArea);
		dojo.place(msgArea.domNode, this._messageContainer);
		//console.log(this.get("top"));
		console.debug("NavWidgetInlineMessagePluggableView:displayInlineMessage():END");
	},

	displayException : function(/*Object*/ex, /*Object*/dontTraceMessage) {
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		// Send to the parent view, if one exists
		if (this.parentPluggableView) {
			this.parentPluggableView.displayException(ex, dontTraceMessage);
		}
		// Otherwise, send to the managing pluggable view, if one exists
		else if (this.managingPluggableView) {
			this.managingPluggableView.displayException(ex, dontTraceMessage);
		} else {
			//No where else to turn, so we need to deal with it
			this.displayInlineException(ex, dontTraceMessage);
		}
	},

	displayInlineException : function(/*Object*/ex, /*Object*/dontTraceMessage) {
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		var msgId = null;
		var msgSeverity = null;
		var msgText = null;

		//Checking for existence of isInstanceOf before calling it because normal JS exception won't have an isInstanceOf
		//Also check that msgId, msgSeverity and msgText exist otherwise popup may not display
		if (ex && ex.isInstanceOf && ex.isInstanceOf(ibm.tivoli.navmodel.Exception) && ex.getMsgId() && ex.getMsgSeverity() && ex.getMsgText()) {
			msgId = ex.getMsgId();
			msgSeverity = ex.getMsgSeverity();
			msgText = ex.getMsgText();
		} else {

			//We have one of the following two messages to choose from. I don't think we're going to have enough in the exception to know if one of these is more appropriate than the
			//other. Also, I don't think we want to do the substitution for ${error_txt} since likely not translated.
			//
			//	- "TCTUI1002E":"An error has occurred.  The data provider could not return the data. ${error_txt}", // ${error_txt} will contain the error message returned from the server
			//	- "TCTUI1003E":"An error has occurred communicating with the server. ${error_txt}"  // ${error_txt} will contain the error message returned from the server

			msgId = "TCTUI1003E";
			msgSeverity = "Error";
			//74050: this_messages is undefined from NavWidgetInlineMessagePluggableView.js
			this._messages = dojo.i18n.getLocalization("ibm.tivoli.tip.navwidget", "messages");

			var messageTemplate = this._messages.TCTUI1003E;
			msgText = dojo.string.substitute(messageTemplate, {
				error_txt : ""
			}); //Doing an empty substitution since message in generic exception probably won't be translated
		}

		//Display the message
		this.displayMessage(msgId, msgSeverity, msgText);

		//Let's trace to the console window too
		if (!dontTraceMessage) {
			if (this._trace.isError()) {
				var methodName = "handleException";
				this._trace.error(ex, methodName);
			}
		}
	},

	clearMessages : function() {
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		// Send to the parent view, if one exists
		if (this.parentPluggableView && this.parentPluggableView.clearMessages) {
			this.parentPluggableView.clearMessages();
		}
		// Otherwise, send to the managing pluggable view, if one exists
		else if (this.managingPluggableView && this.managingPluggableView.clearMessages) {
			this.managingPluggableView.clearMessages();
		} else {
			//No where else to turn, so we need to deal with it
			this.clearInlineMessages();
		}
	},

	clearInlineMessages : function() {
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		if (this._messageArray) {
			for ( var i = 0; i < this._messageArray.length; i++) {
				if (this._messageArray[i].destroy) {
					this._messageArray[i].destroy();
				}
			}
		}
	}

});
});
