/*********************************************************** {COPYRIGHT-TOP} ***
* Licensed Materials - Property of IBM
* Tivoli Widget Library
*
* (C) Copyright IBM Corp. 2014.  All Rights Reserved.
*
* US Government Users Restricted Rights - Use, duplication, or
* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
************************************************************ {COPYRIGHT-END} **/
define("ibm/tivoli/tip/navwidget/groupwidget/dijit/GroupWidgetView", 
	[
		"dojo/_base/declare",
		"ibm/tivoli/tip/navwidget/dijit/NavWidgetPluggableView",
		"dojo/dom-style",
		"dojo/_base/lang",
		"dojo/query",
		"dojo/dom-construct",
		"dojox/widget/Standby"
	],
	function(declare, PluggableView, domStyle, lang, query, domConstruct, Standby) {
		return declare("ibm.tivoli.tip.navwidget.groupwidget.dijit.GroupWidgetView", [PluggableView], {
		
		datasetInfo: null,
		_usesWidgetDefinition : false,
		datasetInfo:null,
		childViews:null,
		node:null,
		standby: null,
		itemId:null,
		
		startup: function() {
			console.log("GrpWidgetView-startup ");
			for (var index = 0;  index < this.childViews.length;  ++index) {
				this.childViews[index].startup();
			}
			//this.inherited(arguments);
		},
		
		constructor: function() {
			//this.inherited(arguments);
		},
		
		_setDatasetLoadData: function(dataset){
			this.inherited(arguments);
			this._datasetReady(this.dataset);
		},

		refresh: function(){
			this._datasetReady(this.dataset);
		},
		
		_datasetReady: function(dataset){
			console.debug("GrpWidget-_datasetReady");		
			var kwArgs = {};
			kwArgs.onComplete = dojo.hitch(this,this._itemFetchComplete);
			//kwArgs.properties = ["all"];			
			if(dataset !== null) {
				kwArgs.count = 1;
				kwArgs.start = 0;
				kwArgs.clearCache =  dataset.isClearCacheOnRefresh();
				dataset.getItems(kwArgs);
			}
		},
	
		_itemFetchComplete: function(items) {
			console.debug("GrpWidget -- _itemFetchComplete");
			if(items && items[0]) // for scalar widgets: need itemId for eventing;
				this.itemId = items[0].getId();				
			for (var index = 0;  index < this.childViews.length;  ++index) {
				this.childViews[index].setItem(items);
			}
		},
		
		_handleItemStatusChangedEvent: function(event) {
			console.log("GrpWidget.js: _handleItemStatusChangedEvent event received");
		},
		
		_handleItemPropertiesChangedEvent: function(event) {	
			console.debug("GrpWidgetView-_handleItemPropertiesChangedEvent", event);
			if(event)
				this.itemId = event.getItems()[0].getId();	
			for (var index = 0;  index < this.childViews.length;  ++index) {
				this.childViews[index].itemPropertiesChanged(event);
			}
		},

		_handleItemsRemovedEvent: function(event) {
			console.info("_handleItemsRemovedEvent");
			this._datasetReady(event.getDataset());
		},
		
		_handleItemsAddedEvent: function(event) {
			console.info("_handleItemsAddedEvent");
			this._datasetReady(event.getDataset());
		},
		
		_handleChangedEvent: function(event) {	
			console.debug("datasetChanged event received");
			this._datasetReady(event.getDataset());
		},
		 
		addChildWidget: function(view) {
			if(!this.childViews)
				this.childViews = new Array();
			this.childViews.push(view);
		},
		
		setDatasetInfo: function(datasetInfo) {
			this.datasetInfo = datasetInfo;
		},
				
		showBusyPane: function(event){		
			if(this.standby) this.standby.show();		
		},	
		
		hideBusyPane: function(event){		
			if(this.standby) this.standby.hide();		
		},
		
		forceHideBusyPane: function(event){		
			if(this.standby) this.standby.hide();		
		}
		
	});
});
