// wrapped by build app
define("ibm/tivoli/tip/navwidget/table/dijit/LinksTableView", ["dijit","dojo","dojox","dojo/require!dojo/data/ItemFileReadStore,ibm/tivoli/tip/navwidget/topology/dijit/MenuProviderHelper,ibm/tivoli/navmodel/DatasetLinksStore,ibm/tivoli/tip/navwidget/table/dijit/AbstractTableView,ibm/tivoli/tip/navwidget/table/dijit/NavModelTable"], function(dijit,dojo,dojox){
/*********************************************************** {COPYRIGHT-TOP} ***
* Licensed Materials - Property of IBM
* Tivoli Widget Library
*
* (C) Copyright IBM Corp. 2014.  All Rights Reserved.
*
* US Government Users Restricted Rights - Use, duplication, or
* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
************************************************************ {COPYRIGHT-END} **/
/* 
 * Licensed Materials - Property of IBM
 * 
 * TIVOTCT00
 * 
 * �Restricted Materials of IBM�
 * 
 * Copyright IBM Corp. 2011, 2012 All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or 
 * disclosure restricted by GSA ADP Schedule Contract with 
 * IBM Corp. 
 */

dojo.provide ("ibm.tivoli.tip.navwidget.table.dijit.LinksTableView");

dojo.require("dojo.data.ItemFileReadStore");   // 49426  Gridx
// dojo.require("ibm.tivoli.tip.navwidget.topology.dijit.TopologyMenuLayer");   // 58415
dojo.require("ibm.tivoli.tip.navwidget.topology.dijit.MenuProviderHelper");
dojo.require("ibm.tivoli.navmodel.DatasetLinksStore");
dojo.require ("ibm.tivoli.tip.navwidget.table.dijit.AbstractTableView");
dojo.require("ibm.tivoli.tip.navwidget.table.dijit.NavModelTable");

ibm.tivoli.tip.navwidget.table.dijit.LinksTableView._trace = new ibm.tivoli.navmodel.Trace("ibm.tivoli.tip.navwidget.table.dijit.LinksTableView");

dojo.declare ("ibm.tivoli.tip.navwidget.table.dijit.LinksTableView",
	ibm.tivoli.tip.navwidget.table.dijit.AbstractTableView,
	{
	// summary:
	//		Coming soon
	// description:
	//		Coming soon
	
	//***************************
	// "Private"
	//***************************
	// _trace: [private] Trace
	//		Utility for trace and logging
	_trace: ibm.tivoli.tip.navwidget.table.dijit.LinksTableView._trace,
	
	constructor: function () {		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		
		this.title = this.commonResources.LINK_VIEW;
		this.label = this.commonResources.LINK_VIEW;   // 58415
		
		this.labelIconClass = "linkViewIcon";
	    this._pDEFAULT_WIDGET_DEF_INFO = {
				className: "ibm.tivoli.navmodel.TableWidgetDef",
				baseUrl: "/ibm/tivoli/rest",
		    	provider: "any",
		    	datasource: "any",
		    	widget: "table",
		    	definition: "DefaultLinksTable"
			},
		this._pTableType = "link";
		this._pTableClassName = "ibm.tivoli.tip.navwidget.table.dijit.NavModelTable";
		this._pDefaultColumns = [
				{id: "item2", label: this.commonResources.ITEM2, type: "string"},
				{id: "label", label: this.commonResources.TYPE,  type: "string"},
				{id: "item1", label:this.commonResources.ITEM1,  type: "string", sortOrder: 0} ];
	},
	
	// 58415
	postCreate: function() {
		dojo.attr(this.domNode, 'aria-label', this.label);
		this.inherited(arguments);
	},	

	isApplicable: function(/*ibm.tivoli.navmodel.Dataset*/dataset){
		// Primarily interested in the following view types: 
		//	viewType == "graph" || viewType == "tree" || viewType == "tree:reverse" || viewType == "table_relationship";
		return this.inherited(arguments);
	},

	// 58415
	augmentGridParams: function(gridParams) {    
		// summary:
		//		Set up gridParams as needed
		// description:
		//		Modify the gridParams to compensate for what dojoe.tablex wants
		
		// 58766
		if(!gridParams.label) {
			gridParams.label = this.label;
		}
		
        if (gridParams.filter) {
        	if (!gridParams.filter.isServerSide) {
        		gridParams.filter.isServerSide = true;
        	}
        }
        else {
        	gridParams.filter = {isServerSide : true}
        }
		
		// Reset the structure value to only the array of column descriptors and not the defaultCell info
		// Gridx does not support multiple or complicated nested layouts
 		if ((gridParams.structure.length == 1) && (gridParams.store instanceof dojo.data.ItemFileReadStore)) {						
			gridParams.structure = [{}];
		} else if ((gridParams.structure.length == 1) && ("rows" in gridParams.structure[0]) && (gridParams.structure[0].rows instanceof Array)) {
			gridParams.structure = gridParams.structure[0].rows; 
		} else if((gridParams.structure.length == 2) && ("rows" in gridParams.structure[0]) && (gridParams.structure[0].rows instanceof Array) && ("rows" in gridParams.structure[1]) && (gridParams.structure[1].rows instanceof Array)  ) {
	    	// if there are some defined locked columns, merge them into one array since
	    	// Gridx does not support true column locking, they will however appear
	    	// at the beginning of the table
	    	var layout1 = gridParams.structure[0].rows;
	    	var layout2 = gridParams.structure[1].rows;
	    	var layoutMerged = [];
    	
	    	layoutMerged = layout1.concat(layout2);

	    	gridParams.structure = layoutMerged;  	
	    }
		
		// Hidden columns should not be listed in the Configure Options dialog
		gridParams.structure = dojo.filter(gridParams.structure,  function(colDef) { return !(colDef.hidden); });
		
		return gridParams;
	},	
	
	_createTableStore: function(columnIds){
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		// columnIds:
		//		
		if(!columnIds) {
			columnIds = ["all"];
		}
		// create or update store

		if (!this._dataStore) {   // 49426  Gridx (split out to always return some store)
            if (this.dataset) {
            	// 58415 : remove special properties for label, item1 and item2
            	// as they are not properties in the traditional sense, but mapped to other
            	// Link getter functions
            	var defaultColIds = null;
            	if (columnIds && columnIds.length > 0) {
            		defaultColIds = dojo.filter(columnIds, function(id) {return (id != "label") && (id != "item1") && (id != "item2");});
            	}
            	else {
            		defaultColIds = columnIds;
            	}
            	this._dataStore = new ibm.tivoli.navmodel.DatasetLinksStore({dataset:this.dataset, returnItem:true, defaultProperties:defaultColIds});
            }
            else {
				//No dataset, so just create an empty store
				/*var emptyStore = 	new dojo.data.ItemFileReadStore({
					  					data: { items: []}
	                				});
				this._dataStore = emptyStore; */
				console.warn("LinksTableView.js: No dataset, skipping empty datastore");	// 58415			
            }
		   this.inherited(arguments);
		}
	}		
	
	/////////////////////////////////////////////////
	// Selection change handling
	/////////////////////////////////////////////////
	/* _handlingSelectOrDeselectAll: false,
	_handlingSelectionChangedCallback: false,
	_gridSelectionChangedCallback: function() {		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		this._handlingSelectionChangedCallback = true;
		
		if (!this.selection.isChanging()&& ! this._handlingSelectOrDeselectAll) {
			//Get the grid's selection... will be an array of Client Dataset Relationships
			var selectedRows = this._grid.selection.getSelected(); 

			//Set the selected links on the view's selection object
			this.selection.setSelectedObjects(null, selectedRows, null, null);
		}
		
		this._handlingSelectionChangedCallback = false;
	} */	
});

});
