// wrapped by build app
define("ibm/tivoli/tip/navwidget/topology/dijit/MenuProviderHelper", ["dijit","dojo","dojox","dojo/i18n!ibm/tivoli/tip/navwidget/nls/resources","dojo/require!ibm/tivoli/tip/navwidget/topology/dijit/MenuProviderHelperBase,ibm/tivoli/tip/navwidget/dojo/NavWidgetUtil,ibm/tivoli/tip/navwidget/properties/dijit/PropertiesNotebookDialog,ibm/tivoli/navmodel/NavWidgetDef,ibm/tivoli/navmodel/Trace,dojox/layout/ResizeHandle"], function(dijit,dojo,dojox){
/*********************************************************** {COPYRIGHT-TOP} ***
* Licensed Materials - Property of IBM
* Tivoli Widget Library
*
* (C) Copyright IBM Corp. 2014.  All Rights Reserved.
*
* US Government Users Restricted Rights - Use, duplication, or
* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
************************************************************ {COPYRIGHT-END} **/
/* 
 * Licensed Materials - Property of IBM
 * 
 * TIVOTCT00
 * 
 * �Restricted Materials of IBM�
 * 
 * Copyright IBM Corp. 2011, 2012 All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or 
 * disclosure restricted by GSA ADP Schedule Contract with 
 * IBM Corp. 
 */

dojo.provide("ibm.tivoli.tip.navwidget.topology.dijit.MenuProviderHelper");

dojo.require("ibm.tivoli.tip.navwidget.topology.dijit.MenuProviderHelperBase");    // 256005  Moved out to its own file for Dojo 1.7
dojo.require("ibm.tivoli.tip.navwidget.dojo.NavWidgetUtil");
dojo.require("ibm.tivoli.tip.navwidget.properties.dijit.PropertiesNotebookDialog");
dojo.require("ibm.tivoli.navmodel.NavWidgetDef");
dojo.require("ibm.tivoli.navmodel.Trace");
dojo.requireLocalization("ibm.tivoli.tip.navwidget", "resources");
dojo.require("dojox.layout.ResizeHandle");

dojo.declare("ibm.tivoli.tip.navwidget.topology.dijit.MenuProviderHelper",
	      ibm.tivoli.tip.navwidget.topology.dijit.MenuProviderHelperBase,
{		
	// summary:
	//		Coming soon
	// description:
	//		Coming soon
	
	//_propDialog: [private] Object
	//		Coming soon
	_propDialog: null,

	// resizeAxis: String
	//  x | xy | y to limit pane's sizing direction.
	resizeAxis: "xy",
			
	// enableResizeHandle: boolean
	//a flag to enable/disable the resize handle, default is true
	enableResizeHandle: true,
	
	/* Richa Defect#54789 Adding the resize handle to properties dialog box. */
	setSize: function(){			
			if(this.enableResizeHandle == true){
			//Build and place resize handle       
			var resizeHandleDOM = dojo.doc.createElement( 'span' );
			resizeHandleDOM.className = "dojoxFloatingResizeHandle";    
			dojo.place( resizeHandleDOM, this._propDialog.domNode, "last" );
			this.resizeHandle = new dojox.layout.ResizeHandle(
			{ 
				targetId: this._propDialog.id, 
				resizeAxis: this.resizeAxis 
			}, resizeHandleDOM );  
			this.onResizeListener = dojo.connect( this._propDialog, "resize", this, "customLayout" );		
		}
		},

	customLayout: function() 
      {
		/* summary: Resizes the Properties Dialog. */

		var generalDiv1 = dojo.byId( this._propDialog.id + '_myProperties_GENERAL_PROPERTIES_VIEW' );
		var generalDiv = dojo.byId( this._propDialog.id + '_myProperties' );
	//	var x = this._propDialog.id + '_myProperties_tablist_'+ this._propDialog.id + '_myProperties_GENERAL_PROPERTIES_VIEW'
		var dialogSize = dojo.contentBox( this._propDialog.domNode );


    // IE 8 was causing some bogus numbers to appear when the dialog first open, if that happens ignore the caller.
    if( dialogSize.w < 0 || dialogSize.h < 0 ){
			console.log( "[customLayout] Ignoring resize request since dialogSize is negative. " );
			return;
		}
		
		var titleBarSize = dojo.marginBox( this._propDialog.titleBar );
		
		// Start collect information about the various elements of the dialog box
		var cBox = dojo.marginBox( this._propDialog.containerNode );
	    var msgBox = dojo.marginBox( generalDiv );
		var newSize = { h:0 };

		//Debug information to validate calculations or if funny things happen 
	/*    console.info( "[customLayout] =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=" );
	    console.info( "[customLayout] dialogSize [ w=" + dialogSize.w + ", h="+ dialogSize.h + "]" );
		console.info( "[customLayout] cBox [ w=" + cBox.w + ", h=" + cBox.h + "]" );
		console.info( "[customLayout] msgBox [ w=" + msgBox.w + ", h=" + msgBox.h + "]" );
		console.info( "[customLayout] titleBarSize [ w=" + titleBarSize.w + ", h=" + titleBarSize.h + "]" ); */
		
		/* We subtract the current message box size from the content box size to figure out how much margins, padding, and
		   surrounding content are taking up space so we can correctly adjust the width and height of the message description
			 based on the detla we're given by the resize event. */

		newSize.h = dialogSize.h - titleBarSize.h - (cBox.h - msgBox.h);
		
		//Set the minimum height.. calculations not working now..fixed to 100px.
		var minDataDiv=('.' + this._propDialog.id + '_myProperties_GENERAL_PROPERTIES_VIEWgeneralTab' );
		var minDataDiv1=('.' + this._propDialog.id + '_myProperties_GENERAL_PROPERTIES_VIEW_NAME_Name.value_id' );

		var msgId = dojo.query( minDataDiv, this._propDialog.domNode )[0]|| 
					dojo.query( minDataDiv1, this._propDialog.domNode )[0] ||null;

		if( msgId !== null ){	
		  var minHeight = dojo.marginBox( msgId );	  
		} else {
			//console.log( "[customLayout] Unable to determine the min height of a text string all plan exhasted.", msgId );
			var minHeight = { h:100 };
		}
		newSize.h = Math.max( minHeight.h, newSize.h );
		console.info("newSize.h is "+newSize.h);
		
	    dojo.contentBox( generalDiv, newSize );
		dojo.contentBox( generalDiv1, newSize );
	},

	getMenuItems: function(/*Object*/ context) {		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		// context:
		//		Coming soon
		var items = this.inherited(arguments);
		
		// Note: Add code here to add JSON menu item objects (for our built-in actions) to items
		// Example: 
		//    items.push( { "actionID":"someUniqueID",
		//                  "label":"someLabelForTheItem",
		//                  "launchType":"NOOP" } );
		// Note: For globalization, the label will need to be loaded from a resource bundle.
		//       Also, setting launchType to NOOP is optional, but may simplify code in
		//       getMenuCommand (see below)
		
		
		//The PropertiesNotebook should not be displayed unless only a single item is selected
		//first check the context to make sure multiple items are not selected
		//checks if only one item or link
		var selectedObjects = context.selection;
		if(( selectedObjects.getItemCount() + selectedObjects.getLinkCount() + selectedObjects.getRelationshipCount()) == 1){
				
			var object = null;
			
			if(selectedObjects.getItemCount() == 1){
				object = selectedObjects.getItems()[0];            
			}else if(selectedObjects.getRelationshipCount() == 1){
				object = selectedObjects.getRelationships()[0];
			}else if(selectedObjects.getLinkCount() == 1){
				object = selectedObjects.getLinks()[0];
			}else{
				console.log("Cannot handle non link, rel, or item objects. No action preformed.");
			}
			
			//if the object doesnt support properties, dont add prop menu item.
			if(object && object.supportsProperties() ){
				//Add the PropertiesNotebook to the Menu list of items
				items.push(
					{ 
					  "actionID": "_separator_" 
					},
					{ "actionID": "nwmi_PropertiesNotebookDialog",
					  "label": ibm.tivoli.tip.navwidget.dojo.NavWidgetUtil.getStringWithEllipsis(this._resources.PROPERTIES),
					  "launchType":"NOOP"
					}			
				  );	
			}
			
		} else {

			//Get Default Actions for this specific view
			var tasks = context.getViewSpecificTasks();
			if (tasks) {
				items.push(
						{ 
						  "actionID": "_separator_",
						  "launchType":"VIEW_COMMAND"
						});	
				// 48183
                var startIdx = 0;
                if (tasks.length > 0 && tasks[0][0] == "_separator_") {
                	startIdx = 1;  // skip first task if it is a separator so we do not have two in a row
                }
				for (var i=startIdx;i<tasks.length;i++) {			
					items.push(
							{ "actionID": tasks[i][0],
							  "label": tasks[i][1],
						 	 "launchType":tasks[i][2]
							}			
				  		);
				}
			}		
		}	

		return items;
	},
	
	getMenuCommand: function(/*Object*/ commandName, /*Object*/ context, /*Object*/ menuItem) {		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		// commandName:
		//		Coming soon
		// context:
		//		Coming soon
		// menuItem:
		//		Coming soon
		var result = null;
		
		// Note: add code here to check the commandName (which is also the actionID from 
		// menuItem) and if it is one of our actions, do or call whatever is needed to do 
		// the work and then set the result to a no-op command so the TIPContextMenu will 
		// take no action on the returned result
		// Ex:
		//     result = {"launchType":"NOOP"};
		//  or
		//     result = menuItem;  (if the launchType="NOOP" was already an attribute in the menu item)
		//
		
		//command name is = to actionID...so if one of the special menu items added above, do special processing
		
		// make sure we have a menu item (default action/task processing can call with just a 
		// command and no menuItem)
		if (menuItem && (menuItem.launchType == "VIEW_COMMAND")) {
			context.executeViewSpecificTask(commandName);
			result = {"launchType":"NOOP"}; 
			return result;
		}

		switch (commandName) {
			case "nwmi_PropertiesNotebookDialog":			
				//The PropertiesNotebook should not be displayed unless only a single item is selected
				//first check the context to make sure multiple items are not selected
				//checks if only one item or link
				var selectedObjects = context.selection;
				if(( selectedObjects.getRelationshipCount() + selectedObjects.getLinkCount() + selectedObjects.getItemCount() ) != 1){
					//if there is more than one item then just return and do nothing
					result = menuItem;
					return result;
				}
				

				// 48463: DefaultActionHelper is stopping the default action if the selected context object does not support Properties dialog even if another default action has been specified
				// Need to get the selected object here so we can check if it supports properties or not before display the Properties dialog
                var selectedObject = null;
                if(selectedObjects.getItemCount() == 1) {
                	selectedObject = selectedObjects.getItems()[0];
                } else if(selectedObjects.getRelationshipCount() == 1) {
                	selectedObject = selectedObjects.getRelationships()[0];
                }else if(selectedObjects.getLinkCount() == 1) {
                	selectedObject = selectedObjects.getLinks()[0];
                } else {
                	console.log("Cannot handle non link, rel, or item objects. No action preformed.");
                    result = menuItem;
                    return result;
                }							
				if (selectedObject.supportsProperties()) { // Only display dialog if the object supports Properties
					//Try to look up nav widget def and get widget definition for props notebook
					var dialogWidgetDefinitionId = null;
					var topLevelPluggableViewWidgetDefinition = context.getTopLevelPluggableViewWidgetDefinition();
					if (topLevelPluggableViewWidgetDefinition != null && topLevelPluggableViewWidgetDefinition.isInstanceOf(ibm.tivoli.navmodel.NavWidgetDef)) {
						var notebook = topLevelPluggableViewWidgetDefinition.getNotebook();
						if (notebook) {
							dialogWidgetDefinitionId = notebook.definition;
						}
					}
					
					// if there is one item then create the PropertiesNotebookDialog
					this._propDialog = new ibm.tivoli.tip.navwidget.properties.dijit.PropertiesNotebookDialog({
						id: context.id + "_PropertiesDialog",
						//Richa defect #54789: Removing the tundra class setting
						//className: "tundra",
						//Richa defect #54789: adding class to override the styles
						className: "propertiesNotebook",
						//Richa : Min width of 400px was not being set because of this and hence the scrollbar was hidden
						// style: "width:40%",
						managingPluggableView: context,
						widgetDefinitionId: dialogWidgetDefinitionId
					});
					
					this._propDialog.setDataset(context.dataset);
                
					if(selectedObjects.getItemCount() == 1){
						var item = selectedObjects.getItems()[0];
						//set the object on the dialog (hardcoded to 0 since we checked there is only one item
						this._propDialog.setObjects([item]);
                    
					}else if(selectedObjects.getRelationshipCount() == 1){
						var rel = selectedObjects.getRelationships()[0];
						//set the object on the dialog (hardcoded to 0 since we checked there is only one item
						this._propDialog.setObjects([],[],[rel]);
					}else if(selectedObjects.getLinkCount() == 1) {
						var link = selectedObjects.getLinks()[0];
						//set the object on the dialog (hardcoded to 0 since we checked there is only one item
						this._propDialog.setObjects([],[link]);
					}else{
						console.log("Properties dialog does not render anything other than links, items, or relationships.");
					}
					this.setSize();
					//display the dialog
					this._propDialog.startup();
					this._propDialog.show();
					// dojo.connect(this._propDialog,"onCancel" ,dojo.hitch(this, this._cleanupDialog));
				}
				else {
					console.log("object does not support properties, performing no action");
				}
				
                //done return
				result = menuItem;
				return result;
			
			default:
				// Note: If this is NOT one of our client-side actions, DO NOT set result and let
				// the parent class command be returned
				return (result) ? result : this.inherited(arguments);
			
		}
	}
	
});
});
