/*
 * Licensed Materials - Property of IBM
 *
 * OCO Source Materials
 *
 * (C) Copyright IBM Corp. 2012 All Rights Reserved
 *
 * The source code for this program is not published or other-
 * wise divested of its trade secrets, irrespective of what has
 * been deposited with the U.S. Copyright Office.
 */
/*global define */
define("ibm/usmi/scheduler/wizard_pages/nls/es/JobLaunchWizardResources", {
	/**
	 * This file contains resources for each page of the job launch wizard.
	 * Please keep overall Job Launch Wizard resources in the first section of
	 * the file. The second section contains resources for the Schedule page.
	 * The third section contains resources for the Notifications page. The
	 * fourth section contains resources for the Options page.
	 */

	/**
	 * Section 1: Overall Job Launch Wizard resources.
	 */
	// Messages:
	JOB_SUCCESSFULLY_RUN_NOW : "El trabajo siguiente se ha creado e iniciado correctamente: ",
	JOB_SUCCESSFULLY_SCHEDULED : "El trabajo siguiente se ha creado y planificado correctamente: ",
	JOB_CREATION_FAILED : "Ha fallado la creación del nuevo trabajo.",
	JOB_FAILED_RESPONSE : "Si el problema continúa, póngase en contacto con el servicio de soporte.",
	// The following error message should never be displayed to the user.  There 
	// are no scenarios where this message should ever needed
	// However, if a bug exists in the code, this message can be used so that
	// the UI does not crash (and give no reason to the user why the UI did not function
	// as expected).  Currently logging is not defined...When logging is defined and working, 
	// the code is obligated to log additional information (when available) before issuing
	// this message.
	GENERIC_ERROR_MESSAGE : "Se ha producido un problema al intentar lanzar la tarea.",
	GENERIC_ERROR_RESPONSE : "Si el problema persiste, póngase en contacto con el siguiente nivel de soporte o con el representante de servicio.",
	
	// Field labels:
	SUBMIT_BUTTON_LABEL : "Enviar",
			
	// Completion Message link text
	VIEW_JOB_LINK_TEXT : "Ver trabajo",

	/**
	 * Section 2: Resources for the Schedule Page of the Job Launch Wizard.
	 */
	// Page title:
	SCHEDULE_PAGE_TITLE : "Planificación",

	// Messages:
	NO_VALID_JOB_NAME_ERROR : "El valor introducido para el nombre del trabajo no es válido.",
	MISSING_CUSTOM_DATES : "No se han seleccionado fechas personalizadas.",
	SELECTED_DATE_IN_PAST : "La fecha y la hora actualmente seleccionadas quedan en el pasado o ahora mismo.",
	REPEAT_FOR_DURATION_NOT_VALID : "Elija un valor de duración para Repetir para entre el 1 y el 5000.",
	REPEAT_UNTIL_DURATION_NOT_VALID : "El valor de duración de Repetir hasta es anterior a la fecha de planificación.",
	MISSING_SELECTED_DAY_OF_WEEK : "No se ha seleccionado ningún día de la semana.",
	MISSING_MONTHLY_DATES : "No se han seleccionado fechas mensuales.",
	CUSTOM_DATE_ALREADY_SELECTED : "La fecha personalizada seleccionada ya existe en la lista.  Seleccione una fecha distinta.",
	CUSTOM_DATE_IN_PAST : "La fecha personalizada seleccionada queda en el pasado o ahora mismo.  Seleccione una fecha distinta.",
	MONTHLY_DATE_ALREADY_SELECTED : "La fecha mensual seleccionada ya existe en la lista.  Seleccione una fecha distinta.",

	// Field labels:
	WHEN_TO_RUN_LABEL : "Cuando realizar la ejecución:",
	JOB_NAME_LABEL : "Nombre del trabajo:",
	SCHEDULE_DATE_LABEL : "Fecha :",
	SCHEDULE_TIME_LABEL : "Hora :",
	REPEATE_OPTIONS_LABEL : "Opciones de repetición:",
	FREQUENCY_LABEL : "Frecuencia:",
	WEEKEND_LABEL : "En fines de semana:",
	WEEKLY_VALUES_LABEL : "Ejecutar cada semana en los días siguientes:",
	MONTHLY_SELECT_LABEL : "Ejecutar cada mes en los días siguientes:",
	CUSTOM_DATES_ADD_VALUES_PROMPT : "Pulse Añadir para añadir la fecha anterior a la lista de fechas planificadas a continuación.",
	DURATION_LABEL : "Duración:",
	REPEAT_OPTIONS_LABEL : "Opciones de repetición:",
	REPEAT_FOR_VALUE_LABEL : "Repetir para:",
	REPEAT_UNTIL_VALUE_LABEL : "Repetir hasta:",
	REPEAT_FOREVER_PROMPT : "Ilimitado",
	REPEAT_FOR_PROMPT : "Durante",
	REPEAT_UNTIL_PROMPT : "Hasta",
	ADD_BUTTON_LABEL : "Añadir",
	REMOVE_BUTTON_LABEL : "Eliminar",

	// Field values:
	RUN_NOW_VALUE : "Ejecutar ahora",
	RUN_LATER_VALUE : "Planificar",
	REPEAT_FOREVER_VALUE : "Repetir siempre",
	REPEAT_SELECTION_ONCE_VALUE : "Una vez",
	REPEAT_SELECTION_HOURLY_VALUE : "Cada hora",
	REPEAT_SELECTION_DAILY_VALUE : "Diariamente",
	REPEAT_SELECTION_WEEKLY_VALUE : "Semanalmente",
	REPEAT_SELECTION_MONTHLY_VALUE : "Mensualmente",
	REPEAT_SELECTION_YEARLY_VALUE : "Anualmente",
	REPEAT_SELECTION_CUSTOM_VALUE : "Personalizado",
	WEEKEND_DONT_MOVE_VALUE : "No trasladar",
	WEEKEND_MOVE_TO_FRIDAY_VALUE : "Trasladar a viernes",
	WEEKEND_MOVE_TO_MONDAY_VALUE : "Trasladar a lunes",
	WEEKEND_MOVE_TO_WEEKDAY_VALUE : "Trasladar al día laborable más próximo",
	WEEKEND_DELETE_VALUE : "Suprimir",
	WEEKLY_SUNDAY_VALUE : "Domingo",
	WEEKLY_MONDAY_VALUE : "Lunes",
	WEEKLY_TUESDAY_VALUE : "Martes",
	WEEKLY_WEDNESDAY_VALUE : "Miércoles",
	WEEKLY_THURSDAY_VALUE : "Jueves",
	WEEKLY_FRIDAY_VALUE : "Viernes",
	WEEKLY_SATURDAY_VALUE : "Sábado",

	MONTHLY_DATE_1ST_VALUE : "día 1",
	MONTHLY_DATE_2ND_VALUE : "día 2",
	MONTHLY_DATE_3RD_VALUE : "día 3",
	MONTHLY_DATE_4TH_VALUE : "día 4",
	MONTHLY_DATE_5TH_VALUE : "día 5",
	MONTHLY_DATE_6TH_VALUE : "día 6",
	MONTHLY_DATE_7TH_VALUE : "día 7",
	MONTHLY_DATE_8TH_VALUE : "día 8",
	MONTHLY_DATE_9TH_VALUE : "día 9",
	MONTHLY_DATE_10TH_VALUE : "día 10",
	MONTHLY_DATE_11TH_VALUE : "día 11",
	MONTHLY_DATE_12TH_VALUE : "día 12",
	MONTHLY_DATE_13TH_VALUE : "día 13",
	MONTHLY_DATE_14TH_VALUE : "día 14",
	MONTHLY_DATE_15TH_VALUE : "día 15",
	MONTHLY_DATE_16TH_VALUE : "día 16",
	MONTHLY_DATE_17TH_VALUE : "día 17",
	MONTHLY_DATE_18TH_VALUE : "día 18",
	MONTHLY_DATE_19TH_VALUE : "día 19",
	MONTHLY_DATE_20TH_VALUE : "día 20",
	MONTHLY_DATE_21ST_VALUE : "día 21",
	MONTHLY_DATE_22ND_VALUE : "día 22",
	MONTHLY_DATE_23RD_VALUE : "día 23",
	MONTHLY_DATE_24TH_VALUE : "día 24",
	MONTHLY_DATE_25TH_VALUE : "día 25",
	MONTHLY_DATE_26TH_VALUE : "día 26",
	MONTHLY_DATE_27TH_VALUE : "día 27",
	MONTHLY_DATE_28TH_VALUE : "día 28",
	MONTHLY_DATE_29TH_VALUE : "día 29",
	MONTHLY_DATE_30TH_VALUE : "día 30",
	MONTHLY_DATE_31ST_VALUE : "día 31",

	REPEAT_FOR_HOURS_VALUE : "Horas",
	REPEAT_FOR_DAYS_VALUE : "Días",
	REPEAT_FOR_WEEKS_VALUE : "Semanas",
	REPEAT_FOR_MONTHS_VALUE : "Meses",
	REPEAT_FOR_YEARS_VALUE : "Años",

	/**
	 * Section 3: Resources for the Notifications Page of the Job Launch Wizard.
	 */
	// Page title:
	NOTIFICATIONS_PAGE_TITLE : "Notificaciones",

	// Messages:
	PERCENT_FAILED_VALUE_NOT_SET_ERROR : "Elija un porcentaje de destinos fallidos que esté entre el 1 y el 100.",
	NUMBER_FAILED_VALUE_NOT_SET_ERROR : "Elija un número de destinos fallidos que sea superior al 0.",
	MISSING_EMAIL_INFORMATION : "Asegúrese de que se haya introducido información en todos los campos de correo electrónico.",
	EMAIL_ADDRESS_WRONG_FORMAT : "La dirección de correo electrónico tiene un formato incorrecto",

	// Field labels:
	RECEIVE_NOTIFICATIONS_LABEL : "Recibir notificaciones:",
	JOB_FAILS_ANY_ERROR_RADIO_LABEL : "Cualquier error",
	JOB_FAILS_PERCENT_ERROR_RADIO_LABEL : "Porcentaje de destinos con errores:",
	JOB_FAILS_NUMBER_ERROR_RADIO_LABEL : "Número de destinos con errores:",
	EMAIL_INFORMATION_LABEL : "Información de correo electrónico:",
	EMAIL_ADDRESS_LABEL : "Dirección de correo electrónico:",
	EMAIL_SERVER_LABEL : "Nombre del servidor de correo electrónico:",
	EMAIL_PORT_LABEL : "Número de puerto del servidor de correo electrónico:",

	// Field values:
	JOB_BEGINS_VALUE : "Notificar cuando se inicie el trabajo.",
	JOB_COMPLETES_OK_VALUE : "Notificar cuando se complete correctamente el trabajo.",
	JOB_FAILS_VALUE : "Notificar cuando este trabajo falle. ",

	/**
	 * Section 4: Resources for the Notifications Page of the Job Launch Wizard.
	 */
	// Page title:
	OPTIONS_PAGE_TITLE : "Opciones",

	// Messages:
	MAXIMUM_JOB_INSTANCES_VALUE_ERROR : "Elija un número máximo de instancias de trabajo entre 10 y 100.",

	// Field labels:
	SYSTEM_TIMES_LABEL : "Horas del sistema:",
	UNAVAILABLE_SYSTEMS_LABEL : "Sistemas no disponibles:",
	MAXIMUM_JOBS_LABEL : "Instancias máximas de trabajo:",
	MANAGEMENT_SERVER_TIME_RADIO : "Utilizar la hora del servidor de gestión",
	LOCAL_SYSTEM_TIME_RADIO : "Utilizar hora de sistema local",
	FAIL_IF_UNAVAILABLE_RADIO : "Error si el sistema no está disponible",
	RUN_WHEN_AVAILABLE_RADIO : "Ejecutar cuando el sistema quede disponible"
});

