/*
 * Licensed Materials - Property of IBM
 *
 * OCO Source Materials
 *
 * (C) Copyright IBM Corp. 2012, 2013 All Rights Reserved
 *
 * The source code for this program is not published or other-
 * wise divested of its trade secrets, irrespective of what has
 * been deposited with the U.S. Copyright Office.
 */
define(
        "ibm/usmi/statuspod/JobStatusPodMenuItem", [
            "dojo/_base/declare",
            "./StatusPodMenuItem",
            "dojo/_base/connect",
            "./Constants"
        ],
        function(declare, StatusPodMenuItem, connect, Constants) {
            return declare(
                    [ StatusPodMenuItem
                    ],
                    {
                        // summary:
                        //      Job Status Pod Menu Item 

                        onClick: function(/*Event*/) {
                            // summary:
                            //      click the menu item to launch the target page for the job
                            var menuItemOnClickFunc = window["launchInContext"];
                            var url = window.location.protocol
                                    + '//'
                                    + location.host
                                    + '/ibm/console/xLaunch.do?pageID=com.ibm.usmi.console.scheduler.navigationElement&moduleRef=com.ibm.director.core.console.tasks&hideTaskArea=false&disableNavArea=false&hideBannerArea=false&hideTaskBarArea=false&hideNavArea=true';
                            url = url + '&DCMJobId=' + this.objectId;
                            this._logger.finest("external launch url is:" + url, "onClick");
                            menuItemOnClickFunc(null, null, url);
                            connect.publish(Constants.TOPIC_CLOSE_JOBS_DIALOG);
                        }
                    });
        });
