require({cache:{
'url:ibm/usmi/widgets/templates/LoginWindow.html':"<div style=\"height:100%\" dojoAttachPoint=\"outDialog\">\r\n<!--\r\n\r\nLicensed Materials - Property of IBM\r\n\r\n(C) Copyright IBM Corp. 2012 All Rights Reserved\r\n\r\nUS Government Users Restricted Rights - Use, duplicate or\r\ndisclosure restricted by GSA ADP Schedule Contract with\r\nIBM Corp.\r\n\r\n-->\r\n<table>\r\n<tr>\r\n<td width=\"25%\"></td>\r\n<td width=\"50%\" align=\"center\">\r\n\r\n<div dojoAttachPoint=\"inDialog\" class=\"logindialog\" dojoType=\"dijit.layout.ContentPane\">\r\n\t<div class=\"logindialogcontent\">\r\n\t\t<image src=\"${titleImage}\" />\r\n\t\t<div class=\"title\">${nls.TITLE}</div>\r\n\t\t<div class=\"version\">${nls.VERSION}</div>\r\n\t\t<div dojoAttachPoint=\"loginPane\">\r\n\t\t\t<div class=\"line\"><input id=\"${id}UserName\" hint=\"${nls.USER_NAME}\" hintPosition=\"inside\" dojoAttachEvent=\"onKeyDown:_userKeyDown\" type=\"text\" dojoType=\"idx.oneui.form.TextBox\" name=\"username\" required=\"true\" value=\"\" dojoAttachPoint=\"loginUserName\" missingMessage=\"${nls.INVALID_MSG_USR}\" invalidMessage=\"${nls.INVALID_MSG_USR}\" regExp=\"${regExp}\"></div>\r\n\t\t\t<div class=\"line\"><input id=\"${id}Password\" hint=\"${nls.PASSWORD}\" hintPosition=\"inside\" dojoAttachEvent=\"onKeyDown:_passwordKeyDown\" type=\"password\" dojoType=\"idx.oneui.form.TextBox\" name=\"password\" required=\"true\" value=\"\" dojoAttachPoint=\"loginPassword\" missingMessage=\"${nls.INVALID_MSG_PWD}\" invalidMessage=\"${nls.INVALID_MSG_PWD}\" regExp=\"${regExp}\"></div>\r\n\t\t\t<div class=\"line\"><button id=\"${id}Submit\" dojoType=\"dijit.form.Button\" dojoAttachPoint=\"loginButton\" dojoAttachEvent=\"onClick:_onSubmitClick\" name=\"login\">${nls.OK}</button></div>\r\n\t\t</div>\r\n\t\t<div id=\"${id}Message\" class=\"line\" dojoAttachPoint=\"messagePane\">\r\n\t\t</div>\r\n\t\t<div style=\"display:none;\">\r\n\t\t\t<form dojoAttachPoint=\"loginHiddenForm\" action=\"/ibm/console/j_security_check\" method=\"post\">\r\n\t\t\t\t<input dojoAttachPoint=\"j_username\" name=\"j_username\" />\r\n\t\t\t\t<input dojoAttachPoint=\"j_password\" name=\"j_password\" type=\"password\" />\r\n\t\t\t</form>\r\n\t\t</div>\r\n\t\t<div class=\"copyright\">&copy;${nls.COPYRIGHT}</a></div>\r\n\t</div>\r\n</div>\r\n\r\n</td>\r\n<td width=\"25%\"></td>\r\n</tr>\r\n</table>\r\n</div>"}});
/*
 * Licensed Materials - Property of IBM
 *
 * OCO Source Materials
 *
 * (C) Copyright IBM Corp. 2012, 2014 All Rights Reserved
 *
 * The source code for this program is not published or other-
 * wise divested of its trade secrets, irrespective of what has
 * been deposited with the U.S. Copyright Office.
 */

define("ibm/usmi/widgets/LoginWindow", [
	"dojo/hash",
	"dojo/_base/declare",
	"dijit/_WidgetBase",
	"dijit/_Templated",
	"dojo/i18n!./nls/LoginWindow",
	"dojo/text!./templates/LoginWindow.html",	
	"dijit/focus",
	"ibm/usmi/core/utils/Logger",
	"ibm/usmi/widgets/FrameworkMessage",
	"idx/form/TextBox",
	"dijit/form/Button",
	"dijit/layout/ContentPane"
], function (hash, declare, _Widget, _Templated, mri, template, focus, Logger, Message) {

	return declare("ibm.usmi.widgets.LoginWindow", [
		_Widget,
		_Templated
	], {
		nls : mri,
		regExp : ".*",
		templateString : template,
		widgetsInTemplate : true,
		messageBox : undefined,
		titleImage : "js/ibm/usmi/widgets/themes/login/images/LoginLogo.png",
		nextUrl: "index.html#",
		logger : new Logger("ibm.usmi.widgets", "LoginWindow"),
		
		postMixInProperties : function () {
			this.inherited(arguments);

			var branding;
			var brandingUrl = "dojo/text!./js/ibm/usmi/widgets/templates/loginbranding.json";
			require([brandingUrl], function(loginbranding) {
				if (loginbranding) {
					branding = dojo.fromJson(loginbranding);
				}
			});			
			
			var replaceNls = function(jsp) {
				var jspjson = dojo.fromJson(jsp);
				if (jspjson) {					
					if (jspjson.FULL_PRODUCT_NAME) {
						this.nls.TITLE = jspjson.FULL_PRODUCT_NAME;
					}
					if (jspjson.PRODUCT_VERSION) {
						this.nls.VERSION = this.nls.BRANDED_VERSION + jspjson.PRODUCT_VERSION;
					}
					//if (jspjson.COMPANY_LOGO_IMAGE_61x25) {
					//	this.titleImage = jspjson.COMPANY_LOGO_IMAGE_61x25;
					//}
					//... other keys ...
				}				
			};
			if (branding && branding.enable) {
				// If branding is enabled, replace the default nls with keys
				// from branding
				this.logger.info("Branding service is enabled.", "postMixInProperties");
				var nlsBranding = "dojo/text!"+branding.url;
				require([nlsBranding], dojo.hitch(this, replaceNls));
			}
			
		},
		
		postCreate : function () {
			this.inherited(arguments);
			focus.focus(dojo.byId(this.id + "UserName"));
				//when the username textbox gets focus, the hint text disappears so need to redisplay it
			this._showTextboxHint(this.loginUserName);
			this.nextUrl += hash();
		},

		_userKeyDown : function (key) {
			this.cleanMessage();
			this._hideTextboxHint(this.loginUserName);
			if (key && key.keyCode === 13) {
				focus.focus(dojo.byId(this.id + "Password"));
			}
		},

		_passwordKeyDown : function (key) {
			this.cleanMessage();
			if (key && key.keyCode === 13) {
				focus.focus(dojo.byId(this.id + "Submit"));
				this._onSubmitClick();
			}
		},
		
		/*
			displays a text box's hint text
		*/
		_showTextboxHint : function (/*idx/oneui/form/TextBox*/ textbox) {
			if(textbox && textbox.get("_phspan")) {
				textbox.get("_phspan").style.display = "";
			}
		},
		
		/*
			hides a text box's hint text
		*/
		_hideTextboxHint : function (/*idx/oneui/form/TextBox*/ textbox) {
			if(textbox && textbox.get("_phspan")) {
				textbox.get("_phspan").style.display = "none";
			}
		},
		
		showMessage : function (message) {
			this.cleanMessage();
			var trimmed = (message)? message.replace(/(^\s*)|(\s*$)/g, "") : "";
			this.messageBox = new Message({
				type : "error", 
				title : this.nls.ERROR,
				closable : false,
				collapsed : false,
				showAction : false,
				showRefresh : false,
				showViewDetails : false,
				description : trimmed,
				dateFormat : {
					selector : "time", 
					timePattern : "hh:mm a"}
				}).placeAt(this.id+"Message","last");

			this.inDialog.resize();
		},

		cleanMessage : function () {
			if (this.messageBox) {
				this.messageBox.destroy();
				this.messageBox = undefined;
				this.inDialog.resize();
			}			
		},

		/**
		 * Called when login button pressed Calls user 'onSubmit' method after
		 * trimming fields. Displays error message if fields invalid.
		 * 
		 * @param {Event}
		 *            e
		 */
		_onSubmitClick : function (/*Event*/e) {
			this.cleanMessage();
			
			this.j_username.value = this.loginUserName.getValue();
			this.j_password.value = this.loginPassword.getValue();
			
			localStorage.setItem("loginUser", this.j_username.value);
			localStorage.setItem("loginProduct", this.nls.TITLE);
			
			var dataLoad = function (data) {

				this.loginUserName.setDisabled(false);
				this.loginPassword.setDisabled(false);
				this.loginButton.setDisabled(false);

				if (this.logger.isFinest()) {
					this.logger.finest("Returned Data: "+data, "_onSubmitClick");
				}
				
				if (data) {
					// try to get session ID
					var idstart = data.indexOf("XSS=\"");
					if (idstart > 0) {
						var id = data.substring(idstart+5, data.indexOf("\"",idstart+5));
						localStorage.setItem("loginSession", id);
					}
				}
				
				var start = 0;
				// check data
				if (data.indexOf("ChangePwdAction")>0) {
					// user expired
					this.logger.fine("Check Data: change password", "_onSubmitClick");
					window.location.replace("changepwd.html");
				} else if (data.indexOf("logonForm")>0) {
					// user or password wrong
					// or user is locked
					// can't tell the difference here, because of the message is i18n
					this.logger.fine("Check Data: wrong user or password", "_onSubmitClick");
					var errorMsg = this.nls.INVALID; 
					var foundMsg = data.indexOf('class="validation-error">');
					if (foundMsg>0) {
						start = data.indexOf(">", foundMsg+26)+1;
						errorMsg = data.substring(start, data.indexOf("</td>",start));
					}
					focus.focus(dojo.byId(this.id + "UserName"));
					this.showMessage(errorMsg);
				} else if (data.indexOf("ISCmain")>0) {
					// logged in
					this.logger.fine("Check Data: login OK", "_onSubmitClick");
					this.outDialog.style.visibility = "hidden";
					window.location.replace(this.nextUrl);
				} else if (data.indexOf("loginConflictForm")>0) {
					// other user logged in already,
					// force login
					// find session id first
					this.logger.fine("Check Data: login conflicts", "_onSubmitClick");
					var begin = data.indexOf("XSS=", start) + 4;
					dojoConfig.iscSession = data.substring(begin, data.indexOf("\">", begin));
					
					var loginForm = document.createElement("form");
					loginForm.setAttribute("method", "POST");
					loginForm.setAttribute("action", "/ibm/console/secure/securelogon.do?XSS=" + dojoConfig.iscSecion);
					loginForm.setAttribute("name", "loginConflictForm");
					loginForm.setAttribute("style", "display: none");

					var field1 = document.createElement("input");
					field1.setAttribute("type", "radio");
					field1.setAttribute("name", "action");
					field1.setAttribute("value", "force");
					field1.setAttribute("checked", "checked");

					var field2 = document.createElement("input");
					field2.setAttribute("type", "radio");
					field2.setAttribute("name", "action");
					field2.setAttribute("value", "continue");

					loginForm.appendChild(field1);
					loginForm.appendChild(field2);
					
					var nextUrl = this.nextUrl;
					var llogger = this.logger;
					var xhrArgs = {
						form : loginForm,
						handleAs : "text",
						load : function (data) {
							llogger.fine("Check Data: force logged in", "_onSubmitClick");
							window.location.replace(nextUrl);
						},
						error : function (error) {
							llogger.error("Returned Error(Force login): "+error, "_onSubmitClick");
						}
					};
					dojo.xhrPost(xhrArgs);			
				} else {
					// sth. is very wrong
					// this.showMessage(this.nls.UNKNOWN);
					this.logger.fine("Returned nothing.", "_onSubmitClick");
					window.location.replace(this.nextUrl);
				}

			};
			var dataLoadError = function (error) {
				this.logger.error("Returned Error: "+error, "_onSubmitClick");
				this.loginUserName.setDisabled(false);
				this.loginPassword.setDisabled(false);
				this.loginButton.setDisabled(false);

				focus.focus(dojo.byId(this.id + "UserName"));
				this.showMessage(error);
			};
			var xhrArgs = {
				form : this.loginHiddenForm,
				handleAs : "text",
				load : dojo.hitch(this, dataLoad),
				error : dojo.hitch(this, dataLoadError)
			};
			this.loginUserName.setDisabled(true);
			this.loginPassword.setDisabled(true);
			this.loginButton.setDisabled(true);
			var deferred = dojo.xhrPost(xhrArgs);
		}
	});

});
