require({cache:{
'url:ibm/usmi/widgets/templates/RelatedResourceTemplate.html':"<div class=\"interiorSpacious\">\r\n<!--\r\n\r\nLicensed Materials - Property of IBM\r\n\r\n(C) Copyright IBM Corp. 2012 All Rights Reserved\r\n\r\nUS Government Users Restricted Rights - Use, duplicate or\r\ndisclosure restricted by GSA ADP Schedule Contract with\r\nIBM Corp.\r\n\r\n-->\r\n<div id=\"relatedResourcesTableView\" dojoAttachPoint=\"relatedResourcesTableViewNode\"></div>\r\n</div>"}});
/*
 * Licensed Materials - Property of IBM
 *
 * OCO Source Materials
 *
 * (C) Copyright IBM Corp. 2012, 2013 All Rights Reserved
 *
 * The source code for this program is not published or other-
 * wise divested of its trade secrets, irrespective of what has
 * been deposited with the U.S. Copyright Office.
 */
define("ibm/usmi/widgets/RelatedResourcesTable", [
	"ibm/tivoli/tip/TCTTable",
	"dojo/_base/kernel",
	"dojo/_base/declare",
	"dojo/_base/lang",
	"dijit/_WidgetBase",
	"dijit/_TemplatedMixin",
	"dojo/text!./templates/RelatedResourceTemplate.html",
	"ibm/usmi/widgets/util/ResourceNavigatorDAHelper",
	"ibm/usmi/util/DefaultMessageHandler",
	"ibm/usmi/util/BaseWidget",
	"ibm/usmi/widgets/util/Constants",
	"ibm/usmi/core/utils/Logger",
	"ibm/usmi/widgets/table/DefaultItemsTableView",
	"ibm/usmi/widgets/util/ResourceMenuProviderHelper",
	"dojo/data/ItemFileReadStore",
	"ibm/tivoli/tip/navwidget/dijit/RESTContextMenuProvider",
	"ibm/tivoli/navmodel/Dataset",
	"dojo/topic",
	"dojo/hash",
	"dojo/_base/xhr",
	"dojo/_base/connect",
	"dojo/_base/lang",
	"dijit/registry"
], function (TCTTable, dojo, declare, lang, WidgetBase, TemplatedMixin, template, ResourceNavigatorDAHelper,
		DefaultMessageHandler, BaseWidget, Constants, Logger, DefaultItemsTableView, ResourceMenuProviderHelper,
		ItemFileReadStore, RESTContextMenuProvider, Dataset, topic, hash) {

	return declare([
		WidgetBase,
		TemplatedMixin,
		BaseWidget
	], {
		templateString : template,

		// String to hold relationship to show in table
		relationship : null,
		topicReference : null,
		///////////////////////////////////////////////////////////////////
		// private members
		///////////////////////////////////////////////////////////////////

		// the logger
		_relatedResourceTableLogger : new Logger("ibm.usmi.widgets", "RelatedResourcesTable"),

		// table member variable
		_relatedResourcesTableView : null,

		_dataset : null,
		postCreate : function () {
			this.inherited(arguments);

			// relationship is set on the hash, get the hashparm
			this.relationship = this.getInitArg("relationship");
			if (!this.relationship) {
				var targetInfo = this.getInitArg(Constants.TARGET_INFO);
				if (targetInfo) {
					this.relationship = targetInfo.relationship;
				}
			}

			//sourceToken should be set in basewidget if it was there
			if (!this.sourceToken) {
				var targetInfo2 = this.getInitArg(Constants.TARGET_INFO);
				if (targetInfo2) {
					this.sourceToken = targetInfo2[Constants.SOURCE_TOKEN];
				}
			}
			//TODO: handle error case if we don't have what we need

			// create related resource table
			this.makeTable();
		},
		startup : function () {
			this.inherited(arguments);
			this.topicReference = topic.subscribe(Constants.TOPIC_RETARGET_INFO, lang.hitch(this, this.retargeted));
		},

		//Create the table view for related resources
		makeTable : function () {
			if (this._relatedResourceTableLogger.isFinest()) {
				this._relatedResourceTableLogger.entering("", "Creating Related Resources table.");
			}

			//stacked var statements to appease the formatter. if its on, it will make the line too long
			//and we'll be in trouble
			// create a default context menu provider			
			var helper = new ResourceMenuProviderHelper();
			var defaultActionHelper = new ResourceNavigatorDAHelper(), cmProvider = new RESTContextMenuProvider({
				view : this,
				getMenuItemsCallback : lang.hitch(helper, helper.getMenuItems),
				getMenuCommandCallback : lang.hitch(helper, helper.getMenuCommand)
			});

			this._relatedResourcesTableView = new DefaultItemsTableView({
				id : "relatedResourcesTableView" + this.id,
				cmProvider : cmProvider,
				style : "width:100%; height:100%;",
				daHelper : defaultActionHelper,
				height : "100%"
			}, this.relatedResourcesTableViewNode);

			this._relatedResourcesTableView.startup();

			//Register for selection changes
			dojo.connect(this._relatedResourcesTableView.selection, "onSelectionChanged", dojo
					.hitch(this.selectionHasChanged));

			lang.hitch(this, this.makeDataset());

			if (this._relatedResourceTableLogger.isFinest()) {
				this._relatedResourceTableLogger.exiting("", "Creating Related Resources table.");
			}
		},

		//Create the dataset for the table
		makeDataset : function () {
			// summary:
			//        Create the dataset for the table
			if (this._relatedResourceTableLogger.isFinest()) {
				this._relatedResourceTableLogger.entering("", "Creating Related Resource dataset.");
			}

			var _processDataSet = function (dataset) {
				this._relatedResourcesTableView.setDataset(dataset, null, null);
				dojo.publish(Constants.TOPIC_TASK_TITLE_CHANGE, {
					resource : dataset._dataset.label,
					view : dataset._dataset.labelQualifier
				});
			};
			this._dataset = new Dataset({
				onComplete : lang.hitch(this, _processDataSet),
				onError : function (error, exception, ioArgs) {
					var msgHandler = new DefaultMessageHandler({});
					msgHandler.displayException(exception);
				},
				baseUrl : "/ibm/tivoli/rest",
				provider : "USMI",
				datasource : "",
				dataset : "RELATIONSHIP:" + this.relationship,
				clearCacheOnRefresh : true,
				parameters : {
					sourceToken : this.sourceToken,
					relationship : this.relationship
				},
				defaultProperties : []
			});

			if (this._relatedResourceTableLogger.isFinest()) {
				this._relatedResourceTableLogger.exiting("", "Creating Related Resource dataset.");
			}
		},

		//selection changed callback
		selectionHasChanged : function (selection) {
		// summary:
		//        Called when selection is made in the table
		/*            if (this._relatedResourceTableLogger.isFinest()) {
		                this._relatedResourceTableLogger.info("", "SELECTION CHANGED!! selection = " + selection.getItemIds());
		            } */

		},

		//Destroy the topology canvas (largely so server will get notified to clean itself up)
		destroy : function () {
			// summary:
			//        Clean up any objects the Resource Navigator is hanging onto
			if (this._relatedResourceTableLogger.isFinest()) {
				this._relatedResourceTableLogger.entering("", "destroy");
			}

			this._relatedResourcesTableView.destroyRecursive();
			if (this.topicReference) {
				this.topicReference.remove();
				this.topicReference = null;
			}
			if (this._dataset) {
				this._dataset.destroy(); //destroy old dataset
				this._dataset = null;
			}
			this.inherited(arguments);
			if (this._relatedResourceTableLogger.isFinest()) {
				this._relatedResourceTableLogger.exiting("", "destroy");
			}
		},

		retargeted : function (retargetInfo) {
			if (retargetInfo.taskSelection === "ibm/usmi/widgets/RelatedResourcesTable") {
				if (retargetInfo.relationship && retargetInfo.sourceToken) {
					this.relationship = retargetInfo.relationship;
					this.sourceToken = retargetInfo.sourceToken;
					if (this._dataset) {
						this._dataset.destroy(); //destroy old dataset
					}
					this.makeDataset();
				}
			}
		}
	});
});
