/*
 * Licensed Materials - Property of IBM
 *
 * OCO Source Materials
 *
 * (C) Copyright IBM Corp. 2012, 2013 All Rights Reserved
 *
 * The source code for this program is not published or other-
 * wise divested of its trade secrets, irrespective of what has
 * been deposited with the U.S. Copyright Office.
 */
// Finder TaskDataStore
define("ibm/usmi/widgets/finder/TaskDataStore", [
	"dojo/_base/lang",
	"dojo/_base/declare",
	"ibm/usmi/util/Utils",
	"dojo/i18n!ibm/usmi/nls/frameworkResources",
	"./FinderBaseDataStore"
], function (djLang, declare, Utils, MRI, FinderBaseDataStore) {

	return declare([ FinderBaseDataStore
	], {
		constructor : function (type, cache) {
			this.populateItems(cache);
		},
		populateItems : function () {
			this.inherited(arguments);
		},

		initiateTaskSearch : function (searchString, finderObj) {
			var query = "name:'*" + searchString + "*' OR category:'*" + searchString + "*'";
			Utils.CMTraceTimeDelta("finderTimer", "before initiating search", true);
			var functions = {
				query : {
					complexQuery : query
				},
				queryOptions : {
					ignoreCase : true
				},
				onError : djLang.hitch(finderObj, finderObj.fetchFailed),
				onComplete : djLang.hitch(finderObj, finderObj.doSearch, this, 'special#_none', MRI.MoreTasks,
						this._type, true)
			};
			this._dataStore.fetch(functions);
		},
		destroy : function () {
			this.inherited(arguments);
		}
	});
});
