/*
 * Licensed Materials - Property of IBM
 *
 * OCO Source Materials
 *
 * (C) Copyright IBM Corp. 2012 All Rights Reserved
 *
 * The source code for this program is not published or other-
 * wise divested of its trade secrets, irrespective of what has
 * been deposited with the U.S. Copyright Office.
 */

define("ibm/usmi/widgets/table/_ColumnVisible", [
    "dojo/on",
	"dojo/_base/declare",
	"dijit/_WidgetBase",
	"dijit/registry",
	"dojo/_base/lang",
	"dojoe/tablex/_ColumnVisible"
], function (on, declare, _WidgetBase, registry, lang, ColumnVisible) {
	return declare([
		_WidgetBase,
		ColumnVisible
	], {
		postCreate : function () {
			this.inherited("postCreate", arguments);
			on(this.checkbox, 'change', lang.hitch(this, this.checkChanged));
		},
		setVisible : function (checked) {
			this.checkbox.setChecked(checked);
			//Defect 27350: Safari:In Table, Select All/ Deselect All for config columns popup does not work as expected for safari browser.
			//Anupama -  workaround, adding a fake event
			registry.byId(this.checkbox.id.toString()).set("disabled", true);
			registry.byId(this.checkbox.id.toString()).set("disabled", false);
		},
		checkChanged : function () {
			if (this.columnChooser) {
				this.columnChooser.updatedCheck(this);
			}
		}
	});
});