require({cache:{
'url:idx/form/mobileTemplates/ComboBox.html':"<div id=\"widget_${id}\" class=\"dijitReset dijitInline idxComposite\" \r\n\t><div class=\"idxLabel dijitInline dijitHidden\" dojoAttachPoint=\"labelWrap\"\r\n\t\t><span class=\"idxRequiredIcon\">*&nbsp</span\r\n\t\t><label dojoAttachPoint=\"compLabelNode\"\r\n\t\t></label\r\n\t></div\r\n\t><div class=\"dijitInline idxCompositeField\" dojoAttachPoint=\"fieldWrap\"\r\n\t\t><div class=\"dijitReset idxCompositeHelpContainer\" dojoAttachPoint=\"helpContainer\"\r\n\t\t\t><div class='dijitInline idxHelpIcon'\r\n\t\t\t\t><span class='idxHelpIconAltText'>?</span\r\n\t\t\t></div\r\n\t\t\t><span dojoAttachPoint=\"helpMessage\"></span\r\n\t\t></div\r\n\t\t><div class=\"dijit dijitInline dijitReset dijitInlineTable dijitLeft\" role=\"combobox\" dojoAttachPoint=\"stateNode,oneuiBaseNode,_aroundNode,_popupStateNode\"\r\n\t\t\t><input class='dijitReset idxTextBoxInput' dojoAttachPoint=\"textbox,focusNode,inputNode\" type=\"${type}\" role=\"textbox\" aria-haspopup=\"true\" autocomplete=\"off\" ${!nameAttrSetting}\t/\r\n\t\t\t><input dojoAttachPoint=\"_buttonNode\"  class=\"dijitReset dijitDownArrowButton\" value=\" &#9660;\" type=\"text\" tabIndex=\"-1\" readonly=\"readonly\" role=\"presentation\"\r\n\t\t\t${_buttonInputDisabled}\r\n\t\t/></div\r\n\t\t><div class='dijitReset idxValidationContainer' dojoAttachPoint=\"validationContainer\"\r\n\t\t\t><div class=\"idxValidationIcon dijitInline\"\r\n\t\t\t\t><span class=\"dijitReset idxValidationInner\" tabIndex=\"-1\" readonly=\"readonly\" role=\"presentation\">&#935;</span\r\n\t\t\t></div\r\n\t\t\t><span dojoAttachPoint=\"validationMessage\"></span\r\n\t\t></div\r\n\t></div\r\n></div>"}});
/*
 * Licensed Materials - Property of IBM
 * (C) Copyright IBM Corp. 2010, 2012 All Rights Reserved
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */

define("idx/form/plugins/phone/ComboBoxPlugin", [
	"dojo/_base/declare",
	"dojo/_base/lang", 
	"dojo/aspect",
	"dojo/dom-class",
	"dojo/dom-style",
	"dojo/dom-attr",
	"dojo/on",
	"dojo/touch",
	"dojo/query",
	"./OverlayComboBoxMenu",
	"dojo/text!../../mobileTemplates/ComboBox.html"
], function(declare, lang, aspect, domClass, domStyle, domAttr, on, touch, query, OverlayComboBoxMenu, template){
	
	return declare(null, {
		/**
		 * 
		 */
		baseClass: "idxMobileComboBox",
		/**
		 * 
		 */
		oneuiBaseClass: "dijitTextBox dijitComboBox",
		/**
		 * 
		 */
		templateString: template,
		/**
		 * 
		 * Set the dropDownClass to OverlayComboBoxMenu and create dropDown widget
		 * before the function _startSearch in _AutoCompleteMixin.js
		 * 
		 */
		dropDownClass: OverlayComboBoxMenu,
		/**
		 * 
		 * @param {Object} scope
		 * @param {Object} bShow
		 */
		showHintMessage: function( scope, bShow ){
			var nodeList = query(".dijitPlaceHolder", scope.domNode);
			if ( nodeList.length >0){
				var node = nodeList[0];
				domStyle.set(node, "display", bShow ? "": "none");
			}
		},

		/**
		 * 
		 */
		postCreate: function(scope){
			var self = this;
			if (scope.inputNode){
				touch.press(scope.inputNode, function(){
					if (scope.dropDown) {
						scope.dropDown.hide();
					}
					self.showHintMessage(scope, false);
				});
				
			}
			domAttr.set(scope.focusNode, "readonly", "readonly");
			scope.own(
				on(scope._buttonNode, touch.press, lang.hitch(scope,"_onDropDownMouseDown") ),
				on(scope.focusNode, touch.press, function(){
					domAttr.remove(scope.focusNode, "readonly");
					
				}),
				on(scope.focusNode, "focus", function(){
					self.showHintMessage(scope, false);
				}),
				on(scope.focusNode, "blur",function(){
					domAttr.set(scope.focusNode, "readonly", "readonly");
					if ( !scope.focusNode.value ){
						self.showHintMessage(scope, true);
					}
				})
			);

			aspect.after(scope, "onSearch", lang.hitch(scope, "_openResultList"), true);
		},
		/**
		 * 
		 * @param {Object} message
		 */
		displayMessage: function(scope, message){
			if(message){
				scope.validationMessage.innerHTML = message;
			}
		},
		/**
		 * 
		 */
		closeDropDown: function(scope){
			domClass.remove(scope.helpContainer, "dijitHidden");
			domClass.remove(scope.validationContainer, "dijitHidden");
		},
		
		/**
		 * Set the flag inProcessInput when user input on mobile
		 */
		onInput: function(){
			this.inProcessInput = true;
			this.inherited(arguments);
		},
		/**
		 * 
		 */
		loadDropDown: function(scope){
			scope.inProcessInput = false;
			scope._startSearch(scope.focusNode.value);
		}, 
		/**
		 * 
		 */
		openDropDown: function(scope){
			//
			//	Do not show anything
			//
			
			if ( scope.inProcessInput )
				return;
			domClass.add(scope.helpContainer, "dijitHidden");
			domClass.add(scope.validationContainer, "dijitHidden");
			scope.dropDown.show(scope.dropDown.containerNode, ['above-centered','below-centered','after','before']);
		},
		/**
		 * @param {Object} scope
		 * @param {Object} helpText
		 */
		_setHelpAttr: function(scope, helpText){
			scope._set("help", helpText);
			if(scope.helpContainer){
				domStyle.set(scope.helpContainer, "display", helpText ? "block": "none");
				scope.helpMessage.innerHTML = helpText;
			}
		}
	});
});