require({cache:{
'url:idx/gridx/templates/FilterDialogPane.html':"<form action=\"./\" onsubmit='return false;' data-dojo-attach-event='onsubmit: _onSubmit'\r\n\t><label id=\"${id}_MatchOptionLabel\" for=\"${id}_MatchOptionSelect\">${module.nls.relationMsgFront}</label\r\n\t><select data-dojo-type=\"idx/form/Select\"\r\n\t\tdata-dojo-attach-point='_sltMatch'\r\n\t\tid=\"${id}_MatchOptionSelect\"\r\n\t\taria-labelledby=\"${id}_MatchOptionLabel\"\r\n\t\t><option value=\"all\">${module.nls.relationAll}</option\r\n\t\t><option value=\"any\">${module.nls.relationAny}</option\r\n\t></select\r\n\t><div class=\"gridxFilterRulesLabel\">${module.nls.rules}</div\r\n\t><div class=\"gridxFilterRules\"\r\n\t\tdata-dojo-attach-point='_ruleContainer'\r\n\t></div\r\n\t><input type=\"submit\" value='' tabindex='-1' class=\"dijitOffScreen\" role='presentation' data-dojo-attach-point='submitBtn'\r\n/></form>\r\n"}});
define("idx/gridx/modules/filter/FilterDialogPane", [
	'dojo/_base/declare',
	'dojo/_base/query',
	'dojo/_base/array',
	'dojo/dom-construct',
	'dojo/dom-class',
	'dijit/registry',
	'dijit/_WidgetBase',
	'dijit/_TemplatedMixin',
	'dijit/_WidgetsInTemplateMixin',
	'dojo/text!../../templates/FilterDialogPane.html',
	'./FilterPane'
], function(declare, query, array, domConstruct, domClass, registry,
	_WidgetBase, _TemplatedMixin, _WidgetsInTemplateMixin, template, FilterPane){

	return declare([_WidgetBase, _TemplatedMixin, _WidgetsInTemplateMixin], {
		templateString: template,

		module: null,

		show: function(){
			this.module._filterDialog.show();
			if(!this._ruleContainer.childNodes.length){
				this.addRule();
			}
		},

		clear: function(){
			this.module.confirmToClear();
		},

		getData: function(){
			// summary:
			//	Get filter data.
			return {
				type: this._sltMatch.get('value'),
				conditions: array.map(array.map(this._ruleContainer.childNodes, registry.byNode), function(p){
					return p.getData();
				})
			};
		},

		setData: function(data){
			// summary:
			//	Set filter data.
			var t = this;
			array.forEach(array.map(t._ruleContainer.childNodes, registry.byNode), function(p){
				p.destroyRecursive();
			});
			t._ruleContainer.innerHTML = '';
			if(data && data.conditions.length){
				t._sltMatch.set('value', data.type || 'all');
				array.forEach(data.conditions, function(d){
					t.addRule().setData(d);
				});
			}
		},

		addRule: function(refNode){
			var ac = this._ruleContainer,
				fp = new FilterPane({
					module: this.module
				});
			if(refNode){
				domConstruct.place(fp.domNode, refNode, 'after');
			}else{
				ac.appendChild(fp.domNode);
			}
			fp.startup();
			fp._onColumnChange();
			try{
				fp.tbSingle.focus();//TODO: this doesn't work now.
			}catch(e){}
			this.connect(fp, 'onChange', '_updateButtons');
			this._updateButtons();
			//scroll to bottom when add a rule
			ac.scrollTop = 100000;
			return fp;
		},

		isValid: function(){
			return array.every(array.map(this._ruleContainer.childNodes, registry.byNode), function(p){
				var type = p._getType(),
					valueBox = p._getValueBox();
				if(/Range/.test(type)){
					return valueBox.start.isValid() && valueBox.end.isValid();
				}else if(valueBox.isValid){
					return valueBox.isValid();
				}
			});
		},

		_onSubmit: function(){
			if(this.isValid()){
				this.module._filterDialog.hide();
				this.module.applyFilter(this.getData());
			}
			return false;
		},

		_updateButtons: function(){
			var t = this,
				children = t._ruleContainer.childNodes,
				c = t.module.arg('maxRuleCount'),
				singleRule = children.length === 1,
				maxRule = children.length >= c && c > 0;
			//toggle filter button disable
			t._btnFilter.set('disabled', array.some(array.map(children, function(c){
				var p = registry.byNode(c);
				p._removeBtn.set('disabled', singleRule);
				p._addBtn.set('disabled', maxRule);
				return p;
			}), function(p){
				return !p.getData();
			}));
			//toggle add rule button disable
			t._btnClear.set('disabled', !t.module.filterData);
		}
	});
});
