define("idx/multichannel", ["dojo/_base/kernel", // kernel.isAsync
	"dojo/_base/declare", // declare
	"dojo/_base/lang", // lang.mixin lang.hitch
	"dojo/_base/array", // array.forEach array.indexOf array.map
	"dojo/_base/sniff",
	"dojo/dom-class",
	"dojox/mobile/common",
	"dojox/mobile/compat"
], function(kernel, declare, lang, array, has, domClass, common, compat){
	
	//TODO add more common initial logic
	var idxMultichannel = declare("idx/multichannel", [], {
		themeMap: {
			"Holodark":		"holodark",
			"Android 3":	"holodark",
			"Android 4":	"holodark",
			"Android":		"android",
			"BlackBerry": 	"blackberry",
			"BB10":			"blackberry",
			"iPhone":		"iphone",
			"iPad":			"ipad",
			"MSIE 10":		"windows",
			"WindowsPhone":	"windows",
			"Custom":		"custom"
		},
		themes: null,
		platform: "",//"tablet", "phone", "desktop"
		_detectPlatform: function(){
			var dua = navigator.userAgent;
			var themes = []; //"tablet", "phone", "mobile", ......
			if(dua.match(/(iPhone|iPod|iPad|Android|Holodark|BlackBerry|BB10|WindowsPhone)/)){
				themes.push("mobile");
				if((dua.indexOf("iPod")>=0) || (dua.indexOf("iPhone")>=0) || (dua.indexOf("WindowsPhone")>=0)){
					this.platform = "phone";
				} else if (dua.indexOf("iPad")>=0) {
					this.platform = "tablet";
				}
				
				// Should be actived if we have to support OS specified theme
				for(var key in this.themeMap){
					if(dua.indexOf(key) > -1){
						var theme = this.themeMap[key];
						themes.push(theme);
					}
				}
				
			}else{
				themes.push("desktop");
				this.platform = "desktop";
			}
			//For IE10
			if (dua.match(/IEMobile\/10\.0/)) {
				var msViewportStyle = document.createElement("style");
				msViewportStyle.appendChild(document.createTextNode("@-ms-viewport{width:auto!important}"));
				document.getElementsByTagName("head")[0].appendChild(msViewportStyle);
			}
			this.themes = themes;
		},
		getRuntimePlatform: function(){
			if(!this.platform){this._detectPlatform();}
			return this.platform;
		},
		updateGlobalTheme: function(themes){
			if((!themes) || themes.length == 0){
				themes = this.themes;
			}
			var doc = document.documentElement;
			array.map(themes, function(theme){
				domClass.add(doc, theme + "Platform");
			})
		}
	});
	idxMultichannel.getRuntimePlatform = function(){
		if(!idxMultichannel._masterMC){
			idxMultichannel._masterMC = new idxMultichannel();
		}
		return idxMultichannel._masterMC.getRuntimePlatform();
	};
	idxMultichannel.updateGlobalTheme = function(theme){
		if(!idxMultichannel._masterMC){
			idxMultichannel._masterMC = new idxMultichannel();
		}
		idxMultichannel._masterMC.updateGlobalTheme(theme);
	}
	return idxMultichannel;
});
