define("idx/templateLoad", ["dojo/has"],function(has){
	var hasMobile = has("mobile"),
		hasDesktop = has("desktop"),
		widgetTemplatesMap = {
			"idx/form/TextBox": {
				"mobile": "dojo/text!./mobileTemplates/TextBox.html",
				"desktop": "dojo/text!./templates/TextBox.html"
			}
		}
		
	//"dojo/has!idx_form_TextBox-desktop?dojo/text!./templates/TextBox.html"  // desktop widget, load the template
	//	+ ":idx_form_TextBox-mobile?"										// mobile widget, don't load desktop template
	//	+ ":desktop?dojo/text!./templates/TextBox.html"						// global desktop platform, load template
	//	+ ":mobile?"														// global mobile platform, don't load
	//	+ ":dojo/text!./templates/TextBox.html", 
	
	return function(widgetClass, platform){
			var hasWidgetForDesktop = has(widgetClass.replace(/\//g, "_") + "_desktop"),
				hasWidgetForMobile = has(widgetClass.replace(/\//g, "_") + "_mobile"),
				desktopTemplate = widgetTemplatesMap[widgetClass][platform];
				
			return 
				hasWidgetForDesktop ? 
					desktopTemplate : 
					(hasWidgetForMobile ? 
						"" : 
						(hasDesktop ? 
							widgetTemplatesMap : 
							(hasMobile ? "" : desktopTemplate)
						)
					);
			
		};
})
